{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      API - ADVANCED PROGRAMMING INTERFACE


  Programmed by:      Rozsnyo Daniel

  Version:            1.00.031
  Release date:       2001-03-25
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

Unit API;

Interface

 Uses Types;

 Type      TLongSearchRec = record
                              Attr             : LongInt;
                              Creation         : Comp;
                              Lastaccess       : Comp;
                              LastModification : Comp;
                              HighFileSize     : LongInt;
                              LowFileSize      : LongInt;
                              Reserved         : Comp;
                              Name             : Array[0..259] of Char;
                              ShortName        : Array[0..13] of Char;
                              Handle           : Word;
                            end;

           Pchar               = ^String;

 Const     LongFaReadOnly      =  $01;
           LongFaHidden        =  $02;
           LongFaSysFile       =  $04;
           LongFaVolumeID      =  $08;
           LongFaDirectory     =  $10;
           LongFaArchive       =  $20;
           LongFaAnyFile       =  $3F;

           IDE_TIMEOUT         =  100000;

 const     NoLFN               =  true;

 Var       LoggedPerson        : record
                                   loggedin  : boolean;
                                   loginname : string;
                                   logintime : TDateTime;
                                   loginpath : string;
                                 end;

 { disk drives functions }

 Procedure API_LoadDiskTypes;
 Function  API_GetNumberOfDrives:byte;
 Function  API_GetTypeOfDrive(c:char):byte;
 Function  API_GetLongNameOfDrive(c:char):string;

 Function  API_GetNumberOfFixedDisks:integer;
 Procedure API_GetBIOSDiskData(disk:byte;var data:TBiosDiskData);
 Procedure API_GetIDEDiskData (disk:byte;var data:TIDEDiskData);

 { process functions }

 Function  API_GetProcessID(class:string):word;
 Function  API_GetProcessCount(class:string):word;

 { general purpose }

 Function  Minim(a,b:integer):integer;
 Function  Maxim(a,b:integer):integer;

 { long filenames }

 Function  API_LongFindFirst(filespec:string;attr:word;var S:TLongSearchRec):integer;
 Function  API_LongFindNext(var S:TLongSearchRec):integer;
 Function  API_LongFindClose(var S:TLongSearchRec):integer;
 Function  API_GetLongNameOf(shortname:string):string;
 Function  API_MakeLongName(shortname:string):string;
 Function  AsciiZtoString(s:Pchar):string;

 { get paths }

 Function  API_GetAppDir(appname:string):string;
 Function  API_GetCurrentDir:string;
 Function  API_GetFile(s:string):string;
 Function  API_GetDir(s:string):string;

 { time and date functions }

 Procedure API_GetSystemTime(var t:TDateTime);

 { other functions }

 Procedure API_GetProcessorData(var Pdata:TProcessorData);
 Function  API_GetProcessorIDstring : string;


Implementation
 Uses      Dos,
           Convert,
           SysCalls,
           DrvTypes;


 Var       DRIVETYPES : array['A'..'Z'] of byte;
           DRIVENUM   : byte;

 Function  API_GetNumberOfFixedDisks:integer;
           begin
             API_GetNumberOfFixedDisks:=mem[Seg0040:$75]
           end;

 Procedure API_GetBIOSDiskData(disk:byte;var data:TBiosDiskData);
           var c,h,s : word;
           begin
             asm
                     mov ah,08h
                     mov dl,disk
                     or  dl,80h
                     int 13h
                     jc  @err
                     mov al,dh
                     xor ah,ah
                     inc ax
                     mov word ptr h,ax
                     mov ax,cx
                     and ax,$003F
                     mov word ptr s,ax
                     mov al,ch
                     mov ah,cl
                     mov cl,6
                     shr ah,cl
                     mov word ptr c,ax
                     jmp @OK
               @ERR: mov word ptr c,0
                     mov word ptr h,0
                     mov word ptr s,0
               @OK:
             end;
             data.c:=c;
             data.h:=h;
             data.s:=s;
           end;

 Procedure API_GetIDEDiskData(disk:byte;var data:TIDEDiskData);
           var timeout  : longint;
               oval     : byte;
               DiskData : array[0..255] of word;
               i        : integer;
               adr      : word;

           function GetStr(a,b : integer):string;
                    var r : string;
                        i : integer;
                    begin
                      r:='';
                      for i:=a to b do
                          r:=r+chr(diskdata[i] shr 008)+
                               chr(diskdata[i] and $FF);
                      while (r[0]>#0) and
                            (r[ord(r[0])]=' ') do dec(r[0]);
                      GetStr:=r;
                    end;

           begin
             data.sn   :='';
             data.model:='';
             data.rev  :='';

             adr:=$1F0;

             if (disk=2) or (disk=3) then
                begin
                  dec(disk,2);
                  adr:=$170;
                end;

             { wait to READY controller }
             timeout:=IDE_TIMEOUT;
             while (Port[Adr+7]<>$50) and
                   (timeout>0) do dec(timeout);
             if timeout=0 then exit;

             { select disk }
             if disk=0 then oval:=$A0 else
             if disk=1 then oval:=$B0 else exit;
             Port[Adr+6]:=oval;

             { get info }
             Port[Adr+7]:=$EC;

             timeout:=IDE_TIMEOUT;
             while (Port[Adr+7]<>$58) and
                   (timeout>0) do dec(timeout);
             if timeout=0 then exit;

             { read data }
             for i:=0 to 255 do DiskData[i]:=PortW[Adr];

             data.model:=GetStr(27,46);
             data.sn   :=GetStr(10,19);
             data.rev  :=GetStr(23,26);

           end;

 Function  API_GetProcessorIDstring : string;
           var procID : string[12];
           begin
             asm
               db 066h
               xor ax,ax
               db 00Fh
               db 0A2h
               db 066h
               mov word ptr [procID+1],bx
               db 066h
               mov word ptr [procID+5],dx
               db 066h
               mov word ptr [procID+9],cx
               mov al,12
               mov byte ptr [procID+0],al
             end;
             API_GetProcessorIDstring:=procID;
           end;

 Procedure API_GetProcessorData(var Pdata:TProcessorData);
           var _eax,_ebx       : longint;
               _ecx,_edx       : longint;
               i               : integer;
           begin
             asm
               db 066h
               xor ax,ax
               db 00Fh
               db 0A2h
               db 066h
               mov word ptr [_eax],ax
             end;
             Pdata.Pages:=_eax;
             asm
               db 066h
               xor ax,ax
               mov al,1
               db 00Fh
               db 0A2h
               db 066h
               mov word ptr [_eax],ax
               db 066h
               mov word ptr [_ebx],bx
               db 066h
               mov word ptr [_ecx],cx
               db 066h
               mov word ptr [_edx],dx
             end;
             Pdata.Eax:=_eax;
             Pdata.Ebx:=_ebx;
             Pdata.Ecx:=_ecx;
             Pdata.Edx:=_edx;
             With Pdata do
              begin
                Family:=(EAX shr 8) and $F;
                Model :=(EAX shr 4) and $F;
                ID    :=EAX and $F;
                case (EAX shr 12) and $3 of
                  0 : Class:=prcls_OEM;
                  1 : Class:=prcls_OverDrive;
                  2 : Class:=prcls_Dual;
                  3 : Class:=prcls_Reserved;
                end;

                Brand:=EBX and $FF;

                FPU  :=((EDX shr  0)and 1)=1;
                VME  :=((EDX shr  1)and 1)=1;
                DE   :=((EDX shr  2)and 1)=1;
                PSE  :=((EDX shr  3)and 1)=1;

                TSC  :=((EDX shr  4)and 1)=1;
                MSR  :=((EDX shr  5)and 1)=1;
                PAE  :=((EDX shr  6)and 1)=1;
                MCE  :=((EDX shr  7)and 1)=1;

                CX8  :=((EDX shr  8)and 1)=1;
                APIC :=((EDX shr  9)and 1)=1;
                    {:=((EDX shr 10)and 1)=1;}
                SEP  :=((EDX shr 11)and 1)=1;

                MTRR :=((EDX shr 12)and 1)=1;
                PGE  :=((EDX shr 13)and 1)=1;
                MCA  :=((EDX shr 14)and 1)=1;
                CMOV :=((EDX shr 15)and 1)=1;

                FGPAT:=((EDX shr 16)and 1)=1;
                PSE36:=((EDX shr 17)and 1)=1;
                PSN  :=((EDX shr 18)and 1)=1;
                CLFSH:=((EDX shr 19)and 1)=1;

                    {:=((EDX shr 20)and 1)=1;}
                DS   :=((EDX shr 21)and 1)=1;
                ACPI :=((EDX shr 22)and 1)=1;
                MMX  :=((EDX shr 23)and 1)=1;

                FXSR :=((EDX shr 24)and 1)=1;
                SSE  :=((EDX shr 25)and 1)=1;
                SSE2 :=((EDX shr 26)and 1)=1;
                SS   :=((EDX shr 27)and 1)=1;

                    {:=((EDX shr 28)and 1)=1;}
                TM   :=((EDX shr 29)and 1)=1;

                if pages>1 then
                   begin
                     asm
                       db 066h
                       xor ax,ax
                       mov al,2
                       db 00Fh
                       db 0A2h
                       db 066h
                       mov word ptr [_eax],ax
                       db 066h
                       mov word ptr [_ebx],bx
                       db 066h
                       mov word ptr [_ecx],cx
                       db 066h
                       mov word ptr [_edx],dx
                     end;
                     eax:=_eax;
                     ebx:=_ebx;
                     ecx:=_ecx;
                     edx:=_edx;
                     cache[ 0]:=(eax shr  0) and $FF;
                     cache[ 1]:=(eax shr  8) and $FF;
                     cache[ 2]:=(eax shr 16) and $FF;
                     cache[ 3]:=(eax shr 24) and $FF;
                     cache[ 4]:=(ebx shr  0) and $FF;
                     cache[ 5]:=(ebx shr  8) and $FF;
                     cache[ 6]:=(ebx shr 16) and $FF;
                     cache[ 7]:=(ebx shr 24) and $FF;
                     cache[ 8]:=(ecx shr  0) and $FF;
                     cache[ 9]:=(ecx shr  8) and $FF;
                     cache[10]:=(ecx shr 16) and $FF;
                     cache[11]:=(ecx shr 24) and $FF;
                     cache[12]:=(edx shr  0) and $FF;
                     cache[13]:=(edx shr  8) and $FF;
                     cache[14]:=(edx shr 16) and $FF;
                     cache[15]:=(edx shr 24) and $FF;
                   end;

                if (pages>=3) and psn then
                   begin
                     asm
                       db 066h
                       xor ax,ax
                       mov al,3
                       db 00Fh
                       db 0A2h
                       db 066h
                       mov word ptr [_eax],ax
                       db 066h
                       mov word ptr [_ebx],bx
                       db 066h
                       mov word ptr [_ecx],cx
                       db 066h
                       mov word ptr [_edx],dx
                     end;
                     eax:=_eax;
                     ebx:=_ebx;
                     ecx:=_ecx;
                     edx:=_edx;
                     serial:=ashex(edx shr 16)
                            +ashex(edx and $FFFF)
                            +ashex(ecx shr 16)
                            +ashex(ecx and $FFFF);
                   end else serial:='<no serial number>';

              end;
           end;

 Procedure API_LoadDiskTypes;
           var i : char;
           begin
             drivenum:=0;
             for i:='A' to 'Z' do
                 begin
                   drivetypes[i]:=drivetype(i);
                   if drivetypes[i]<>dtNone then inc(drivenum);
                 end;
           end;

 Function  API_GetNumberOfDrives:byte;
           begin
             API_GetNumberOfDrives:=drivenum;
           end;

 Function  API_GetTypeOfDrive(c:char):byte;
           begin
             API_GetTypeOfDrive:=drivetypes[c];
           end;

 Function  API_GetLongNameOfDrive(c:char):string;
           var s:string;
           begin
             s:=upcase(c)+': ';
             case drivetypes[c] of
               dtNone          : s:='';
               dtSubsted       : s:=s+'[subst]';
               dtAssigned      : s:=s+'[assign]';
               dtPhantom       : s:=s+'[phantom]';
               dtFloppy525DD   : s:=s+'[5.25" - 360 KB]';
               dtFloppy525HD   : s:=s+'[5.25" - 1.2 MB]';
               dtFloppy35DD    : s:=s+'[3.5" - 720 KB]';
               dtFloppy35HD    : s:=s+'[3.5" - 1.44 MB]';
               dtFloppy35ED    : s:=s+'[3.5" - 2.88 MB]';
               dtOptical       : s:=s+'[optical]';
               dtTape          : s:=s+'[streamer]';
               dtRemovable     : s:=s+'[removable]';
               dtFixed         : s:=s+'[fixed]';
               dtNetwork       : s:=s+'[network]';
               dtCDrom         : s:=s+'[cd-rom]';
               dtRAMdrive      : s:=s+'[ramdrive]';
               dtPlaceHolder   : s:=s+'[unknown]';
               dtError         :;
               else s:=s+'???';
             end;
             API_GetLongNameOfDrive:=s;
           end;

 Function  API_GetProcessID(class:string):word;
           var i : word;
           begin
             for i:=0 to kerneldata.numofprocesses-1 do
                 if (class=kerneldata.processdata[i].name) and
                    ((kerneldata.processdata[i].flags and PROC_DEAD)=0)
                    then begin
                           API_GetProcessID:=kerneldata.processdata[i].ID;
                           exit;
                         end;
             API_GetProcessID:=$FFFF;
           end;

 Function  API_GetProcessCount(class:string):word;
           var i : word;
               n : word;
           begin
             n:=0;
             for i:=0 to kerneldata.numofprocesses-1 do
                 if (class=kerneldata.processdata[i].name) and
                    ((kerneldata.processdata[i].flags and PROC_DEAD)=0)
                    then begin
                           inc(n);
                         end;
             API_GetProcessCount:=n;
           end;

 Function  Minim(a,b:integer):integer;assembler;
           asm
             mov ax,a
             cmp ax,b
             jl @K
             mov ax,b
             @K:
           end;

 Function  Maxim(a,b:integer):integer;assembler;
           asm
             mov ax,a
             cmp ax,b
             jg @K
             mov ax,b
             @K:
           end;

 Function  AsciiZtoString(s:pchar):string;
           var i : integer;
               r : string;
           begin
             i:=0;
             r:='';
             while (i<255) and
                   (s^[i]<>#00) do
                   begin
                     r:=r+s^[i];
                     inc(i);
                   end;
             AsciiZtoString:=r;
           end;

           {
              podobne jako findfist ale pouziva sa takto:

              var
                res : integer;
              begin
                res:=ffirst('*.*',Anyfile,sr)
                while res=0 do begin
                                 asciiztostring(sr.name)
                                 res:=fnext(sr)
                               end;
              end;

           }

 Function  API_LongFindFirst( filespec:string;
                              attr:word;
                              var S:TLongSearchRec):integer;
           Begin
             FileSpec := FileSpec + #0;
             S.Attr := Attr;
             asm
               push ds
               push ss
               pop ds
               lea dx,filespec+1
               les di,S
               mov ax,$714e
               mov cx,attr
               mov si,0
               int $21
               les di,S
               mov word ptr es:[di+TLongSearchRec.handle], ax
               jc @1
               xor ax,ax
             @1:
               mov @result,ax
               pop ds
             end;
           end;

 Function  API_LongFindNext(var S:TLongSearchRec):integer;
           begin
             asm
               mov ax,$714f
               mov si,0
               les di,S
               mov bx,word ptr es:[di+TLongSearchRec.Handle]
               int $21
               jc @1
               xor ax,ax
             @1:
               mov @result,ax
             end;
           end;

 Function  API_LongFindClose(var S:TLongSearchRec):integer;
           begin
             asm
               mov ax,$71a1
               les di,S
               mov bx,word ptr es:[di+TLongSearchRec.Handle]
               int $21
               jc @1
               xor ax,ax
             @1:
               mov @result,ax
             end;
           end;

 Function  API_GetLongNameOf(shortname:string):string;
           var S : TLongSearchRec;
               r : integer;
               l : string;
           Begin
             r:=API_LongFindFirst(shortname,LongfaAnyfile-LongfaVolumeID,S);
             if r=0 then
                if S.Name[0]<>#0
                   then l:=AsciiZtoString(addr(S.Name))
                   else l:=AsciiZtoString(addr(S.ShortName));
             API_GetLongNameOf:=L;
             API_LongFindClose(S);
           end;

 Function  API_MakeLongName(shortname:string):string;
           var r : string;
               s : string;
               i : integer;
           Begin
             if noLFN then
                begin
                  api_makelongname:=shortname;
                  exit;
                end;
             if copy(shortname,2,2)=':\' then
                begin
                  { disk drive - full path}
                  r:=copy(shortname,1,3);
                  r[1]:=UpCase(r[1]);
                  s:=r;
                  i:=4;
                end else
                begin
                  { ???, may be relative path}
                  r:='';
                  s:='';
                  i:=1;
                end;
             while length(s)<length(shortname) do
                   begin
                     while (shortname[i]<>'\') and
                           (i<=length(shortname)) do
                           begin
                             s:=s+shortname[i];
                             inc(i);
                           end;
                     r:=r+API_GetLongNameOf(s);
                     if shortname<>(s+'\') then
                        begin
                          r:=r+'\';
                          inc(i);
                          s:=s+'\';
                        end else break;
                   end;
             API_MakeLongName:=r;
           end;

 Function  API_GetCurrentDir:string;
           var s:string;
           begin
             GetDir(0,s);
             API_GetCurrentDir:=s;
           end;

 Function  API_GetAppDir(appname:string):string;
           begin
             API_GetAppDir:='appdata\'+appname+'\';
           end;

 Function  API_GetDir(s:string):string;
           var r:string;
           begin
             r:='';

             {
               Current directory and drive (System 2001 Root)
             }
             if s='current'
                then r:=API_GetCurrentDir;

             {
               universal user's directory (user's root)
             }
             if s='user'
                then r:='users\'+loggedperson.loginpath;

             {
               universal database directory
             }
             if s='database'
                then r:='users\'+loggedperson.loginpath+'DataBase';

             {
               Open dialog
             }
             if s='docs'
                then r:='users\'+loggedperson.loginpath+'MyDocs';
             if s='favorite'
                then r:='users\'+loggedperson.loginpath+'Favorite';
             if s='recent'
                then r:='users\'+loggedperson.loginpath+'Recent';

             {
               Convert to LongFileNames
             }
             API_GetDir:=API_MakeLongName(r);
           end;

 Function  API_GetFile(s:string):string;
           var r : string;
           begin
             r:='';

             {
               APPLication SETtingS
               ----        ---    -
             }
             if s='applsets' then r:=API_GetDir('user')+'\applsets.ini';

             API_GetFile:=r;

           end;

 Procedure API_GetSystemTime(var t:TDateTime);
           var w1 : word;
               w2 : word;
               w3 : word;
               w4 : word;
           begin
             GetDate(w1,w2,w3,w4);
             t.year      := w1;
             t.month     := w2;
             t.day       := w3;
             t.dayofweek := w4;
             GetTime(w1,w2,w3,w4);
             t.hrs       := w1;
             t.min       := w2;
             t.sec       := w3;
             t.hos       := w4;
           end;

 begin
 end.
