
{

  System 2001 v.6 A
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      BMP HANDLING


  Programmed by:      Rozsnyo Daniel

  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

unit bmp;


interface
  uses types;

  Const
         BmpDirect       = 0;
         BmpMemManBuffer = 1;

  var    BmpShowType : byte;

  type   BmpFileHeader = record
                           BmpType  : array[0..1] of char;
                                                { type, must be BM      }
                           FileSize : longint;  { size of the file in B }
                           Reserv1  : word;     { must be set to zero   }
                           Reserv2  : word;     { must be set to zero   }
                           DataOfs  : longint;  { offset of data values }
                           Size     : longint;  { header size in Byte   }
                           Width    : longint;  { width in pixels       }
                           Height   : longint;  { height in pixels      }
                           Planes   : word;     { must be 1             }
                           BitCount : word;     { num. of bits 1,4,8,24 }
                           Compress : longint;  { 0 = uncompressed      }
                           ImgSize  : longint;  { 0 or Size of image    }
                           Xpix2met : longint;  { X pixels on 1 meter   }
                           Ypix2met : longint;  { Y pixels on 1 meter   }
                           ColorUsd : longint;  { colors really used    }
                           ColorImp : longint;  { 0 = all colors are imp}
                         end;

         BmpPalette    = array[0..255] of record
                                            blue     : byte;
                                            green    : byte;
                                            red      : byte;
                                            reserved : byte;
                                          end;

         PBmpPalette   = ^BMPpalette;

         BmpFile       = object
                           filename   : string;
                           filehandle : file;
                           opened     : boolean;
                           size       : Tpoint;
                           dataoffset : longint;
                           bitperpixel: byte;
                           colors     : byte;
                           filesize   : longint;
                           linesize   : longint;
                           actualpos  : longint;
                           palettemem : boolean;
                           palette    : PBmpPalette;
                           palettesize: integer;
                           lastline   : integer;
                           constructor init;
                           procedure   openfile(fn:string);
                           procedure   open;
                           procedure   close;
                           function    readline( y : longint;
                                                 a : PRGBColorArr):boolean;
                           function    readlineXL( x,
                                                   y,
                                                   l : longint;
                                                   a : PRGBColorArr):boolean;
                           function    readline24( y : longint;
                                                   a : PRGBColorArr):boolean;
                           function    readline24xl( x,
                                                     y,
                                                     l : longint;
                                                     a : PRGBColorArr):boolean;
                           destructor  done;
                         end;

         PBmpfile      = ^BmpFile;

  function  getbmpdata(fn:string;var a:BmpFileHeader):boolean;
  function  getbmppalette(fn:string;var p:BmpPalette):boolean;
  {function  showbmp(x,y:integer;fn:string):boolean;}

  procedure savescreenshot;

implementation
  {uses advmm;}

  procedure putline(x,y:integer;w:word;a:PRGBColorArr);
            begin
            end;

  function  bmpfile.readline(y:longint;a:PRGBColorArr):boolean;
            var no:longint;
            begin
              readline:=false;
              no:=dataoffset+linesize*((size.y-1)-y);
              if no<>actualpos then
                 begin
                   {$I-}
                   seek(filehandle,no);
                   {$I+}
                   if ioresult<>0 then exit;
                   actualpos:=no;
                 end;
              case bitperpixel of
                24 : begin
                       {$I-}
                       blockread(filehandle,a^,size.x*3);
                       {$I+}
                       readline:=ioresult=0;
                     end;
                 8 : begin
                       {$I-}
                       blockread(filehandle,a^,size.x);
                       {$I+}
                       readline:=ioresult=0;
                     end;
                 4 : ;
                 1 : ;
              end;
              lastline:=y;
              readline:=true;
            end;

  function  bmpfile.readlineXL(x,y,l:longint;a:PRGBColorArr):boolean;
            var no:longint;
            begin
              readlineXL:=false;
              if l<1 then exit;
              no:=dataoffset+linesize*((size.y-1)-y)+(x*bitperpixel div 8);
              if no<>actualpos then
                 begin
                   {$I-}
                   seek(filehandle,no);
                   {$I+}
                   if ioresult<>0 then exit;
                   actualpos:=no;
                 end;
              case bitperpixel of
                24 : begin
                       {$I-}
                       blockread(filehandle,a^,l*3);
                       {$I+}
                       readlineXL:=ioresult=0;
                     end;
                 8 : begin
                       {$I-}
                       blockread(filehandle,a^,l);
                       {$I+}
                       readlineXL:=ioresult=0;
                     end;
              end;
              lastline:=y;
            end;

  function  bmpfile.readline24(y:longint;a:PRGBColorArr):boolean;
            type bytearray = array[0..2047] of byte;
            var no : longint;
                b  : ^bytearray;
                su : boolean;
                i  : integer;
                n  : byte;
            begin
              readline24:=false;
              no:=dataoffset+linesize*((size.y-1)-y);
              if no<>actualpos then
                 begin
                   {$I-}
                   seek(filehandle,no);
                   {$I+}
                   if ioresult<>0 then exit;
                   actualpos:=no;
                 end;
              case bitperpixel of
                24 : begin
                       {$I-}
                       blockread(filehandle,a^,size.x*3);
                       {$I+}
                       su:=ioresult=0;
                     end;
                 8 : begin
                       getmem(b,linesize);
                       {$I-}
                       blockread(filehandle,b^,linesize);
                       {$I+}
                       su:=ioresult=0;
                       if su then
                          begin
                            for i:=0 to size.x-1 do
                                begin
                                  a^[i].r:=palette^[b^[i]].red;
                                  a^[i].g:=palette^[b^[i]].green;
                                  a^[i].b:=palette^[b^[i]].blue;
                                end;
                          end;
                       freemem(b,linesize);
                     end;
                 4 : begin
                       getmem(b,linesize);
                       {$I-}
                       blockread(filehandle,b^,linesize);
                       {$I+}
                       su:=ioresult=0;
                       if su then
                          begin
                            for i:=0 to size.x-1 do
                                begin
                                  if (i mod 2)=0
                                     then n:=b^[i div 2] shr 4
                                     else n:=b^[i div 2] and 15;
                                  a^[i].r:=palette^[n].red;
                                  a^[i].g:=palette^[n].green;
                                  a^[i].b:=palette^[n].blue;
                                end;
                          end;
                       freemem(b,linesize);
                     end;
                 1 : begin
                       getmem(b,linesize);
                       {$I-}
                       blockread(filehandle,b^,linesize);
                       {$I+}
                       su:=ioresult=0;
                       if su then
                          begin
                            for i:=0 to size.x-1 do
                                begin
                                  n:=b^[i div 8];
                                  n:=ord((n and (128 shr (i mod 8)))>0);
                                  a^[i].r:=palette^[n].red;
                                  a^[i].g:=palette^[n].green;
                                  a^[i].b:=palette^[n].blue;
                                end;
                          end;
                       freemem(b,linesize);
                     end;
              end;
              readline24:=su;
              lastline:=y;
            end;

  function  bmpfile.readline24xl(x,y,l:longint;a:PRGBColorArr):boolean;
            type bytearray = array[0..2047] of byte;
            var no : longint;
                b  : ^bytearray;
                su : boolean;
                i  : integer;
                n  : byte;
            begin
              readline24xl:=false;
              if l<1 then exit;
              no:=dataoffset+linesize*((size.y-1)-y)+(x*bitperpixel div 8);
              if no<>actualpos then
                 begin
                   {$I-}
                   seek(filehandle,no);
                   {$I+}
                   if ioresult<>0 then exit;
                   actualpos:=no;
                 end;
              case bitperpixel of
                24 : begin
                       {$I-}
                       blockread(filehandle,a^,l*3);
                       {$I+}
                       su:=ioresult=0;
                     end;
                 8 : begin
                       getmem(b,l);
                       {$I-}
                       blockread(filehandle,b^,l);
                       {$I+}
                       su:=ioresult=0;
                       if su then
                          begin
                            for i:=0 to size.x-1 do
                                begin
                                  a^[i].r:=palette^[b^[i]].red;
                                  a^[i].g:=palette^[b^[i]].green;
                                  a^[i].b:=palette^[b^[i]].blue;
                                end;
                          end;
                       freemem(b,l);
                     end;
              end;
              readline24xl:=su;
              lastline:=y;
            end;

  procedure bmpfile.openfile(fn:string);
            begin
              filename:=fn;
              open;
            end;

  procedure bmpfile.open;
            var bmfh:bmpfileheader;
            begin
              if opened then exit;
              if filename='' then exit;
              assign(filehandle,filename);
              {$I-}
              reset(filehandle,1);
              {$I+}
              opened:=IOresult=0;
              if opened then
                 begin
                   {$I-}
                   blockread(filehandle,bmfh,sizeof(bmpfileheader));
                   {$I+}
                   if ioresult=0           then
                      if bmfh.bmptype='BM' then
                      if bmfh.compress=0   then
                         begin
                           actualpos   := bmfh.dataofs;
                           size.x      := bmfh.width;
                           size.y      := bmfh.height;
                           dataoffset  := bmfh.dataofs;
                           bitperpixel := bmfh.bitcount;
                           colors      := bmfh.colorusd;
                           filesize    := bmfh.filesize;
                           linesize    := (filesize-dataoffset) div size.y;
                           lastline    := 0;
                           if (bitperpixel>0) and
                              (bitperpixel<9) then
                              begin
                                palettesize:=4*(1 shl bitperpixel);
                                getmem(palette,palettesize);
                                palettemem:=true;
                                {$I-}
                                blockread( filehandle,
                                           palette^,
                                           palettesize);
                                {$I+}
                              end;
                           {$I-}
                           seek(filehandle,bmfh.dataofs);
                           {$I+}
                         end;
                 end;
            end;

  procedure bmpfile.close;
            begin
              if opened then system.close(filehandle);
            end;

  destructor bmpfile.done;
             begin
               if palettemem then
                  begin
                    freemem(palette,palettesize);
                    palettemem:=false;
                  end;
               close;
             end;

  constructor bmpfile.init;
              begin
                opened:=false;
                filename:='';
                size.x:=0;
                size.y:=0;
                palettemem:=false;
              end;

{
  function  showbmp(x,y:integer;fn:string):boolean;
            var b : bmpfile;
                p : PRGBColorArr;
                l : integer;
                ok: boolean;
                mb: Tmemoryblock;
                mw: longint;
            label JumpThere;
            begin
              showbmp:=false;
              ok:=true;
              b.init;
              b.openfile(fn);
              if b.opened then
                 if b.size.x>0 then
                 begin
                   if maxavail>=(b.size.x*3+4) then
                      begin
                        getmem(p,b.size.x*3+4);
                        case bmpshowtype of
                          BmpDirect :
                            begin
                             JumpThere:
                              ok:=true;
                              for l:=b.size.y-1 downto 0 do
                                  begin
                                    ok:=ok and b.readline24(l,p);
                                    if not ok then break;
                                    putline(x,y+l,b.size.x,p);
                                  end;
                            end;
                          BmpMemManBuffer:
                            begin
                              mb.size:=longint(b.size.x)*b.size.y*3;
                              MemManAlloc(mb);
                              if mb.free=mbfree then goto jumpthere;
                              mw:=(b.size.x*3 div 4)*4+4;
                              for l:=b.size.y-1 downto 0 do
                                  begin
                                    ok:=ok and b.readline24(l,p);
                                    if not ok then break;
                                    memmanwrite(mb,longint(l)*b.size.x*3,b.size.x*3,Pointer(p));
                                  end;
                              if ok then
                              for l:=0 to b.size.y-1 do
                                  begin
                                    memmanread(mb,longint(l)*b.size.x*3,mw,pointer(p));
                                    putline(x,y+l,b.size.x,p);
                                  end;
                              memmandealloc(mb);
                            end;
                        end;
                        freemem(p,b.size.x*3+4);
                        showbmp:=ok;
                      end;
                 end;
              b.done;
            end;
}

  function  getbmpdata(fn:string;var a:BmpFileHeader):boolean;
            var f : file;
                r : boolean;
            begin
              assign(f,fn);
              reset(f,sizeof(bmpfileheader));
              {$I-}
              blockread(f,a,1);
              {$I+}
              r:=ioresult=0;
              getbmpdata:=r;
              if r then close(f);
            end;

  function  getbmppalette(fn:string;var p:BmpPalette):boolean;
            var f:file;
                h:bmpfileheader;
                n:word;
            begin
              assign(f,fn);
              {$I-}
              reset(f,1);
              blockread(f,h,sizeof(bmpfileheader));
              {$I+}
              if ioresult<>0 then begin
                                    {$I-}
                                    close(f);
                                    {$I+}
                                    getbmppalette:=false;
                                    exit;
                                  end else getbmppalette:=true;
              if h.bitcount>8 then begin
                                     close(f);
                                     getbmppalette:=false;
                                     exit;
                                   end;
              {$I-}
              blockread(f,p,(1 shl h.bitcount));
              close(f);
              {$I+}
            end;

            var  vBuff : record
                           Attributes   : word;
                           WinAttribA   : byte;
                           WinAttribB   : byte;
                           Granularity  : word;
                           WinSize      : word;
                           WinStartA    : word;
                           WinStartB    : word;
                           PageSelect   : pointer;
                           BytesPerLine : word;
                           {optional}
                           Width        : word;
                           Height       : word;
                           CharWidth    : byte;
                           CharHeight   : byte;
                           MemoryPlanes : byte;
                           BitsPerPixel : byte;
                           Reserved     : array[0..485] of byte;
                         end;

                 vesareadwindow : byte;
                 vesabpl        : word;
                 vesawindow     : word;
                 vesaactwin     : word;

procedure savescreenshot;
          type bmfh=bmpfileheader;
          var h  : bmfh;
              f  : file;
              b  : PRGBColorArr;
              sx : integer;
              sy : integer;
              l  : integer;
              lw : word;
              fn : string;

          procedure vesasetup;
                    begin
                      asm
                        {
                          get vesa mode number
                        }
                        mov ax,4f03h
                        int 10h
                        and bx,$3FFF
                        {
                          get information about this mode
                        }
                        mov cx,bx
                        mov ax,seg vbuff
                        mov es,ax
                        mov ax,4f01h
                        mov di,offset vbuff
                        int 10h
                      end;
                      sx:=vbuff.width;
                      sy:=vbuff.height;
                      vesareadwindow:=0;
                      if (vbuff.winattribB and 2)>0
                         then vesareadwindow:=1;
                      vesabpl:=vbuff.bytesperline;
                      {
                        memorize the current vesa window
                      }
                      asm
                        mov ax,4f05h
                        mov bh,01h
                        mov bl,vesareadwindow
                        int 10h
                        mov word ptr vesawindow,dx
                      end;
                      vesaactwin:=vesawindow;
                    end;

          procedure getvesaline(y:integer;p:pointer);
                    type abyte = array[0..65000] of byte;
                    var la : longint;
                        i  : integer;
                        o  : word;
                    begin
                      la:=longint(y)*vesabpl;
                      if (la div 65536)<>vesaactwin then
                         begin
                           vesaactwin:=la div 65536;
                           asm
                             mov ax,4f05h
                             mov bh,00h
                             mov bl,vesareadwindow
                             mov dx,word ptr vesaactwin
                             int 10h
                           end;
                         end;
                      o:=la mod 65536;
                      for i:=0 to (sx*3)-1 do
                          begin
                            abyte(p^)[i]:=mem[$A000:o];
                            if o<65535
                               then inc(o)
                               else begin
                                      inc(vesaactwin);
                                      asm
                                        mov ax,4f05h
                                        mov bh,00h
                                        mov bl,vesareadwindow
                                        mov dx,word ptr vesaactwin
                                        int 10h
                                      end;
                                      o:=0;
                                    end;
                          end;
                    end;
          begin
            vesasetup;
            fn:='test\screen.bmp';
            lw:=(((sx+1)*3) div 4)*4;
            with h do
              begin
                bmptype[0]:='B';
                bmptype[1]:='M';
                filesize:=longint(sy)*lw+sizeof(bmfh);
                reserv1:=0;
                reserv2:=0;
                dataofs:=54;
                size:=40;
                width:=sx;
                height:=sy;
                planes:=1;
                bitcount:=24;
                compress:=0;
                imgsize:=0;
                xpix2met:=$EC4;
                ypix2met:=$EC4;
                colorusd:=0;
                colorimp:=0;
              end;
            if maxavail<lw then exit;

            getmem(b,lw);

            assign(f,fn);
            {$I-}
            rewrite(f,1);
            {$I+}
            if ioresult<>0 then
               begin
                 freemem(b,lw);
                 exit;
               end;

            blockwrite(f,h,54);

            for l:=sy-1 downto 0 do
                begin
                  getvesaline(l,b);
                  blockwrite(f,b^,lw);
                end;

            freemem(b,lw);
            close(f);
            {
              change to previous vesa window
            }
            asm
              mov ax,4f05h
              mov bh,00h
              mov bl,vesareadwindow
              mov dx,word ptr vesawindow
              int 10h
            end;
          end;

begin
  bmpshowtype:=bmpdirect;
end.