{$O+,F+,N+}
unit convert;
interface

Function  Velke(i:string):string;
Function  Male(i:string):string;
Function  IntegerToString(i:longint):string;
Function  IntToStrSpc(i:longint):string;
Function  BooleanToString(b:boolean):string;
Function  RomeToString(i:integer):string;
Function  RealToString(i:extended):string;
Function  RealToString1(i:extended):string;
Function  RealToStr(i:extended):string;
Function  StringToInteger(s:string):longint;
Function  StringToBoolean(s:string):boolean;
Function  StringToReal (s:string):extended;
Function  StringToExtReal(s:string):extended;
function  timetostring3(h,m,s:word):string;
function  timetostring2e(h,m,s:word):string;
function  timetostring2(h,m:word):string;
function  combinemaskandname(mask,name:string):string;
function  mask2path(mask:string):string;
function  hexcode(d:longint):string;
function  hexcodeW(d:longint):string;
function  codehex(d:string):longint;
function  getpercentage(have,max:integer):integer;
function  filelen(fn:string):longint;

function  ZeroExtend(s:string;n:integer):string;

function  ashex(n:word):string;
function  ptrtostring(p:pointer):string;

procedure CutSpaces(var s:string);

function  isSorted(a,b:string):boolean;

function  ColorToStr(c:longint):string;
function  StrToColor(s:string):longint;

function  ParamValue(pname,params:string):string;

implementation
  uses dos;

  const hexdigits:array[0..15] of char = '0123456789ABCDEF';

  Function  IntToStrSpc(i:longint):string;
            var s,u:string;
                a,b:integer;
            begin
              s:=integertostring(i);
              inttostrspc:=s;
              if length(s)<4 then exit;
              a:= length(s) div 3;
              b:= length(s) mod 3;
              u:=copy(s,1,b);
              for i:=0 to a-1 do
                  u:=u+' '+copy(s,1+b+i*3,3);
              inttostrspc:=u;
            end;

  function  ashex(n:word):string;
            var t:string[4];
            begin
              t[0]:=#04;
              t[1]:=chr(n div 4096);
              t[2]:=chr((n div 256)mod 16);
              t[3]:=chr((n mod 256)div 16);
              t[4]:=chr(n mod 16);
              ashex:=t;
            end;

  function  ZeroExtend(s:string;n:integer):string;
            var st:string;
            begin
              st:=s;
              while length(st)<n do st:='0'+st;
              ZeroExtend:=st;
            end;

  function  getpercentage(have,max:integer):integer;
            begin
              if max=0 then getpercentage:=0
                       else getpercentage:=trunc(have/max*100);
            end;

  function  codehex(d:string):longint;
            var s:string;
                l:longint;
                t:byte;
            begin
              s:=d;
              while (length(s)>0)and(s[1]=' ') do s:=copy(s,2,255);
              codehex:=0;
              if s='' then exit;
              if length(s)=1 then s:='000'+s;
              if length(s)=2 then s:= '00'+s;
              if length(s)=3 then s:=  '0'+s;
              l:=0;
              for t:=0 to 3 do
                  begin
                    case s[t+1] of
                      '0'..'9' : l:=l+(ord(s[t+1])-ord('0'))*($1000 shr (t*4));
                      'A'..'F' : l:=l+(ord(s[t+1])-ord('A')+10)*($1000 shr (t*4));
                    end;
                  end;
              codehex:=l;
            end;

  function  hexcode(d:longint):string;
            var   zost : longint;
                  vysl : string;
                  vlen : byte absolute vysl;
            begin
              vysl:= hexdigits[(d and $0F000000) shr 24]+
                     hexdigits[(d and $00F00000) shr 20]+
                     hexdigits[(d and $000F0000) shr 16]+
                     hexdigits[(d and $0000F000) shr 12]+
                     hexdigits[(d and $00000F00) shr 08]+
                     hexdigits[(d and $000000F0) shr 04]+
                     hexdigits[(d and $0000000F) shr 00];
              while (vysl[1]='0') and (vlen>1) do vysl:=copy(vysl,2,255);
              hexcode:=vysl;
            end;

  function  hexcodeW(d:longint):string;
            var   vysl : string;
            begin
              vysl:= hexdigits[(d and $F000) shr 12]+
                     hexdigits[(d and $0F00) shr 08]+
                     hexdigits[(d and $00F0) shr 04]+
                     hexdigits[(d and $000F) shr 00];
              hexcodew:=vysl;
            end;

  function  ptrtostring(p:pointer):string;
            begin
              ptrtostring:=hexcodew(seg(p^))+':'+hexcodew(ofs(p^));
            end;

  function  combinemaskandname(mask,name:string):string;
            var D: DirStr;
                N: NameStr;
                E: ExtStr;
            begin
              if mask='' then begin
                                combinemaskandname:=name;
                                exit;
                              end;
              if name='' then begin
                                combinemaskandname:='';
                                exit;
                              end;
              FSplit(mask, D, N, E);
              combinemaskandname:=d+name;
            end;

  function  mask2path(mask:string):string;
            var D: DirStr;
                N: NameStr;
                E: ExtStr;
            begin
              if mask='' then begin
                                mask2path:='';
                                exit;
                              end;
              FSplit(mask, D, N, E);
              mask2path:=d;
            end;

  Function  BooleanToString(b:boolean):string;
            begin
              if b then booleantostring:='yes'
                   else booleantostring:='no';
            end;

  function  timetostring3(h,m,s:word):string;
            var ts : string;
            begin
              if m<10 then ts:=integertostring(h)+':0'+integertostring(m)+':'
                      else ts:=integertostring(h)+':'+integertostring(m)+':';
              if s<10 then ts:=ts+'0'+integertostring(s)
                      else ts:=ts+integertostring(s);
              timetostring3:=ts;
            end;

  function  timetostring2(h,m:word):string;
            var ts : string;
            begin
              if m<10 then ts:=integertostring(h)+':0'+integertostring(m)
                      else ts:=integertostring(h)+':'+integertostring(m);
              timetostring2:=ts;
            end;

  function  timetostring2e(h,m,s:word):string;
            var ts : string;
            begin
              case (s mod 2)=0 of
               false :if m<10 then ts:=integertostring(h)+':0'+integertostring(m)
                              else ts:=integertostring(h)+':'+integertostring(m);
               true  :if m<10 then ts:=integertostring(h)+' 0'+integertostring(m)
                              else ts:=integertostring(h)+' '+integertostring(m);
              end;
              timetostring2e:=ts;
            end;

  Function  Velke(i:string):string;
            var o:string;
                n:byte;
            begin
              if length(i)=0 then begin
                                    velke:='';
                                    exit;
                                  end;
              o:='';
              for n:=1 to length(i) do o:=o+upcase(i[n]);
              velke:=o;
            end;

  Function  Male(i:string):string;
            var o:string;
                n:byte;
            begin
              if length(i)=0 then begin
                                    male:='';
                                    exit;
                                  end;
              o:='';
              for n:=1 to length(i) do case i[n] of
                                         'A'..'Z' : o:=o+(chr(ord(i[n])+32));
                                         else o:=o+i[n];
                                       end;
              male:=o;
            end;

  Function  IntegerToString(i:longint):string;
            Var
              s : string;
            Begin
              s:='/error/';
              Str(i,s);
              IntegerToString:=s;
            End;

  Function  RealToString(i:extended):string;
            Var
              s : string;
            Begin
              s:='/error/';
              Str(i:10:3,s);
              RealToString:=s;
            End;

  Function  RealToString1(i:extended):string;
            Var
              s : string;
            Begin
              s:='/error/';
              Str(i:3:1,s);
              RealToString1:=s;
            End;

  Function  RealToStr(i:extended):string;
            Var
              s : string;
            Begin
              s:='/error/';
              Str(i:0:7,s);
              if pos('.',s)<>0 then begin
                                      while s[ord(s[0])]='0' do
                                            s[0]:=chr(ord(s[0])-1);
                                      if s[ord(s[0])]='.' then
                                         s[0]:=chr(ord(s[0])-1);
                                    end;
              RealToStr:=s;
            End;

  Function  StringToInteger(s:string):longint;
            Var
              I : longint;
              J : integer;
              r : string;
            Begin
              r:=s;
              while copy(r,1,1)=' ' do r:=copy(r,2,255);
              i:=0;
              Val(r,i,j);
              if j<>0 then val(copy(r,1,j-1),i,j);
              StringToInteger:=i;
            End;

  Function  StringToBoolean(s:string):boolean;
            Begin
              StringToBoolean:=false;
              If s='yes' then StringToBoolean:=true;
              If s='Yes' then StringToBoolean:=true;
              If s='YES' then StringToBoolean:=true;
              If s='true' then StringToBoolean:=true;
              If s='True' then StringToBoolean:=true;
              If s='TRUE' then StringToBoolean:=true;
            End;

  Function  StringToReal(s:string):extended;
            var i : integer;
                r : real;
            begin
              val(s,r,i);
              stringtoreal:=r;
            end;

  Function  RomeToString(i:integer):string;
            begin
              case i of
                00 : rometostring:='0';
                01 : rometostring:='I';
                02 : rometostring:='II';
                03 : rometostring:='III';
                04 : rometostring:='IV';
                05 : rometostring:='V';
                06 : rometostring:='VI';
                07 : rometostring:='VII';
                08 : rometostring:='VIII';
                09 : rometostring:='IX';
                10 : rometostring:='X';
                11 : rometostring:='XI';
                12 : rometostring:='XII';
                else rometostring:='???';
              end
            end;

  function  filelen(fn:string):longint;
            var f:file of byte;
            begin
              assign(f,fn);
              reset(f);
              filelen:=filesize(f);
              close(f);
            end;

  Function  StringToExtReal(s:string):extended;
            var i : integer;
                r : extended;
            begin
              val(s,r,i);
              stringtoextreal:=r;
            end;

  Procedure CutSpaces(var s:string);
            begin
              while copy(s,1,1)=' ' do s:=copy(s,2,255);
              while copy(s,length(s),1)=' ' do s:=copy(s,1,length(s)-1);
            end;

  Function  isSorted(a,b:string):boolean;
            begin
              isSorted:=a<b;
            end;

  function  ColorToStr(c:longint):string;
            begin
              ColorToStr:='#'+
                     hexdigits[(c and $00F00000) shr 20]+
                     hexdigits[(c and $000F0000) shr 16]+
                     hexdigits[(c and $0000F000) shr 12]+
                     hexdigits[(c and $00000F00) shr 08]+
                     hexdigits[(c and $000000F0) shr 04]+
                     hexdigits[(c and $0000000F) shr 00];
            end;

  function  StrToColor(s:string):longint;
            var i:integer;
            begin
              for i:=2 to 7 do
                  begin
                    if s[i] in ['0'..'9'] then
                       begin
                         dec(s[i],ord('0'));
                         continue;
                       end;
                    if s[i] in ['A'..'F'] then
                       begin
                         dec(s[i],ord('A'));
                         inc(s[i],10);
                         continue;
                       end;
                  end;
              StrToColor:=65536*(ord(s[2])*16+ord(s[3]))+
                            256*(ord(s[4])*16+ord(s[5]))+
                                (ord(s[6])*16+ord(s[7]));
            end;

  function  ParamValue(pname,params:string):string;
            begin
              params:=copy(params,pos(pname,params)+length(pname),255);
              if pos(' ',params)>0 then
                 params:=copy(params,1,pos(' ',params)-1);
              ParamValue:=params;
            end;

begin
end.