{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      DRIVERS UNIT


  Programmed by:      Rozsnyo Daniel

  Version:            1.00.003 A
  Release date:       2001-01-24
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

Unit Drivers;

 {x$DEFINE debug_showspeed}

Interface


 Procedure ConsoleDriver;


Implementation
 uses      Types,      { System 2001 v.6 basic types                        }
           SysCalls,   { System 2001 v.6 system calls and message inserting }
           Dos;

 Var  ConsoleData :      record
                           OldMx  : word;
                           OldMy  : word;
                           OldMb  : word;
                           NewMx  : word;
                           NewMy  : word;
                           NewMb  : word;
                           Buttons: word;
                           Mouse  : boolean;
                         end;

 {$IFDEF debug_showspeed}
  h,m,s,ss,se : word;

  t           : longint;
 {$ENDIF}


 Procedure ConsoleDriver;
           var LocalMess   : TMessage;
               KeyBoardOut : PCO_KB_Input;
               MouseChange : TCO_MS_ChangePos;
               CursorPos   : TCO_MS_PressLeft;

           Function  KeyPressed:boolean;assembler;
                     Asm
                           mov  ax, 40h
                           mov  es, ax
                           mov  dx, es:[1ah]
                           mov  bx, es:[1ch]
                           xor  ax, ax
                           cmp  dx, bx
                           je   @E
                           mov  al, 1
                       @E:
                     end;

           Function  ReadKey:char;assembler;
                     Asm
                           MOV AH,8
                           INT 21H
                           XOR AH,AH
                     end;

           Function  GetKeyCode: word;
                     var c : char;
                     begin
                       c:=readkey;
                       if c=#0
                          then begin
                                 c:=readkey;
                                 GetKeyCode:=ord(c)+$100;
                               end
                          else begin
                                 GetKeyCode:=ord(c);
                               end;
                     end;

           Procedure MouseIn;assembler;
                     Asm
                       mov ax,$0003
                       int $33
                       shr cx,3
                       shr dx,3
                       mov Consoledata.NewMX,cx
                       mov Consoledata.NewMY,dx
                       mov Consoledata.NewMB,bx
                     End;

           Procedure MousePut(x,y:word);assembler;
                     Asm
                       mov cx,x
                       shl cx,3
                       mov dx,y
                       shl dx,3
                       mov ax,$0004
                       int $33
                     End;

           Procedure MouseSetXrange(min,max:word);Assembler;
                     Asm
                       mov ax,$0007
                       mov cx,min
                       shl cx,3
                       mov dx,max
                       shl dx,3
                       int $33
                     End;

           Procedure MouseSetYrange(min,max:word);Assembler;
                     Asm
                       mov ax,$0008
                       mov cx,min
                       shl cx,3
                       mov dx,max
                       shl dx,3
                       int $33
                     End;

           Procedure MouseSetResolution(x,y:word);assembler;
                     Asm
          	       mov ax,$000F
          	       mov cx,x
          	       mov dx,y
                       int $33
                     end;
           begin

             LocalMess:=Message;

             Case LocalMess.Mess of

               PR_Init:
                 begin

                 ToConsole:=process.id;


                 {$IFDEF debug_showspeed}
                 t:=0;
                 se:=60;
                 {$ENDIF}

                 { initialize mouse driver }
                   Write('  Initalializing mouse driver   ');
                   Asm
                         mov ax,$0000
                         int $33
                         mov Consoledata.Buttons,bx
                         cmp ax,$FFFF
                         je @I
                         xor al,al
                         jmp @E
                     @I: mov al,1
                     @E: mov byte ptr ConsoleData.Mouse,al

                   End;
                   if consoledata.mouse
                      then writeln('< OK >   ',
                                   Consoledata.Buttons,' button mouse')
                      else writeln('Mouse not found !');
                   Writeln('  Console driver initialized.');
                   mousesetresolution(12,12);
                 end;

               PR_Close,
               PR_Hibernate,
               PR_Kill:
                 { unregister the driver's procedure }
                 SendMessage( LocalMess.dest,ToKernel,KE_StopProcess,0,nil);

               CO_CheckState:
                 begin
                    {$IFDEF debug_showspeed}
                    inc(t);
                    if (t mod 1000)=0 then
                       begin
                         gettime(h,m,s,ss);
                         if s<>se then begin
                                         writeln('Speed: ',t:7,' looks to keyboard and mouse.');
                                         t:=0;
                                         se:=s;
                                       end;
                       end;
                    {$ENDIF}

                 { check the state of keyboard and mouse, if key was
                   pressed, translate keyboard code                        }
                   if keypressed then
                      begin
                        new(keyboardout);
                        With KeyBoardOut^ do
                         begin
                           code      := GetKeyCode;
                           character := chr(code and $FF);
                           flags     := mem[$0:$417];
                         end;

                        SendMessage(LocalMess.dest,ToKernel,
                                    CO_KB_Input,
                                    sizeof(TCO_KB_Input),KeyBoardOut);
                        dispose(keyboardout);
                      end;

                 { if no mouse installed the exit }
                   if not consoledata.mouse then exit;

                 { get the state of mouse }
                   mousein;
                   with ConsoleData do
                    begin
                      if (newMx<>oldMx) or
                         (newMy<>oldMy) then
                         begin
                           {position change}
                           with MouseChange do
                            begin
                              NewPosition.x:=newMx;
                              NewPosition.y:=newMy;
                              OldPosition.x:=oldMx;
                              OldPosition.y:=oldMy;
                            end;
                           oldmx:=newmx;
                           oldmy:=newmy;
                           SendMessage(LocalMess.dest,ToKernel,
                                       CO_MS_ChangePos,
                                       sizeof(MouseChange),addr(MouseChange));

                         end;
                      if newMb<>oldMb then
                         begin
                           {button state changed}
                           Cursorpos.x:=NewMx;
                           Cursorpos.y:=NewMy;
                           if ((oldMb and 1)=0) and ((newMb and 1)=1) then
                              SendMessage(LocalMess.dest,ToKernel,
                                          CO_MS_PressLeft,
                                          sizeof(CursorPos),addr(CursorPos));
                           if ((oldMb and 1)=1) and ((newMb and 1)=0) then
                              SendMessage(LocalMess.dest,ToKernel,
                                          CO_MS_ReleaseLeft,
                                          sizeof(CursorPos),addr(CursorPos));
                           if ((oldMb and 2)=0) and ((newMb and 2)=2) then
                              SendMessage(LocalMess.dest,ToKernel,
                                          CO_MS_PressRight,
                                          sizeof(CursorPos),addr(CursorPos));
                           if ((oldMb and 2)=2) and ((newMb and 2)=0) then
                              SendMessage(LocalMess.dest,ToKernel,
                                          CO_MS_ReleaseRight,
                                          sizeof(CursorPos),addr(CursorPos));
                           OldMb:=NewMb;
                         end;
                    end;
                    {Jump(CO_CheckState);}
                 end;

               CO_KB_GenerateKeypress :
                 begin
                 { translate keyboard code }
                   With TCO_KB_Input(LocalMess.data^) do
                    begin
                     if code<$100
                        then character := chr(code)
                        else character := #00;
                    end;
                   SendMessage( LocalMess.dest,ToKernel,
                                CO_KB_INPUT,
                                sizeof(KeyBoardOut),LocalMess.data);
                 end;

               CO_MS_SetPosition :
                 begin
                 { set the mouse position }
                   mouseput(TCO_MS_SetPosition(LocalMess.data^).x,
                            TCO_MS_SetPosition(LocalMess.data^).y);
                 end;

               CO_MS_SetRange :
                 begin
                 { set the mouse position }
                   mousesetXrange(TCO_MS_SetRange(LocalMess.data^).min.x,
                                  TCO_MS_SetRange(LocalMess.data^).max.x);
                   mousesetYrange(TCO_MS_SetRange(LocalMess.data^).min.y,
                                  TCO_MS_SetRange(LocalMess.data^).max.y);
                 end;

               CO_MS_SetSensitivity :
                 begin
                 { set the mouse sensitivity }
                   mousesetresolution(
                     TCO_MS_SetSensitivity(LocalMess.data^).xaxis,
                     TCO_MS_SetSensitivity(LocalMess.data^).yaxis);
                 end;

               CO_MS_ChangePos :
                 begin
                 { force mouse to refresh the position for one process }
                   mousein;
                   with MouseChange do
                    begin
                      NewPosition.x:=ConsoleData.newMx;
                      NewPosition.y:=ConsoleData.newMy;
                      OldPosition.x:=ConsoleData.oldMx;
                      OldPosition.y:=ConsoleData.oldMy;
                    end;
                    ConsoleData.oldmx:=ConsoleData.newmx;
                    ConsoleData.oldmy:=ConsoleData.newmy;
                    SendMessage(LocalMess.dest,LocalMess.From,
                                CO_MS_ChangePos,
                                sizeof(MouseChange),addr(MouseChange));
                 end;

             end;

           end;


Begin
End.