  Unit Font16;

  Interface

    Const     MaxFonts     = 8;
              STDspacing   = 2;

    Type      FontType     = array[0..4095] of word;
              PFontType    = ^FontType;
              Afonts       = array[0..maxfonts-1] of PFonttype;

              TcharWtype   = array[0..255] of byte;
              PCharWtype   = ^TcharWtype;
              Alengths     = array[0..maxfonts-1] of PCharWtype;

    Var       Fonts     : record
                            number : byte;
                            data   : Afonts;
                            lens   : Alengths;
                            used   : byte;
                            color  : longint;
                            spacing: byte;
                            zoom   : boolean;
                            xz     : shortint;
                            yz     : shortint;
                            xs     : shortint;
                            ys     : shortint;
                            name   : array[0..maxfonts-1] of string[8];
                          end;

              Norm      : byte;
              Bold      : byte;
              Taho      : byte;

              EGAfont   : byte;

              FontError : byte;          { Errors:
                                             0 no error
                                             1 loadfont / wrong file
                                             2 loadfont / not enough memory
                                             3 loadfont / all handle in use
                                         }

    Function  LoadFont(n:string):byte;
    Procedure SaveFont(n:string);

    Function  RegisterFont(p:Pfonttype):byte;
    Procedure RemoveFont;
    Procedure DoneFont;

    Procedure SetFont(f:byte;c:longint);
    Procedure SetZoom(a,b,c,d:shortint);    { paintx,y, nopaintx,y }
    Procedure NoZoom;

    {
    Function  DrawChar(x,y:integer;n:char):byte;

    Function  DrawString(x,y:integer;n:string):word;
    Function  DrawStringLen(x,y,l:integer;n:string):word;
    Function  DrawStringBlock(x,y,l:integer;n:string):word;

    Function  DrawStringCenter(x,y:integer;n:string):word;
    Function  DrawStringcenterLen(x,y,l:integer;n:string):word;

    Function  DrawStringRight(x,y:integer;n:string):word;
    }
    Function  LenString(n:string):word;
    Function  LenChar(n:char):byte;
    Function  CountLen(c:byte):byte;

    {
    Procedure Xgroup(x,y,a,b:integer;s:string);
    }

  Implementation

    {
    Function  DrawStringBlock(x,y,l:integer;n:string):word;
              var slova : array[0..63] of string[32];
                  medz  : integer;
                  i     : byte;
                  m     : byte;
                  dslov : integer;
                  xx    : integer;
                  xxx   : integer;
              begin
                if l<3 then exit;
                if n='' then exit;
                if pos(' ',n)=0 then
                   begin
                     drawstringcenter(x,y+l div 2,n);
                     exit;
                   end;
                m:=length(n);
                medz:=0;
                slova[0]:='';
                for i:=1 to m do
                    if n[i]=' ' then begin
                                       inc(medz);
                                       slova[medz]:='';
                                     end
                                else slova[medz]:=slova[medz]+n[i];
                dslov:=0;
                for i:=0 to medz do dslov:=dslov+lenstring(slova[i]);
                xx:=0;
                for i:=0 to medz do
                    begin
                      xxx:=round(i*(l-dslov)/medz);
                      drawstring(x+xx+xxx,y,slova[i]);
                      xx:=xx+lenstring(slova[i]);
                    end;
              end;
    }

    Procedure SetZoom(a,b,c,d:shortint);
              begin
                fonts.zoom:=true;
                fonts.xz:=a;
                fonts.yz:=b;
                fonts.xs:=a+c;
                fonts.ys:=b+d;
                fonts.spacing:=STDspacing*fonts.xs;
              end;

    Procedure NoZoom;
              begin
                fonts.zoom:=false;
                fonts.xs:=1;
                fonts.spacing:=STDspacing;
              end;
    {
    Function  DrawStringLen(x,y,l:integer;n:string):word;
              var s:string;
              begin
                s:=n;
                if l<8 then exit;
                if lenstring(s)>l then s:=s+'...';
                while lenstring(s)>l do s:=copy(s,1,length(s)-4)+'...';
                drawstring(x,y,s);
              end;

    Function  DrawStringcenterLen(x,y,l:integer;n:string):word;
              var s:string;
              begin
                s:=n;
                if l<8 then exit;
                if lenstring(s)>l then s:=s+'...';
                while lenstring(s)>l do s:=copy(s,1,length(s)-4)+'...';
                drawstringcenter(x,y,s);
              end;

    Function  DrawStringCenter(x,y:integer;n:string):word;
              var l:word;
              begin
                l:=lenstring(n);
                drawstring(x-(l div 2),y,n);
              end;

    Function  DrawStringRight(x,y:integer;n:string):word;
              var l:word;
              begin
                l:=lenstring(n);
                drawstring(x-l,y,n);
              end;
    }

    Procedure SaveFont(n:string);
              var F : file;
              begin
                Assign(f,n);
                {$I-}
                rewrite(f,1);
                {$I+}
                if ioresult<>0 then begin
                                      fonterror:=1;
                                      exit;
                                    end;
                blockwrite(f,fonts.data[fonts.used]^,8192);
                close(f);
              end;

    Function  LoadFont(n:string):byte;
              Var F : file;
                  c : word;
                  i : byte;
              Begin
                if maxavail<(sizeof(fonttype)+sizeof(TcharWtype)) then
                   begin
                     fonterror:=2;
                     exit;
                   end;
                if fonts.number=maxfonts then
                   begin
                     fonterror:=3;
                     exit;
                   end;
                Assign(f,n);
                {$I-}
                reset(f,1);
                {$I+}
                if ioresult<>0 then begin
                                      fonterror:=1;
                                      exit;
                                    end;
                i:=fonts.number;
                New(fonts.data[i]);
                New(fonts.lens[i]);
                blockread(f,fonts.data[i]^,8192);
                close(f);
                LoadFont:=i;
                {
                  fill lengths table
                }
                fonts.used:=fonts.number;
                for i:=0 to 255 do
                    fonts.lens[fonts.number]^[i]:=CountLen(i);
                {
                  add filename (remove the path)
                }
                while pos('\',n)>0 do n:=copy(n,2,255);
                if pos('.',n)>0 then n:=copy(n,1,pos('.',n)-1);
                fonts.name[fonts.number]:=n;
                inc(fonts.number);
                fonterror:=0;
              end;

    Function  RegisterFont(p:Pfonttype):byte;
              Var F : file;
                  i : byte;
              Begin
                i:=fonts.number;
                fonts.data[i]:=p;
                inc(fonts.number);
                RegisterFont:=i;
                fonterror:=0;
              end;

    Procedure RemoveFont;
              begin
                dec(fonts.number);
                dispose(fonts.data[fonts.number]);
                dispose(fonts.lens[fonts.number]);
              end;

    Procedure DoneFont;
              var i:byte;
              begin
                if fonts.number=0 then exit;
                for i:=1 to fonts.number do
                    begin
                      dispose(fonts.data[i-1]);
                      dispose(fonts.lens[i-1]);
                    end;
                fonts.number:=0;
              end;

    Procedure SetFont(f:byte;c:longint);
              begin
                fonts.used:=f;
                fonts.color:=c;
              end;
    {
    Function  DrawChar(x,y:integer;n:char):byte;
              var c  : byte;
                  ms : word;
                  xo : word;
                  yo : word;
                  fd : array[0..15] of word;
              begin
                asm
                      mov ah,n
                      mov c,ah
                      mov ms,0
                end;
                setcolor(fonts.color);
                for yo:=0 to 15 do fd[yo]:=fonts.data[fonts.used]^[c*16+yo];
                case fonts.zoom of
                  false : begin
                            asm
                                  mov yo,0
                              @2: mov xo,0
                              @1: mov bx,yo
                                  shl bx,1
                                  mov si,bx
                                  mov ax,word ptr [fd+si]
                                  mov cx,xo
                                  mov dx,8000h
                                  shr dx,cl
                                  and ax,dx
                                  cmp ax,0
                                  je  @3
                                  mov ax,x
                                  add ax,xo
                                  mov dx,y
                                  add dx,yo
                                  push si
                                  call putpixelasm
                                  pop si
                                  mov ax,xo
                                  cmp ax,ms
                                  jb  @3
                                  mov ms,ax
                              @3: inc xo
                                  cmp xo,16
                                  jne @1
                                  mov xo,0
                                  inc yo
                                  cmp yo,16
                                  jne @2
                            end;
                          end;
                  true  : for yo:=0 to 15 do
                          for xo:=0 to 15 do
                              if ((fd[yo])and($8000 shr xo))>0
                                 then begin
                                        if (xo*fonts.xs)>ms then ms:=xo*fonts.xs;
                                        box( x+xo*fonts.xs,
                                             y+yo*fonts.ys,
                                             fonts.xz-1,
                                             fonts.yz-1);
                                      end;
                end;
                drawchar:=ms;
              end;
    }

    Function  LenChar(n:char):byte;
              begin
                LenChar:=fonts.lens[fonts.used]^[byte(n)];
              end;

    Function  CountLen(c:byte):byte;
              var ms : byte;
                  xo : byte;
                  yo : byte;
              begin
                ms:=0;
                for yo:=0 to 15 do
                for xo:=0 to 15 do
                    if ((fonts.data[fonts.used]^[c*16+yo])and($8000 shr xo))>0
                       then if (xo*fonts.xs)>ms then ms:=xo*fonts.xs;
                CountLen:=ms;
              end;
    {
    Function  DrawString(x,y:integer;n:string):word;
              var i : byte;
                  l : word;
              begin
                if n[0]=#0 then exit;
                l:=0;
                for i:=1 to ord(n[0]) do l:=l+drawchar(x+l,y,n[i])+fonts.spacing;
                DrawString:=l-fonts.spacing;
              end;
    }
    Function  LenString(n:string):word;
              var i : byte;
                  l : integer;
              begin
                lenstring:=0;
                if n[0]=#0 then exit;
                l:=0;
                for i:=1 to ord(n[0]) do l:=l+lenchar(n[i])+fonts.spacing;
                lenString:=l+1-fonts.spacing;
              end;
    {
    Procedure Xgroup(x,y,a,b:integer;s:string);
              begin
                dipt       (x,  y+6,x+a-1,y+b-1);
                undipt     (x+1,y+7,x+a-2,y+b-2);
                setbackcolor;
                bar        (x+5,y+6,x+9+lenstring(s),y+7);
                setfont    (norm,$000000);
                drawstring (x+7,y,s);
              end;
    }
  Begin
    fonts.number:=0;
    fonts.spacing:=STDspacing;
    fonts.xs:=1;
    fonts.zoom:=false;
    fonts.used:=0;
    fonts.color:=0;
    bold:=1;
    norm:=0;
  End.
