{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      [G-PATH technology] VESA GRAPHIC DRIVER(S)


  Programmed by:      Rozsnyo Daniel

  Version:            1.20.001 C
  Release date:       2001-11-19

  Copyright:          (C) 2001, Rozsnyo electronics and software

}

Unit GD_VESA;

Interface

Implementation

  Uses GDrivers,AdvMM,Types;

  type TWordArray = array[0..1] of word;
       PWordArray = ^TWordArray;

       TByteArray = array[0..1] of byte;
       PByteArray = ^TByteArray;

  procedure SwitchToNextOutSegment;forward;

  Procedure REPACK_LINE( pc : word;
                         sd : pointer; sf : byte;
                         ss,so : word; df : byte;
                         ns : pointer);
            type TPixel= array[0..2] of byte;
            var x   : word;
                p   : TPixel;
                w   : word;
                sb  : byte;
                db  : byte;
            procedure chseg;
                      var pr : procedure;
                      begin
                        @pr:=ns;
                        pr;
                      end;
            begin
              {
                byte perpixel
              }
              sb:=sf div 8;
              case df of
                15 : db:=2;
                16 : db:=2;
                24 : db:=3;
                32 : db:=4;
              end;
              {
                repack pixel by pixel
              }
              for x:=0 to pc-1 do
                  begin
                    {
                      read pixel
                    }
                    p[0]:=TByteArray(sd^)[x*sb+0];
                    p[1]:=TByteArray(sd^)[x*sb+1];
                    p[2]:=TByteArray(sd^)[x*sb+2];
                    {
                      save pixel
                    }
                    case df of
                      32 : begin
                             {
                               RGBx,RGBx
                             }
                             Mem[ss:so+0]:=p[0];
                             Mem[ss:so+1]:=p[1];
                             Mem[ss:so+2]:=p[2];
                             if so=$FFFC then chseg;
                           end;
                      16 : begin
                             {
                               bbbbbggggggrrrrr
                               --------   B2
                                  B1   --------
                             }
                             asm
                               xor ax,ax
                               mov bl,byte ptr p[2]
                               shr bl,3
                               or  al,bl
                               shl ax,6
                               mov bl,byte ptr p[1]
                               shr bl,2
                               or  al,bl
                               shl ax,5
                               mov bl,byte ptr p[0]
                               shr bl,3
                               or  al,bl
                               mov w,ax
                             end;
                             MemW[ss:so]:=w;
                             if so=$FFFE then chseg;
                           end;
                      15 : begin
                             {
                                bbbbbgggggrrrrr
                               --------   B2
                                  B1   --------
                             }
                             asm
                               xor ax,ax
                               mov bl,byte ptr p[2]
                               shr bl,3
                               or  al,bl
                               shl ax,5
                               mov bl,byte ptr p[1]
                               shr bl,3
                               or  al,bl
                               shl ax,5
                               mov bl,byte ptr p[0]
                               shr bl,3
                               or  al,bl
                               mov w,ax
                             end;
                             MemW[ss:so]:=w;
                             if so=$FFFE then chseg;
                           end;
                    end;
                    inc(so,db);
                  end;
            end;

  const
       VESA15NAME = 'VESA-15';
       VESA15INV  = 'VESA-15-INV';
       VESA16NAME = 'VESA-16';
       VESA16INV  = 'VESA-16-INV';
       VESA24NAME = 'VESA-24';
       VESA24INV  = 'VESA-24-INV';
       VESA32NAME = 'VESA-32';
       VESA32INV  = 'VESA-32-INV';

  var
       {
         mode info
       }
       MInfo : record
                 Attributes   : word;
                 WinAttribA   : byte;
                 WinAttribB   : byte;
                 Granularity  : word;
                 WinSize      : word;
                 WinStartA    : word;
                 WinStartB    : word;
                 PageSelect   : pointer;
                 BytesPerLine : word;
                 {optional}
                 Width        : word;
                 Height       : word;
                 CharWidth    : byte;
                 CharHeight   : byte;
                 MemoryPlanes : byte;
                 BitsPerPixel : byte;
                 Reserved     : array[0..485] of byte;
               end;

       {
         adapter info
       }
       AInfo : record
                 Signature    : array[0..3] of char;
                 Version      : word;
                 OEMname      : pointer;
                 Capabilities : longint;
                 ModeList     : pointer;
                 VideoMemory  : word;
               end absolute MInfo;

  const
       MAX_MODECOUNT = 20;

  var
       {
         driver data
       }
       vesa  : record
                 modecount    : word;
                 modelist     : array[0..MAX_MODECOUNT-1] of
                                  record
                                    mode : word;
                                    x    : word;
                                    y    : word;
                                  end;
                 bits         : byte;
                 bpp          : byte;
                 bpl          : word;
                 OutSeg       : word;
                 OutSegID     : byte;
                 OutSegPos    : word;
                 ForcePL      : boolean;
                 GrayScale    : boolean;
                 Inverse      : boolean;
               end;

  procedure SwitchOutSegment;assembler;
            asm
              mov ax,4f05h
              mov bl,byte ptr vesa.OutSegID
              mov bh,0
              mov word ptr Vesa.outseg,dx
              int 10h
            end;

  procedure SwitchToNextOutSegment;assembler;
            asm
              mov dx,word ptr Vesa.outseg
              inc dx
              call switchoutsegment;
            end;

  procedure VESA24_MC(var ct:word);
            begin
              {
                GET MODE COUNT
              }
              ct:=vesa.modecount;
            end;

  procedure VESA24_MI(m:word;var inf:TGP_ModeInfo);
            var md:word;
            begin
              {
                GET MODE INFO
              }
              if m<vesa.modecount then
                 begin
                   {
                     mode number valid
                   }
                   md:=vesa.modelist[m].mode;
                   {
                     get all info
                   }
                   asm
                     mov ax,ds
                     mov es,ax
                     mov di,offset MInfo
                     mov cx,word ptr md
                     mov ax,4f01h
                     int 10h
                   end;
                   {
                     this is only important
                   }
                   inf.size.x   := MInfo.width;
                   inf.size.y   := MInfo.height;
                   inf.bitcount := MInfo.bitsperpixel;
                 end else
                 begin
                   {
                     mode number invalid
                   }
                   inf.size.x   := 0;
                   inf.size.y   := 0;
                   inf.bitcount := 0;
                 end;
            end;

  procedure VESA24_SM(m:word);
            var md:word;
            begin
              {
                SET MODE
              }
              if m<vesa.modecount then
                 begin
                   {
                     mode number valid
                   }
                   md:=vesa.modelist[m].mode;
                   {
                     get mode info
                   }
                   asm
                     mov ax,ds
                     mov es,ax
                     mov di,offset MInfo
                     mov cx,word ptr md
                     mov ax,4f01h
                     int 10h
                   end;
                   {
                     initialize the important variables
                   }
                   case MInfo.BitsPerPixel of
                     8 : vesa.bpp := 1;
                    15 : vesa.bpp := 2;
                    16 : vesa.bpp := 2;
                    24 : vesa.bpp := 3;
                    32 : vesa.bpp := 4;
                   end;
                   vesa.bpl := MInfo.BytesPerLine;
                   {
                     set mode
                   }
                   asm
                     mov bx,word ptr md
                     mov ax,4f02h
                     int 10h
                   end;
                   {
                     setup out segment
                   }
                   if (MInfo.WinAttribB and 5) = 5 then
                      begin
                        vesa.OutSegID := 1;
                        vesa.OutSegPos:= MInfo.WinStartB;
                      end;
                   if (MInfo.WinAttribA and 5) = 5 then
                      begin
                        vesa.OutSegID := 0;
                        vesa.OutSegPos:= MInfo.WinStartA;
                      end;
                   asm
                     xor dx,dx
                     call SwitchOutSegment
                   end
                 end else
                 begin
                   {
                     mode number invalid
                   }
                 end;
            end;

  procedure VESA24_PL(x,y,l:integer;p:pointer;f:byte);
            var la    : longint;
                s,o   : word;
                s2,o2 : word;
                w     : word;
                v     : word;
            begin
              {
                invert every pixel's data
              }
              if vesa.inverse then
                 begin
                   o:=l*(f div 8)-1;
                   for s:=0 to o do
                       TByteArray(p^)[s]:=not TByteArray(p^)[s];
                 end;
              {
                destination
              }
              la:=longint(Vesa.bpl)*y+x*vesa.bpp;
              s:= la div 65536;
              o:= la mod 65536;
              {
                try to use in direct copy mode
              }
              if f=vesa.bits then
                 begin
                   {
                     direct copy OK
                   }
                   s2:=seg(p^);
                   o2:=ofs(p^);
                   {
                     number of bytes to copy
                   }
                   w:=l*vesa.bpp;
                   {
                     number of bytes to end of segment
                   }
                   v:=65536-o;
                   {
                     is the copy in 2 segments ?
                   }
                   if (longint(o)+w)>65536
                      then begin
                             {
                               make copy inside 2 segments
                             }
                             asm
                                      mov dx,s
                                      cmp dx,word ptr Vesa.OutSeg
                                      je @move
                                      call SwitchOutSegment
                               @move: mov di,o
                                      mov si,o2
                                      mov cx,v
                                      push ds
                                      push es
                                      mov ax,word ptr vesa.OutSegPos
                                      mov es,ax
                                      mov ax,s2
                                      mov ds,ax
                                      cld
                                      rep movsb
                                      pop es
                                      pop ds
                                      mov dx,word ptr Vesa.OutSeg
                                      inc dx
                                      call SwitchOutSegment
                                      mov di,0
                                      mov cx,w
                                      sub cx,v
                                      push ds
                                      push es
                                      mov ax,word ptr vesa.OutSegPos
                                      mov es,ax
                                      mov ax,s2
                                      mov ds,ax
                                      cld
                                      rep movsb
                                      pop es
                                      pop ds
                             end;
                           end
                      else begin
                             {
                               make copy inside 1 video segment
                             }
                             asm
                                      mov dx,s
                                      cmp dx,Vesa.OutSeg
                                      je @move
                                      call SwitchOutSegment
                               @move: mov di,o
                                      mov si,o2
                                      mov cx,w
                                      push ds
                                      push es
                                      mov ax,word ptr vesa.OutSegPos
                                      mov es,ax
                                      mov ax,s2
                                      mov ds,ax
                                      cld
                                      rep movsb
                                      pop es
                                      pop ds
                             end;
                           end;

                 end else
                 begin
                   {
                     not direct copy, we must repack
                   }
                   asm
                         mov dx, word ptr s
                         cmp dx, word ptr vesa.outseg
                         je @E
                         call SwitchOutSegment
                     @E:
                   end;
                   REPACK_LINE(l,
                               p,f,
                               vesa.outsegpos,o,vesa.bits,
                               addr(switchtonextoutsegment))
                 end;
            end;

  procedure VESA24_PB(x,y,a,b,x0,y0,bpl:integer;mb:PAmmPart;f:byte);
            var {
                  row
                }
                r   : word;
                L   : word;
                {
                  destination
                }
                la  : longint;
                s,o : word;
                p   : pointer;
            begin
              {
                try to use in direct copy mode
              }
              l :=a*(f div 8);
              if (f=vesa.bits) and not vesa.ForcePL then
                 begin
                   {
                     we do the drawing of image line by line
                   }
                   for r:=0 to b-1 do
                       begin
                         {
                           calculate the position on screen
                         }
                         la:=longint(vesa.bpl)*(y+r)+x*vesa.bpp;
                         s:=la div 65536;
                         o:=la mod 65536;
                         {
                           destination
                         }
                         p:=ptr(vesa.OutSegPos,o);
                         asm
                           mov dx, word ptr s
                           cmp dx, word ptr vesa.OutSeg
                           je  @E
                           call SwitchOutSegment
                           @E:
                         end;
                         {
                           calculate the position in source image
                         }
                         la:=longint(bpl)*(y0+r)+x0*(f div 8);
                         {
                           is the move inside 1 segment ?
                         }
                         if (longint(l)+o)<=65536 then
                            begin
                              {
                                download data from memory manager
                              }
                              xms.Read(mb,la,l,p);
                            end else
                            begin
                              {
                                download the first part
                              }
                              xms.Read(mb,la,65536-o,p);
                              {
                                switch to next segment
                              }
                              asm
                                mov dx, word ptr vesa.outseg
                                inc dx
                                call SwitchOutSegment
                              end;
                              {
                                set the destination to the start
                              }
                              p:=ptr(vesa.OutSegPos,0);
                              {
                                download the second part
                              }
                              xms.Read(mb,la+65536-o,longint(l)+o-65536,p);
                            end;
                       end;
                 end else
                 begin
                   {
                     image's bitcount doesn't corresponds to screen's
                   }
                   if maxavail>=l then
                      begin
                        getmem(p,l);
                        {
                          process line for every row of block
                        }
                        for r:=0 to b-1 do
                          begin
                            la:=longint(bpl)*(y0+r)+x0*(f div 8);
                            {
                              download data
                            }
                            xms.Read(mb,la,l,p);
                            {
                              process data
                            }
                            VESA24_PL(x,y+r,a,p,f);
                          end;
                        freemem(p,l);
                      end;
                 end
            end;

  Procedure VESA15162432_SETUP;
            var cm : PWordArray;
                md : word;
            function ModeExist(x,y:word):boolean;
                     var i:integer;
                     begin
                       modeexist:=false;
                       with vesa do
                       if modecount>0 then
                          for i:=0 to modecount-1 do
                              if (modelist[i].x=x) and
                                 (modelist[i].y=y) then
                                 begin
                                   modeexist:=true;
                                   break;
                                 end;
                     end;
            begin
              {
                make the driver public
              }
              GDrivers.SetupDriver( addr(VESA24_MC),
                                    addr(VESA24_MI),
                                    addr(VESA24_SM),
                                    addr(VESA24_PB),
                                    addr(VESA24_PL) );
              {
                get adapter informations
              }
              Ainfo.signature[0]:=' ';
              Ainfo.signature[1]:=' ';
              Ainfo.signature[2]:=' ';
              Ainfo.signature[3]:=' ';
              asm
                mov ax,ds
                mov es,ax
                mov di, offset AInfo
                mov ax,4F00h
                int 10h
              end;
              if (Ainfo.signature[0]='V') and
                 (Ainfo.signature[1]='E') and
                 (Ainfo.signature[2]='S') and
                 (Ainfo.signature[3]='A') then
                 begin
                   {
                     vesa bios detected
                   }
                   vesa.modecount:=0;
                   {
                     filter mode list
                   }
                   {cm:=Ainfo.Modelist;}
                   {md:=cm^[0];}
                   for md:=$0000 to $0FFF do
                   {while md<>$FFFF do}
                     begin
                       {
                         get info about mode
                       }
                       asm
                         mov ax,ds
                         mov es,ax
                         mov di,offset MInfo
                         mov cx,word ptr md
                         mov ax,4f01h
                         int 10h
                       end;
                       {
                         filtering condition
                       }
                       if ((MInfo.Attributes and 17)=17) and
                           (MInfo.bitsperpixel=vesa.bits) then
                          with vesa do
                          if modecount<MAX_MODECOUNT then
                             begin
                               {
                                 if there is free space in table of modes
                               }
                               if not modeexist(MInfo.width,MInfo.Height)
                                  then
                                  begin
                                    modelist[modecount].mode:=md;
                                    modelist[modecount].x:=minfo.width;
                                    modelist[modecount].y:=minfo.height;
                                    inc(modecount);
                                  end;
                             end else
                             begin
                               {
                                 no space in table of modes
                               }
                             end;
                       {cm:=addr(cm^[1]);}
                       {md:=cm^[0];}
                     end;
                 end else
                 begin
                   {
                     no vesa bios
                   }
                   vesa.modecount:=0;
                 end;
            end;

  Procedure VESA15_SETUP_NORM;
            var cm : PWordArray;
                md : word;
            begin
              {
                15 bit mode, normal
              }
              vesa.bits:=15;
              vesa.forcepl:=false;
              vesa.inverse:=false;
              VESA15162432_SETUP;
            end;

  Procedure VESA15_SETUP_INV;
            var cm : PWordArray;
                md : word;
            begin
              {
                15 bit mode, inverse color
              }
              vesa.bits:=15;
              vesa.forcepl:=true;
              vesa.inverse:=true;
              VESA15162432_SETUP;
            end;

  Procedure VESA16_SETUP_NORM;
            var cm : PWordArray;
                md : word;
            begin
              {
                16 bit mode, normal
              }
              vesa.bits:=16;
              vesa.forcepl:=false;
              vesa.inverse:=false;
              VESA15162432_SETUP;
            end;

  Procedure VESA16_SETUP_INV;
            var cm : PWordArray;
                md : word;
            begin
              {
                16 bit mode, inverse color
              }
              vesa.bits:=16;
              vesa.forcepl:=true;
              vesa.inverse:=true;
              VESA15162432_SETUP;
            end;

  Procedure VESA24_SETUP_NORM;
            var cm : PWordArray;
                md : word;
            begin
              {
                24 bit mode, normal
              }
              vesa.bits:=24;
              vesa.forcepl:=false;
              vesa.inverse:=false;
              VESA15162432_SETUP;
            end;

  Procedure VESA24_SETUP_INV;
            var cm : PWordArray;
                md : word;
            begin
              {
                24 bit mode, inverse color
              }
              vesa.bits:=24;
              vesa.forcepl:=true;
              vesa.inverse:=true;
              VESA15162432_SETUP;
            end;

  Procedure VESA32_SETUP_NORM;
            var cm : PWordArray;
                md : word;
            begin
              {
                32 bit mode, normal
              }
              vesa.bits:=32;
              vesa.forcepl:=false;
              vesa.inverse:=false;
              VESA15162432_SETUP;
            end;

  Procedure VESA32_SETUP_INV;
            var cm : PWordArray;
                md : word;
            begin
              {
                32 bit mode, inverse color
              }
              vesa.bits:=32;
              vesa.forcepl:=true;
              vesa.inverse:=true;
              VESA15162432_SETUP;
            end;

  Procedure REG_VESA2432;
            var di : TDriverInfo;
            begin
              {
                normal driver [15bit]
              }
              @di.setup:=addr(vesa15_setup_norm);
              di.name := VESA15NAME;
              GDrivers.RegisterDriver(di);
              {
                inverse driver [15bit]
              }
              @di.setup:=addr(vesa15_setup_inv);
              di.name := VESA15INV;
              GDrivers.RegisterDriver(di);
              {
                normal driver [16bit]
              }
              @di.setup:=addr(vesa16_setup_norm);
              di.name := VESA16NAME;
              GDrivers.RegisterDriver(di);
              {
                inverse driver [16bit]
              }
              @di.setup:=addr(vesa16_setup_inv);
              di.name := VESA16INV;
              GDrivers.RegisterDriver(di);
              {
                normal driver [24bit]
              }
              @di.setup:=addr(vesa24_setup_norm);
              di.name := VESA24NAME;
              GDrivers.RegisterDriver(di);
              {
                inverse driver [24bit]
              }
              @di.setup:=addr(vesa24_setup_inv);
              di.name := VESA24INV;
              GDrivers.RegisterDriver(di);
              {
                normal driver [32bit]
              }
              @di.setup:=addr(vesa32_setup_norm);
              di.name := VESA32NAME;
              GDrivers.RegisterDriver(di);
              {
                inverse driver [32bit]
              }
              @di.setup:=addr(vesa32_setup_inv);
              di.name := VESA32INV;
              GDrivers.RegisterDriver(di);
            end;

Begin

  REG_VESA2432;

end.