{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      GRAPHIC USER INTERFACE


  Programmed by:      Rozsnyo Daniel

  Version:            1.00.029
  Release date:       2001-02-23
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

Unit Gui;

Interface

 {x$DEFINE  log_render}
 {x$DEFINE  countpixels}



 Uses      Types,      { System 2001 v.6 basic types                        }
           bmp,
           memimage,
           Advmm;


 Const     USE_Acceleration = false;

           ObjSizeMax       = 1024;

 Type
           STDwindow =   record
                           Parent         : TProcessID;
                           HasTitle       : boolean;
                           Title          : string[80];
                           Position       : Tpoint;
                           Canvas         : TMemImage;
                           TitleButtCount : byte;
                           TitleButt      : array[0..7] of TTitleButton;
                           Status         : record
                                              InTitle : boolean;
                                              InDrag  : boolean;
                                              Active  : boolean;
                                              Hidden  : boolean;
                                              OnTop   : boolean;
                                              Locked  : boolean;
                                            end;
                           TitleMode      : record
                                              apply   : boolean;
                                              OldSize : integer;
                                            end;
                           TitleOffsetL   : integer;
                           TitleOffsetR   : integer;
                           TitleArea      : record
                                              override : boolean;
                                              pos      : Tpoint;
                                              size     : Tpoint;
                                            end;
                           IsMouse        : boolean;
                           Vmouse         : record
                                              pos      : Tpoint;
                                              lb       : boolean;
                                              rb       : boolean;
                                              olb      : boolean;
                                              orb      : boolean;
                                            end;
                           ObjectsCount   : word;
                           Objects        : PammPart;
                           ObjectLock     : integer;
                         end;

           PWindow   =   ^STDWindow;


           TStdObj   =   record
                           ID             : word;          {  2}
                           Position       : TPoint;        {  4}
                           Size           : TPoint;        {  4}
                           Text           : String[80];    { 81}
                           OnMouse        : boolean;       {  1}
                           Pressed        : boolean;       {  1}
                           Active         : boolean;       {  1}
                           Enabled        : boolean;       {  1}
                           Checked        : boolean;       {  1}
                           UserFlag       : byte;          {  1}
                           CommID         : word;          {  2}
                         end;                              { 99}

           TLineInObj =  record
                           std            : TstdObj;       { 99}
                           curpos         : byte;          {  1}
                           startpos       : byte;          {  1}
                           newtext        : string;        {256}
                           oldtext        : string;        {256}
                           isPasw         : boolean;       {  1}
                           noEdit         : boolean;       {  1}
                         end;                              {615}




 Var       GuiDesktop :  record
                           Size          : Tpoint;
                           ThemeDir      : string;
                           MousePos      : Tpoint;
                           Background    : record
                                             isbitmap : boolean;
                                             filename : string;
                                             position : Tpoint;
                                             bmp      : Pbmpfile;
                                             img      : PGD_AF_PutImage;
                                             DefColor : TColor;
                                           end;
                           Status        : record
                                             indrag   : boolean;
                                             Dragged  : boolean;
                                           end;
                           Rendered      : Longint;
                         end;

           {$IFDEF countpixels}

             pixelcount : longint;

           {$ENDIF}

           Obj     :      array[0..ObjSizeMax-1] of byte;
           ObjPtr  :      pointer;

           {
              public access to current window
           }
           w      : Pwindow;

 Procedure GUI_Determine_Background_image;

 Procedure GraphicInterface;

 procedure DrawAllTitleButts;
 procedure PaintWindow;
 procedure DrawWindowTitle;
 procedure PaintWindowOutline;

 procedure SwitchActive;

 function  Tr(i:string):string;

Implementation

  Uses     SysCalls,   { System 2001 v.6 system calls and message inserting }
           WinsApp,    { System 2001 v.6 wins applications                  }

           Ini,convert,font16,

           gdrivers,api;

  Var      GuiData     : record
                           GDRIVER         : word;
                           GMODE           : Word;
                           DRIVERNAME      : string[32];
                           Resolution      : Tpoint;
                           ResString       : string;
                           Language        : string;
                           Params          : string;
                         end;

           WinsData    : record
                           WinList         : array[0..255] of integer;
                           Windows         : integer;
                           UsedWindows     : array[0..255] of integer;
                           UsedCount       : integer;
                           RenderBuffer    : PRGBColorArr;
                           RenderImage     : Pmemimage;
                         end;

 procedure TrInit;
           var oi : string;
               s  : string;
           begin
             oi:=inifile;
             inifile:='settings\lang.ini';
             s:=readinistring('setup','sel');
             if s='0' then guidata.language:=''
                      else guidata.language:=readinistring('setup',s+'s');
             inifile:=oi;
           end;

 function  Tr(i:string):string;
           var oi : string;
           begin
             tr:=i;
             if guidata.language='' then exit;
             oi:=inifile;
             inifile:='settings\lang.ini';
             tr:=readinistring(guidata.language,i);
             if inierror<>IniOK then tr:=i;
             inifile:=oi;
           end;

 Procedure WinsIV;forward;

 Procedure GUI_Determine_Background_image;
           var fn : string;
           begin
             fn:=guidesktop.themedir+'back';
             if guidesktop.size.x<1000 then fn:=fn+'0';
             fn:=fn+integertostring(guidesktop.size.x)+'.bmp';
             with guidesktop.background do
              begin
                with position do
                 begin
                   x:=0;
                   y:=0;
                 end;
                filename:=fn;
                isbitmap:=fileexist(filename);
              end;
           end;

 Procedure GraphicInterface;
           const
               Sub_Wins      = 'WINS IV server';
               Sub_GDS       = 'Universal GD';
           var
               LocalMess         : TMessage;
           procedure CLOSE_APPS;
                     var i:integer;
                     begin
                       with kerneldata do
                       for i:=numofprocesses-1 downto 0 do
                           if (processdata[i].flags and (PROC_VISUAL or PROC_DEAD))>0 then
                           sendmessage(localmess.dest,processdata[i].id,
                                       PR_Kill,0,nil);
                     end;
           procedure CLOSE_GUI;
                     begin
                       CLOSE_APPS;
                       SendMessage(LocalMess.dest,LocalMess.dest,
                                   UP_message+99,0,nil);
                     end;

           procedure CloseAllSubs;
                     begin
                       if ToGraph<>0
                          then SendMessage( Process.ID, ToGraph,
                                            PR_Close, 0, nil)
                          else SendMessage( Process.ID,
                                            API_GetProcessID(Sub_GDS),
                                            PR_Close, 0, nil);
                       if ToWins<>0
                          then SendMessage( Process.ID, ToWins,
                                            PR_Close, 0, nil)
                          else SendMessage( Process.ID,
                                            API_GetProcessID(Sub_Wins),
                                            PR_Close, 0, nil);
                     end;

           begin
             LocalMess:=Message;
             Case LocalMess.Mess of

               PR_Init:
                 if TPR_Init(localmess.data^).param='?' then
                 begin
                   WriteLn('');
                   WriteLn(' GRAPHIC USER INTERFACE');
                   WriteLn('');
                   WriteLn('   usage:  gui [gds] [gd=DRIVER] [gms] [gm=MODE]');
                   WriteLn('');
                   WriteLn('   where');
                   WriteLn('           gds        list all drivers');
                   WriteLn('           gms        list all modes');
                   WriteLn('           gd=DRIVER  use this driver');
                   WriteLn('           gm=MODE    use this mode (write MODE as AxB)');
                   WriteLn('');
                   closeprocess;
                 end else
                 begin
                   {
                     store params locall for further use
                   }
                   GuiData.Params:=TPR_Init(localmess.data^).param;
                   {
                     register the GUI loader's handle
                   }
                   ToGui:=process.id;
                   writeln('Loading drivers ...');
                   inifile:='settings\system.ini';
                   {
                     determine, which driver we want to use
                   }
                   with guidata do
                        if pos('gd=',params)=0
                           then drivername:=readinistring('gui','driver')
                           else drivername:=paramvalue('gd=',params);
                   {
                     run 2 subparts of Gui - Graphic driver and Wins IV
                   }
                   ToGraph:=0;
                   RunInternal(addr(GD_HANDLE),PROC_DRIVER,Sub_GDS,'');
                   ToWins:=0;
                   RunInternal(addr(WinsIV),PROC_CONSOLE,Sub_Wins,'');
                   {
                     "2 round skip"
                   }
                   jump(UP_message+97);
                   {
                     Translator init
                   }
                   TrInit;
                 end;

               PR_Close,
               PR_Hibernate,
               PR_Kill:
                 begin
                   {
                     return to text mode / hard close
                   }
                   MouseSetTextSensitivity;
                   mousesetrange(80,25);
                   if mem[$0040:$0049]<>3 then
                      begin
                        {
                          if we was in graphic mode....
                        }
                        asm
                          mov ax,3
                          int 10h
                        end;
                        {
                          center the mouse
                        }
                        mousesetposition(40,12);
                        {
                          some menu for shell
                        }
                        writeln;
                        writeln('                                                   < help > < gui > < exit >');
                      end;
                   {
                     close font manager
                   }
                   Donefont;
                   {
                     close other GUI parts
                   }
                   CloseAllSubs;
                   {
                     close GUI loader
                   }
                   SendMessage( process.id, ToKernel, KE_StopProcess, 0,nil);
                   {
                     run text mode shell
                   }
                   RunShell;
                 end;

               UP_message+97:
                 begin
                   {
                     "1 round skip"
                   }
                   jump(UP_message+98);
                 end;

               UP_message+98:
                 begin
                   {
                     GDS load status
                   }
                   if ToGraph = 0 then
                      begin
                        {
                          exit from gui
                        }
                        Writeln('Error: GDS process not loaded properly !');
                        Jump(up_message+99);
                      end else
                      begin
                        {
                          get number of drivers
                        }
                        Writeln('GDS loaded. Getting number of drivers...');
                        SendMessage(process.id, ToGraph,
                                    GP_DRIVERSCOUNT,0,nil);
                      end;
                 end;

               GP_DRIVERSCOUNT:
                 begin
                   {
                     response from GDS, parameter is DRIVERSCOUNT : word
                   }
                   if word(localmess.data^)=0 then
                      begin
                        {
                           no driver found:
                        }
                        Writeln('Error: GDS doesn''t contains graphic driver(s) !');
                        {
                           exit loader
                        }
                        Jump(PR_CLOSE);
                        RunShell;
                      end else
                      begin
                        {
                           drivers found
                        }
                        Writeln('GDS number of drivers = ',word(localmess.data^));
                        {
                           get info about the last driver
                        }
                        guidata.gdriver:=word(localmess.data^)-1;
                        SendMessage(process.id, ToGraph,
                                    GP_DRIVERSNAME,2,addr(guidata.gdriver));
                        Writeln('GDS Searching...');
                      end;
                 end;

               GP_DRIVERSNAME:
                 if pos('gds',guidata.params)>0 then
                 begin
                   {
                     response from GDS, parameter is string
                     GDS LIST MODE
                   }
                   writeln(guidata.gdriver:3,' = ',string(localmess.data^));
                   if guidata.gdriver=0 then
                      begin
                        {
                          no more drivers - close process
                        }
                        closeprocess;
                      end else
                      begin
                        {
                          get name of next driver
                        }
                        dec(guidata.gdriver);
                        SendMessage(process.id, ToGraph,
                                    GP_DRIVERSNAME,
                                    2,addr(guidata.gdriver));
                      end
                 end else
                 begin
                   {
                     response from GDS, parameter is string
                     NORMAL MODE
                   }
                   if guidata.drivername=string(localmess.data^) then
                      begin
                        {
                          driver found
                        }
                        writeln('GDS driver found. Loading driver...');
                        SendMessage(Process.ID, ToGraph,
                                    GP_USEDRIVER,
                                    2, addr(guidata.gdriver))
                      end else
                      begin
                        {
                          not found
                        }
                        if guidata.gdriver=0 then
                           begin
                             {
                               no more drivers
                             }
                             writeln('Error: GUI loader can''t find the driver ('+guidata.drivername+')');
                             {
                               exit gui loader
                             }
                             closeprocess;
                           end else
                           begin
                             {
                               get name of next driver
                             }
                             dec(guidata.gdriver);
                             SendMessage(process.id, ToGraph,
                                         GP_DRIVERSNAME,
                                         2,addr(guidata.gdriver));
                           end;
                      end;
                 end;

               GP_USEDRIVER:
                 begin
                   {
                     response from GDS, driver is in use
                   }
                   WriteLn('GDS driver '+guidata.drivername+' loaded.');
                   WriteLn(guidata.drivername,
                           ' Searching for a video mode...');
                   {
                     determine resolution
                   }
                   with GuiData do
                   if pos('gm=',params)=0 then
                      begin
                        {
                           resolution is in file
                        }
                        ResString:=ReadIniString('gui','resolution');
                        if iniError<>iniOK then
                           begin
                             {
                                error in ini file
                             }
                             WriteLn('Error: system.ini -> gui -> resolution value not found !');
                             CloseProcess;
                           end;
                      end else
                      begin
                        {
                           resolution is in parameter
                        }
                        ResString:=ParamValue('gm=',params);
                      end;
                   {
                     resolve the resolution string
                   }
                   with guidata do
                    begin
                      {
                        initial settings
                      }
                      Resolution.x:=0;
                      Resolution.y:=0;
                      {
                        convert string to x,y
                      }
                      if pos('x',ResString)>0 then
                         begin
                           resolution.x:=stringtointeger(
                                           copy(ResString,
                                                1,
                                                pos('x',ResString)-1));
                           resolution.y:=stringtointeger(
                                           copy(ResString,
                                                pos('x',ResString)+1,
                                                255));
                         end;
                      {
                        test the results
                      }
                      if (resolution.x = 0) or
                         (resolution.y = 0) then
                         begin
                           {
                             wrong resolution setting
                           }
                           WriteLn('Error: Resolution not acceptable ! ('+
                                    ResString+')');
                           closeprocess;
                         end else
                         begin
                           {
                             resolution setting is ok
                           }
                           Write(drivername,' ');
                           if pos('gms',guidata.params)=0 then
                              Write('Resolution is ',resolution.x,' x ',
                                                     resolution.y,' pixels.');
                           Writeln('Getting number of modes...');
                           SendMessage(Process.ID, ToGraph,
                                       GP_MODECOUNT, 0, nil);
                         end;
                    end;
                 end;

               GP_MODECOUNT:
                 begin
                   {
                      response from GDS, modecount is in w
                   }
                   GuiData.GMode:=word(localmess.data^);
                   with GuiData do
                   if GMode=0 then
                      begin
                        {
                          this driver have no mode to switch into
                        }
                        WriteLn('Error: Driver provides 0 modes.');
                        CloseProcess;
                      end else
                      begin
                        {
                          we found some mode
                        }
                        WriteLn(DriverName+' Number of modes: ',
                                GMode);
                        dec(GMode);
                        WriteLn(guidata.drivername+' Searching...');
                        {
                          list modes
                        }
                        SendMessage(Process.ID, ToGraph,
                                    GP_MODEINFO, 2, addr(GMode));
                      end;
                 end;

               GP_MODEINFO:
                 if pos('gms',guidata.params)>0 then
                 with guidata do
                 begin
                   {
                     gms option - mode list
                     write informations about mode
                   }
                   Write(GMode:3,' = ',
                         TGP_ModeInfo(localmess.data^).size.x:4,' x ',
                         TGP_ModeInfo(localmess.data^).size.y:4,' @ ',
                         (TGP_ModeInfo(localmess.data^).bitcount and $7F):2);
                   if (TGP_ModeInfo(localmess.data^).bitcount and $80)=0
                      then WriteLn(' bit')
                      else WriteLn(' bit GRAY-SCALE');
                   {
                     get next mode info
                   }
                   if GMode=0 then
                      begin
                        {
                          no more modes
                        }
                        closeprocess;
                      end else
                      begin
                        {
                          try next mode
                        }
                        Dec(GMode);
                        SendMessage(Process.ID, ToGraph,
                                    GP_MODEINFO, 2, addr(GMode));
                      end;
                 end else
                 with guidata do
                 begin
                   {
                     test, if the mode is the one
                   }
                   if (TGP_ModeInfo(localmess.data^).size.x=resolution.x) and
                      (TGP_ModeInfo(localmess.data^).size.y=resolution.y) then
                      begin
                        {
                          mode found
                        }
                        WriteLn(DriverName+' Graphic mode found.');
                        WriteLn(DriverName+' Changing mode...');
                        SendMessage(Process.ID, ToGraph,
                                    GP_SETMODE, 2, addr(GMode));
                      end else
                      begin
                        {
                          mode not found
                        }
                        if GMode=0 then
                           begin
                             {
                               no more modes
                             }
                             WriteLn('Error: Desired graphic mode not found !');
                             closeprocess;
                           end else
                           begin
                             {
                               try next mode
                             }
                             Dec(GMode);
                             SendMessage(Process.ID, ToGraph,
                                         GP_MODEINFO, 2, addr(GMode));
                           end;
                      end
                 end;

               GP_SETMODE:
                 begin
                   {
                     response from GDS, that the mode was set
                     now determining the background image
                   }
                   guidesktop.themedir:=readinistring('gui','theme');
                   guidesktop.size:=guidata.resolution;
                   with guidesktop do
                     if copy(themedir,length(themedir),1)<>'\' then
                        themedir:=themedir+'\';
                   gui_determine_background_image;
                   guidesktop.background.defColor:=$3040C0;
                   {
                     loading fonts
                   }
                   norm:=LoadFont(guidesktop.themedir+'normal.fnt');
                   bold:=LoadFont(guidesktop.themedir+'bold.fnt');
                   taho:=LoadFont(guidesktop.themedir+'tahoma.fnt');
                   {
                     mouse setup
                   }
                   with guiDesktop.size do
                        begin
                          mousesetrange(x,y);
                          mousesetposition(x div 2,y div 2);
                        end;
                   MouseSetGraphSensitivity;
                   {
                     go to start up process...
                   }
                   jump(up_message+2);
                 end;

               UP_message+2:
                 begin
                   {
                     startup process
                   }
                   RunWinsApp('desktop','');
                   RunWinsApp('mouse','');
                   RunWinsApp('logo','');
                   RunWinsApp('login','');
                 end;

               UP_message+99 :
                 begin

                   {
                     this is end of GUI, we must switch to text mode if
                     we are not in text mode
                   }

                   jump(UP_message+100);
                 end;

               UP_message+100:
                 begin
                   {
                     kill current process and run the shell
                   }
                   CloseProcess;
                 end;

               UP_message+101:             { EXIT from GUI }
                 begin
                   Close_Gui;
                 end;

               UP_message+102:             { LOGOFF and run login }
                 begin
                   Close_Apps;
                   jump(UP_message+2);
                 end;

             end;

           end;

   Function  WinInArea(xx1,yy1,xx2,yy2,X1,Y1,X2,Y2:integer):boolean;
             begin
               {we must determine, if window is in array or
                if the array is not in window

                    66 77 88 99 00
                    66 77 88 99 00
                  11              11
                  11              11

                  22              22
                  22    wwwwww    22
                        w    w
                  33    w    w    33
                  33    w    w    33
                        w    w
                  44    wwwwww    44
                  44              44

                  55              55
                  55              55
                    66 77 88 99 00
                    66 77 88 99 00

                 W    - window (xx1,yy1)->(xx2,yy2)
                 1..0 - area (for render) (x1,y1)->(x2,y2)

               }
               WinInArea:=false;
               {

                    x2 xx1 xx2 x1
                    |  |   |   |

                  aaa          aaa
                    a  wwwww   a
                    a  w   w   a
                    a  wwwww   a
                  aaa          aaa

               }
               if x2<xx1 then exit;
               if x1>xx2 then exit;
               {
                        a    a
                   y2-  aaaaaa

                  yy1-   wwww
                         w  w
                  yy2-   wwww

                   y1-  aaaaaa
                        a    a
               }
               if y2<yy1 then exit;
               if y1>yy2 then exit;
               {and if we are here, then the part of window is in area }
               WinInArea:=true;
             end;

   Procedure MakeWinList;
             var i:integer;
             begin
               {
                  if the process table was changed, then we must
                  make list of available windows
               }
               with KernelData do
                    if true {ThereWasChange} then
                       begin
                     {$IFDEF log_render}
                     MemLog('Rebuilding the system of windows.');
                     {$ENDIF}
                         WinsData.Windows:=0;
                         For i:=0 to NumOfProcesses-1 do
                             if (ProcessData[i].Flags and PROC_VISUAL)>0 then
                                begin
                                   WinsData.WinList[WinsData.Windows]:=i;
                                   Inc(WinsData.Windows);
                                end;
                         {ThereWasChange:=false;}
                     {$IFDEF log_render}
                     MemLog('Number of windows: '+integertostring(winsdata.windows));
                     {$ENDIF}
                       end;
             end;

   Function  InBox(x,y,a,b:integer):boolean;
             begin
               inbox:=(x<=GuiDesktop.MousePos.x) and
                      (GuiDesktop.MousePos.x<(x+a)) and
                      (y<=GuiDesktop.MousePos.y) and
                      (GuiDesktop.MousePos.y<(y+b));
             end;

   Function  InWindow(PR:integer):boolean;
             begin
               with PWindow(kerneldata.processdata[PR].ds_ptr)^ do
                    InWindow:=InBox(position.x, position.y,
                                    canvas.width, canvas.height);
             end;

   function  Bigger(a,b:integer):integer;
             begin
               if a>b then bigger:=a else bigger:=b;
             end;

   function  Smaller(a,b:integer):integer;
             begin
               if a<b then smaller:=a else smaller:=b;
             end;

   procedure DrawAllTitleButts;
             var i:integer;
             begin
               with Pwindow(process.ds_ptr)^ do
                For i:=0 to titlebuttcount-1 do
                    begin
                      if status.active
                         then if titlebutt[i].onmouse
                                 then SetFont(norm,WinsTitleAO)
                                 else SetFont(norm,WinsTitleAI)
                         else SetFont(norm,WinsTitleDI);
                      canvas.drawstring(canvas.width-15
                                                    -titleoffsetR
                                                    -14*i,
                                        6,
                                        TitleButt[i].icon);
                    end;
             end;

   procedure DrawActiveWindowTitle;
             var s:string;
             begin
               Pwindow(process.ds_ptr)^.status.active:=true;
               if not Pwindow(process.ds_ptr)^.hastitle then exit;
               with Pwindow(process.ds_ptr)^ do
               with Pwindow(process.ds_ptr)^.Canvas do
                begin
                  LinearShadeBoxX(3+titleoffsetL,3,
                                  width-6-titleoffsetL-titleoffsetR,14,
                                  WinsTitleAL,WinsTitleAR);
                  LinearShadeBoxX(3+titleoffsetL,17,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleAL,winsbackcolor,64),
                                  mix(WinsTitleAR,winsbackcolor,64));
                  LinearShadeBoxX(3+titleoffsetL,18,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleAL,winsbackcolor,128),
                                  mix(WinsTitleAR,winsbackcolor,128));
                  LinearShadeBoxX(3+titleoffsetL,19,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleAL,winsbackcolor,192),
                                  mix(WinsTitleAR,winsbackcolor,192));
                  Setfont(norm,WinsTitleAT);
                  s:=title;
                  DrawStringLen(5+titleoffsetL,
                                4,
                                width-titleoffsetL
                                     -titleoffsetR
                                     -10-titlebuttcount*14,
                                s);
                  If titlebuttcount>0
                     Then DrawAllTitleButts;
                end;
             end;

   procedure DrawNonActiveWindowTitle;
             var s:string;
             begin
               Pwindow(process.ds_ptr)^.status.active:=false;
               if not Pwindow(process.ds_ptr)^.hastitle then exit;
               with Pwindow(process.ds_ptr)^ do
               with Pwindow(process.ds_ptr)^.Canvas do
                begin
                  LinearShadeBoxX(3+titleoffsetL,3,
                                  width-6-titleoffsetL-titleoffsetR,14,
                                  WinsTitleDL,WinsTitleDR);
                  LinearShadeBoxX(3+titleoffsetL,17,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleDL,winsbackcolor,64),
                                  mix(WinsTitleDR,winsbackcolor,64));
                  LinearShadeBoxX(3+titleoffsetL,18,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleDL,winsbackcolor,128),
                                  mix(WinsTitleDR,winsbackcolor,128));
                  LinearShadeBoxX(3+titleoffsetL,19,
                                  width-6-titleoffsetL-titleoffsetR,1,
                                  mix(WinsTitleDL,winsbackcolor,192),
                                  mix(WinsTitleDR,winsbackcolor,192));
                  Setfont(norm,WinsTitleDT);
                  s:=title;
                  DrawStringLen(5+titleoffsetL,
                                4,
                                width-titleoffsetL
                                     -titleoffsetR
                                     -10-titlebuttcount*14,
                                s);
                  If titlebuttcount>0
                     Then DrawAllTitleButts;
                end;
             end;

   procedure DrawWindowTitle;
             begin
               if Pwindow(process.ds_ptr)^.status.active
                  then DrawActiveWindowTitle
                  else DrawNonActiveWindowTitle;
             end;

   procedure PaintWindowOutline;
             begin
               with Pwindow(process.ds_ptr)^.Canvas do
                begin
                  SetColor(WinsBackColor);
                  box(2,20,width-4,2);
                  UnDipT(0,0,width,  height,  $FF);
                  UnDipT(1,1,width-2,height-2,$40);
                  {
                  SetColor(mix(WinsDarkColor,WinsBackColor,$FF));
                  Frame(0,0,width,  height);
                  SetColor(mix(WinsDarkColor,WinsBackColor,$80));
                  Frame(1,1,width-2,height-2);
                  }
                end;
             end;

   procedure PaintWindow;
             begin
               PaintWindowOutline;
               with Pwindow(process.ds_ptr)^.Canvas do
                    begin
                      SetColor(WinsBackColor);
                      Box(2,2,width-4,height-4);
                    end;
               DrawWindowTitle;
             end;

   procedure SwitchActive;
             var ca : word;
                 i  : integer;
             begin
               MakeWinList;
               for i:=0 to WinsData.Windows-1 do
                   if Pwindow(kerneldata.processdata[winsdata.
                              winlist[i]].ds_ptr)^.status.active then
                              begin
                                ca:=kerneldata.processdata[winsdata.
                                    winlist[i]].id;
                              end;
               SendMessage(ca,ToWins,WI_MakeInActive,0,nil);
               SendMessage(process.id,ToWins,WI_MakeActive,0,nil);
             end;

   {$I src\drivers\blckrend.pas }

   Procedure WinsIV;
             var m   : TMessage;
                 x1  : integer;
                 y1  : integer;
                 x2  : integer;
                 y2  : integer;
                 xx1 : integer;
                 yy1 : integer;
                 xx2 : integer;
                 yy2 : integer;
                 i   : integer;
                 y   : integer;
                 l   : integer;
                 w   : word;

                 MyP : Tprocess;

                 Win : PWindow;
                 Pid : TProcessID;

                 Fac : boolean;
                 f   : boolean;

                 wcol: trgbcolor;

                 inf : boolean;

             Procedure Event(m:word);
                       begin
                         sendmessage(process.id,pid,m,0,nil);
                       end;

             Procedure BeginWindow;
                       begin
                         win^.canvas.prepare;
                       end;

             Procedure ActualizeWindow;
                       var DTA: TWI_Render;
                       begin
                         if win^.canvas.needredraw then
                            with win^ do
                            begin
                              DTA.Min.x:=position.x+canvas.umin.x;
                              DTA.Min.y:=position.y+canvas.umin.y;
                              DTA.Max.x:=position.x+canvas.umax.x;
                              DTA.Max.y:=position.y+canvas.umax.y;
                              SendMessage(process.id,ToWins,WI_Render,
                                          SizeOf(TWI_Render),addr(DTA));
                              BeginWindow;
                            end;
                       end;

             Procedure ReShowWindow;
                       var DTA: TWI_Render;
                       begin
                         with win^ do
                            begin
                              DTA.Min.x:=position.x;
                              DTA.Min.y:=position.y;
                              DTA.Max.x:=position.x+canvas.width-1;
                              DTA.Max.y:=position.y+canvas.height-1;
                              SendMessage(process.id,ToWins,WI_Render,
                                          SizeOf(TWI_Render),addr(DTA));
                              BeginWindow;
                            end;
                       end;

             Function  InTitleButt(n:integer):boolean;
                       begin
                         intitlebutt:=inbox(Win^.Position.x+
                                            Win^.Canvas.Width
                                            -win^.titleoffsetR-17-14*n,
                                            Win^.Position.y+4,13,13);
                       end;

             Function  InTitleBar:boolean;
                       begin
                         if win^.titlearea.override then
                            InTitleBar:=
                              inbox( Win^.Position.x+win^.titlearea.pos.x,
                                     Win^.Position.y+win^.titlearea.pos.y,
                                     win^.titlearea.size.x,
                                     win^.titlearea.size.y) else
                            InTitleBar:=
                              win^.hastitle and
                              inbox( Win^.Position.x+3+win^.titleoffsetL,
                                     Win^.Position.y+3,
                                     Win^.Canvas.Width-6
                                                      -win^.titleoffsetL
                                                      -win^.titleoffsetR
                                                      -14*win^.
                                                      TitleButtCount,
                                     15);
                       end;

             Procedure ActivateTitleButt(n:integer);
                       begin
                         With Win^ do
                          begin
                            SetFont(norm,WinsTitleAO);
                            canvas.drawstring(canvas.width-15-14*n
                                              -titleoffsetR,6,
                                              TitleButt[n].icon);
                            TitleButt[n].onmouse:=true;
                          end;
                       end;

             Procedure PressTitleButt(n:integer);
                       begin
                         With Win^ do
                          begin
                            SetFont(norm,WinsTitleAP);
                            canvas.drawstring(canvas.width-15-14*n
                                              -titleoffsetR,6,
                                              TitleButt[n].icon);
                            TitleButt[n].pressed:=true;
                            TitleButt[n].onmouse:=true;
                          end;
                       end;

             Procedure DeActivateTitleButt(n:integer);
                       begin
                         With Win^ do
                          begin
                            if status.active
                               then SetFont(norm,WinsTitleAI)
                               else SetFont(norm,WinsTitleDI);
                            canvas.drawstring(canvas.width-15-14*n
                                              -titleoffsetR,6,
                                              TitleButt[n].icon);
                            TitleButt[n].onmouse:=false;
                          end;
                       end;

             Procedure MoveWindow(nx,ny:integer);
                       var ox,oy : integer;
                           mx,my : integer;
                           sx,sy : integer;
                           l     : integer;
                           newps : TPoint;
                       begin
                         with win^ do
                          begin
                            if (nx=position.x) and
                               (ny=position.y) then exit;
                            guidesktop.status.dragged:=true;
                            ox:=position.x;
                            oy:=position.y;
                            sx:=canvas.width;
                            sy:=canvas.height;
                            mx:=ox+sx-1;
                            my:=oy+sy-1;
                            newps.x:=nx;
                            newps.y:=ny;
                            sendmessage(process.id,pid,WI_move,
                                        sizeof(newps),addr(newps));
                          end;
                         {
                           Move actual window (win^) to new position (nx,ny)

                           1.
                                 xxxx
                                 x  x  yyyy
                                 xxxx  y  y
                                       yyyy

                           2.        3.       4.        5.

                                nnnn    oooo      nnnn        oooo
                              oon  n    o nnnn    n  noo    nnnn o
                              o n  n    o n  n    n  n o    n  n o
                              o nnnn    oon  n    nnnn o    n  noo
                              oooo        nnnn      oooo    nnnn

                           6.        7.       8.        9.
                              nnnn
                              n  n      oooo      nnnno     onnnn
                              n  n      nnnn      n  no     on  n
                              nnnn      n  n      n  no     on  n
                              oooo      n  n      nnnno     onnnn
                                        nnnn
                         }
                         with Win^ do
                          begin

                            Position.x:=nx;
                            Position.y:=ny;
                          end;

                          {if win^.canvas.bits<=24 then
                             begin

                               if win^.canvas.bits=24
                                  then PutImage(nx,ny,sx,sy,0,0,win^.canvas.mblock)
                                  else ReShowWindow;
                               }
                               {up
                               if (oy<0) and
                                  (ny>oy) then
                                  WinsRender(nx,0,
                                             nx+sx-1,ny-oy);
                               down
                               if (my>=guidesktop.size.y) and
                                  (ny<oy) then
                                  WinsRender(nx,guidesktop.size.y+ny-oy,
                                             nx+sx-1,guidesktop.size.y-1);
                               left
                               if (ox<0) and
                                  (nx>ox) then
                                  WinsRender(0,ny,
                                             nx-ox,ny+sy-1);
                               right
                               if (mx>=guidesktop.size.x) and
                                  (nx<ox) then
                                  WinsRender(guidesktop.size.x+nx-ox,ny,
                                             guidesktop.size.x-1,ny+sy-1);
                               }
                            { end
                             else} ReshowWindow;

                         {case 1}
                         if (nx>mx) or
                            (ny>my) or
                            (ox>(nx+sx-1)) or
                            (oy>(ny+sy-1)) then
                            begin
                              WinsRender(ox,oy,mx,my);
                              exit;
                            end;
                         if (ny+sy-1)<my then
                            {something down (2,4,6)}
                            begin
                              WinsRender(ox,ny+sy,mx,my);
                            end;
                         if ny>oy then
                            {something up (3,5,7)}
                            begin
                              WinsRender(ox,oy,mx,ny-1);
                            end;
                         if nx>ox then
                            {something on left side (2,3,9)}
                            begin
                              WinsRender(ox,bigger(oy,ny),nx-1,smaller(my,ny+sy-1));
                            end;
                         if (nx+sx-1)<mx then
                            {something on right side (4,5,8)}
                            begin
                              WinsRender(nx+sx,bigger(oy,ny),mx,smaller(my,ny+sy-1));
                            end;
                       end;

             procedure LoadWinPid(PR:integer);
                       begin
                         win:=KernelData.ProcessData[WinsData.WinList[PR]].DS_ptr;
                         pid:=KernelData.ProcessData[WinsData.WinList[PR]].ID;
                       end;

             procedure PutImageNow(x,y,a,b:integer;mb:PammPart);
                       var Pim : TGD_AF_Putimage;
                           i   : integer;
                       begin
                         Pim.Position.x:=x;
                         Pim.Position.y:=y;
                         Pim.Size.x:=a;
                         Pim.Size.y:=b;
                         Pim.BytePerLine:=a*3;
                         Pim.SourcePos.x:=0;
                         Pim.SourcePos.y:=0;
                         Pim.Image:=mb;
                         {
                           We do a direct call (needed for faster image
                           handling) This code simulates kernel's work -
                           sending a message
                         }
                         with KernelData do
                          for i:=0 to NumOfProcesses-1 do
                              if processdata[i].id=ToGraph then
                                 begin
                                   Process:=ProcessData[i];
                                   With Message do
                                    begin
                                      From:=ToWins;
                                      Dest:=ToGraph;
                                      Mess:=GD_AF_PutImage;
                                      Size:=sizeof(Pim);
                                      Data:=Addr(Pim);
                                    end;
                                   Process.handle;
                                   Process:=MyP;
                                   break;
                                 end;
                       end;

             function  AllNotActive : boolean;
                       var i: integer;
                       begin
                         AllNotActive:=false;
                         for i:=WinsData.Windows-1 downto 0 do
                             if Pwindow(kerneldata.processdata
                                [winsdata.winlist[i]].ds_ptr)^.
                                status.active then exit;
                         AllNotActive:=true;
                       end;

             begin
               m:=message;
               myp:=process;

               case m.mess of
                 PR_Init:
                   begin
                     ToWins:=Process.ID;
                     guidesktop.status.indrag:=false;
                     Force_MS_POS;
                     GuiDesktop.Rendered:=0;
                   end;

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     SendMessage( process.id,ToGUI,   PR_Kill,0,nil);
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;

                 CO_KB_Input:
                   begin

                     If TCO_KB_Input(m.data^).code=390 then
                        begin
                          SaveScreenShot;
                        end;

                     MakeWinList;
                     for i:=WinsData.Windows-1 downto 0 do
                         if Pwindow(kerneldata.processdata
                            [winsdata.winlist[i]].ds_ptr)^.status.active then
                         if not Pwindow(kerneldata.processdata
                            [winsdata.winlist[i]].ds_ptr)^.titlemode.apply then
                            begin

                              { SEND AS CHARACTER }

                              SendMessage(process.id,
                                          kerneldata.processdata
                                          [winsdata.winlist[i]].id,
                                          WI_Char,
                                          m.size,
                                          m.data);

                              { SEND AS WINS EVENT }

                              SendMessage(process.id,
                                          kerneldata.processdata
                                          [winsdata.winlist[i]].id,
                                          WI_Keycode+
                                          TCO_KB_Input(m.data^).code,
                                          0,nil);

                              { ALT F4 - SEND CLOSE WINDOW }

                              if (WI_Keycode+TCO_KB_Input(m.data^).code)=
                                  WI_KB_Alt_F4 then
                                  begin
                                    SendMessage(process.id,
                                                kerneldata.processdata
                                                [winsdata.winlist[i]].id,
                                                wi_CloseApp,
                                                0,nil);
                                  end;

                              exit;
                            end;
                   end;

                 CO_MS_ChangePos:
                   begin
                     Fac:=false;
                     inf:=false;
                     GuiDesktop.MousePos:=
                       TCO_MS_ChangePos(m.data^).NewPosition;
                     MakeWinList;
                     if winsdata.windows=0 then exit;
                     for i:=WinsData.Windows-1 downto 0 do
                         begin
                         loadwinpid(i);
                         if win^.status.indrag then
                            movewindow(
                              longint(win^.position.x)+
                              TCO_MS_ChangePos(m.data^).NewPosition.x-
                              TCO_MS_ChangePos(m.data^).OldPosition.x,
                              longint(win^.position.y)+
                              TCO_MS_ChangePos(m.data^).NewPosition.y-
                              TCO_MS_ChangePos(m.data^).OldPosition.y);
                         if InWindow(winsdata.winlist[i]) then
                            begin
                             with Win^ do
                              begin
                               if not status.hidden then
                               if ismouse then
                                  if not inf then
                                     begin
                                       {mouse change over window}
                                       if not status.indrag then
                                       begin
                                         vmouse.pos.x:=guidesktop.mousepos.x-position.x;
                                         vmouse.pos.y:=guidesktop.mousepos.y-position.y;
                                         Event(WI_OverWindow);
                                       end;
                                       inf:=true;
                                     end else
                                     begin
                                       ismouse:=false;
                                       Event(WI_OffWindow);
                                     end else
                                  if not inf then
                                     begin
                                      {to this time not over window, but now
                                       is the cursor on this window }
                                      Event(WI_OnWindow);
                                      vmouse.pos.x:=guidesktop.mousepos.x-position.x;
                                      vmouse.pos.y:=guidesktop.mousepos.y-position.y;
                                      Event(WI_OverWindow);
                                      inf:=true;
                                      ismouse:=true;
                                    end;

                               BeginWindow;

                               {
                                 CHECK TITLE BUTTONS
                                  - here are the on-mouse highlighting code
                               }
                               if TitleButtCount>0 then
                                  for y:=0 to TitleButtCount-1 do
                                      begin
                                        if (not TitleButt[y].onmouse) and
                                           (status.active) and
                                           InTitleButt(y) then
                                           if titlebutt[y].pressed
                                              then PressTitlebutt(y)
                                              else ActivateTitleButt(y);
                                        if TitleButt[y].onmouse and
                                           (not InTitleButt(y)) then
                                           DeActivateTitleButt(y);
                                      end;

                               ActualizeWindow;
                               win^.status.InTitle:=InTitleBar;
                              end;
                            end else
                            begin
                             with Win^ do
                              begin
                               BeginWindow;

                               if not status.hidden then
                               if ismouse then
                                  begin
                                    {now is off window, but before was on }
                                    ismouse:=false;
                                    Event(WI_OffWindow);
                                  end else
                                  begin
                                    {now is off, before was off}
                                    {nothing to do - no action}
                                  end;
                               {
                                 CHECK TITLE BUTTONS
                                  - deactivize if needed
                               }
                               if TitleButtCount>0 then
                                  for y:=0 to TitleButtCount-1 do
                                      begin
                                        if TitleButt[y].onmouse and
                                           (not InTitleButt(y)) then
                                           DeActivateTitleButt(y);
                                      end;

                               ActualizeWindow;
                               win^.status.InTitle:=false;
                              end;
                            end;
                         end;
                   end;

                 CO_MS_PressLeft :
                   begin
                     MakeWinList;
                     Fac:=false;
                     for i:=WinsData.Windows-1 downto 0 do
                         if InWindow(winsdata.winlist[i]) then
                            begin
                             loadWinPid(i);
                             BeginWindow;
                             with Win^ do
                              begin
                               {if it was click to active window}
                               if (not win^.status.hidden) and
                                  (not guidesktop.status.indrag) and
                                  (not fac) and
                                  {(status.active and (not vmouse.lb)) then
                                  begin
                                    fac:=true;
                                    vmouse.lb:=true;
                                    Event(WI_OnPress);
                                  end;
                                  }
                                  (status.active) then
                                  begin
                                    fac:=true;
                                    if not vmouse.lb then Event(WI_OnPress);
                                    vmouse.lb:=true;
                                  end;


                               {ACTIVATE}
                               if (not win^.status.hidden) and
                                  (not guidesktop.status.indrag) and
                                  (not fac) and
                                  (not status.active) then
                                  begin
                                    process:=KernelData.ProcessData
                                                        [WinsData.WinList[i]];
                                    drawactivewindowtitle;
                                    process:=Myp;
                                    event(WI_Activate);
                                    ActualizeWindow;
                                    {WE MUST DEACTIVATE THE CURRENT ACTIVE}
                                    for y:=0 to WinsData.Windows-1 do
                                        if y<>i then
                                        if Pwindow(kerneldata.processdata
                                           [winsdata.winlist[y]].DS_ptr)^.
                                           Status.Active then
                                           begin
                                             loadwinpid(y);
                                             beginwindow;
                                             process:=KernelData.ProcessData
                                                      [WinsData.WinList[y]];
                                             DrawNonActiveWindowTitle;
                                             event(WI_Deactivate);
                                             actualizewindow;
                                             process:=myp;
                                             loadwinpid(i);
                                             {
                                             Sendmessage(process.id,ToWins,
                                                    CO_MS_ReleaseLeft,0,nil);
                                             }
                                             Force_MS_POS;
                                             Sendmessage(process.id,ToWins,
                                                    CO_MS_PressLeft,0,nil);
                                           end;
                                    fac:=true; { dont do any further
                                                 activizations }
                                  end;


                               {START DRAG}
                               if status.active then
                               if status.InTitle then
                                  begin
                                    status.indrag:=true;
                                    guidesktop.status.indrag:=true;
                                    guidesktop.status.dragged:=false;
                                    event(WI_StartDrag);
                                  end;

                               {TITLE BUTTON FIRST PRESS}
                               if titlebuttcount>0 then
                               for y:=0 to titlebuttcount-1 do
                                   if titlebutt[y].onmouse then
                                      begin
                                        PressTitleButt(y);
                                      end;
                              end;
                             ActualizeWindow;
                            end;
                   end;

                 CO_MS_ReleaseLeft :
                   begin
                     MakeWinList;
                     for i:=WinsData.Windows-1 downto 0 do
                         begin
                           loadWinPid(i);
                           BeginWindow;
                           with win^ do
                            begin

                              if (not win^.status.hidden) and
                                 (not guidesktop.status.indrag) and
                                 (status.active and vmouse.lb) then
                                 Event(WI_OnRelease);

                              vmouse.lb:=false;

                              if titlebuttcount>0 then
                               for y:=0 to titlebuttcount-1 do
                                   if titlebutt[y].pressed then
                                      begin
                                        if titlebutt[y].onmouse then
                                           begin
                                             event(titlebutt[y].command);
                                             titlebutt[y].pressed:=false;
                                             ActivateTitleButt(y);
                                           end else
                                           begin
                                             titlebutt[y].pressed:=false;
                                             DeActivateTitleButt(y);
                                           end;
                                      end;
                            end;

                           {END DRAG}
                           if win^.status.indrag then
                              begin
                                if not guidesktop.status.dragged then
                                   Event(WI_TitleClick);
                                guidesktop.status.indrag:=false;
                                win^.status.indrag:=false;
                                event(WI_EndDrag);
                              end;
                           actualizewindow;
                         end;
                   end;

                 WI_ActivateMe,
                 WI_MakeActive:
                   begin
                     makewinlist;
                     for i:=WinsData.Windows-1 downto 0 do
                         if kerneldata.processdata[winsdata.
                            winlist[i]].ID=m.from then
                         begin
                           if (m.mess=WI_MakeActive) and
                              (Pwindow(kerneldata.processdata[winsdata.
                               winlist[i]].ds_ptr)^.status.active)
                              then break;
                           LoadWinPid(i);
                           BeginWindow;
                           process:=KernelData.ProcessData
                                    [WinsData.WinList[i]];
                           drawactivewindowtitle;
                           process:=Myp;
                           event(WI_Activate);
                           ActualizeWindow;
                           break;
                         end;
                   end;

                 WI_MakeInActive:
                   begin
                     makewinlist;
                     for i:=WinsData.Windows-1 downto 0 do
                         if kerneldata.processdata[winsdata.
                            winlist[i]].ID=m.from then
                         begin
                           if not Pwindow(kerneldata.processdata[winsdata.
                              winlist[i]].ds_ptr)^.status.active then break;
                           LoadWinPid(i);
                           BeginWindow;
                           process:=KernelData.ProcessData
                                    [WinsData.WinList[i]];
                           drawnonactivewindowtitle;
                           process:=Myp;
                           event(WI_Activate);
                           ActualizeWindow;
                           break;
                         end;
                   end;

                 WI_NewWindow:
                   begin
                     {

                       check for a new window and if it is not active,
                       then activize it

                     }
                     MakeWinList;
                     if winsdata.windows=0 then exit;
                     for i:=WinsData.Windows-1 downto 0 do
                         begin
                           loadwinpid(i);
                           with Win^ do
                            begin
                              if status.ontop then event(WI_newwindow);
                              BeginWindow;
                              if (not win^.status.hidden) and
                                 (not guidesktop.status.indrag) and
                                 (not status.active) and
                                 AllNotActive then
                                 begin
                                   process:=KernelData.ProcessData
                                            [WinsData.WinList[i]];
                                   drawactivewindowtitle;
                                   process:=Myp;
                                   event(WI_Activate);
                                   actualizewindow;
                                 end;
                            end;
                         end;
                   end;

                 WI_Render:
                   begin

                     with TWI_Render(m.data^) do
                          BlockRender(min,max,guidesktop.size);

                   end;

               end;
             end;


Begin
  objptr:=addr(obj);


 {$IFDEF countpixels}
  pixelcount := 0;
 {$ENDIF}
end.