{$F+,O+}
{  REAS ini file    [section]
                    item = value
                    nextitem = nextvalue
                    [nextsection]
                    ; comment text
}

unit ini;
interface

Const IniOK           = 0;
      Iniitemnotfound = 1;
      IniFileMissing  = 2;
      IniFileEmpty    = 3;
      IniFileReadOnly = 4;

var IniFile        : string;
    IniError       : byte;
    Inidata        : record
                       Section : string;
                       Item    : string;
                       Value   : string;
                       Number  : longint;
                     end;

    Function       ReadIniFile:byte;
    Function       ReadIniString(section,item:string):string;
    Function       ReadIniBoolean(section,item:string):boolean;
    Function       ReadIniValue(section,item:string):longint;
    Function       ReadIniColor(section,item:string):longint;
    Procedure      ChangeIni(section,item,value:string);
    Procedure      AddIniSection(section:string);
    Procedure      AddIniItem(section,item,value:string);
    Procedure      DeleteIniItem(section,item:string);
    Procedure      DeleteIniSection(section:string);

implementation

  Function  StringToInteger(s:string):longint;
            Var
              I : longint;
              J : integer;
              r : string;
            Begin
              r:=s;
              while copy(r,1,1)=' ' do r:=copy(r,2,255);
              i:=0;
              Val(r,i,j);
              if j<>0 then val(copy(r,1,j-1),i,j);
              StringToInteger:=i;
            End;

  Function ReadIniFile:byte;
            Label
              koniec;
            Var
              Ifile  : text;
              Search : string;
              Found  : boolean;
              New    : boolean;
              Temp   : string;
            Begin
              ReadIniFile:=1;
              Found:=false;
              Search:='['+Inidata.section+']';
              Assign(Ifile,IniFile);
              {$I-}
              Reset(Ifile);
              {$I+}
              if ioresult<>0 then
                 begin
                   readinifile:=IniFileMissing;
                   exit;
                 end;
              if eof(Ifile) then
                 begin
                   readinifile:=IniFileEmpty;
                   close(Ifile);
                   exit;
                 end;
              Repeat
                Readln(Ifile,Temp);
                If Temp=Search then
                   begin
                     New:=false;
                     Repeat
                       if eof(ifile) then new:=true;
                       Readln(Ifile,Temp);
                       if copy(temp,1,1) = ';' then new:=false;
                       If Pos('[',Temp)=1 then New:=true;
                       If Pos(Inidata.item+' = ',Temp)=1 then
                          begin
                            Delete(Temp,1,length(Inidata.item+' = '));
                            Inidata.value:=Temp;
                            Inidata.number:=stringtointeger(Temp);
                            ReadIniFile:=0;
                            Goto koniec;
                          end;
                     Until new=true;
                   end;
              Until Eof(Ifile);
              Inidata.value:='';
              Inidata.number:=0;
            koniec:
              Close(Ifile);
            End;

Function  StringToBoolean(s:string):boolean;
          Begin
            StringToBoolean:=false;
            If s='yes' then StringToBoolean:=true;
            If s='Yes' then StringToBoolean:=true;
            If s='YES' then StringToBoolean:=true;
            If s='true' then StringToBoolean:=true;
            If s='True' then StringToBoolean:=true;
            If s='TRUE' then StringToBoolean:=true;
          End;

Function  ReadIniBoolean(section,item:string):boolean;
          begin
            inidata.section:=section;
            inidata.item:=item;
            inierror:=readinifile;
            readiniboolean:=stringtoboolean(inidata.value);
          end;

Function  ReadIniString(section,item:string):string;
          begin
            inidata.section:=section;
            inidata.item:=item;
            inierror:=readinifile;
            readinistring:=inidata.value;
          end;

Function  ReadIniValue(section,item:string):longint;
          begin
            inidata.section:=section;
            inidata.item:=item;
            inierror:=readinifile;
            readinivalue:=inidata.number;
          end;

Procedure ChangeIni(section,item,value:string);
          var fi,fo : text;
              t,u   : string;
          begin
            assign(fi,inifile);
            assign(fo,'~rename.tmp');
            {$I-}
            Reset(fi);
            {$I+}
            if ioresult<>0 then
               begin
                 inierror:=IniFileMissing;
                 exit;
               end;
            {$I-}
            ReWrite(fo);
            {$I+}
            if ioresult<>0 then
               begin
                 inierror:=IniFileReadOnly;
                 close(fi);
                 exit;
               end;
            {
              copy INI -> ~rename.tmp
            }
            while not(eof(fi)) do begin
                                    readln(fi,t);
                                    writeln(fo,t);
                                  end;
            close(fi);
            close(fo);
            erase(fi);
            assign(fi,'~rename.tmp');
            assign(fo,inifile);
            reset(fi);
            rewrite(fo);
            t:='';
            while not(eof(fi)) do begin
                                    readln(fi,u);
                                    writeln(fo,u);
                                    if u='['+section+']' then
                                       while not(eof(fi)) and
                                             not((copy(t,1,1)='[')) do
                                             begin
                                               readln(fi,t);
                                               if copy(t,1,length(item)+3)=(item+' = ')
                                                  then t:=item+' = '+value;
                                               writeln(fo,t);
                                             end;
                                  end;
            close(fi);
            close(fo);
            erase(fi);
            inierror:=IniOK;
          end;

Procedure DeleteIniSection(section:string);
          var fi,fo : text;
              t     : string;
              u     : boolean;
          begin
            assign(fi,inifile);
            assign(fo,'~rename.tmp');
            reset(fi);
            rewrite(fo);
            while not(eof(fi)) do begin
                                    readln(fi,t);
                                    writeln(fo,t);
                                  end;
            close(fi);
            close(fo);
            erase(fi);
            assign(fi,'~rename.tmp');
            assign(fo,inifile);
            reset(fi);
            rewrite(fo);
            u:=true;
            while not(eof(fi)) do begin
                                    readln(fi,t);
                                    if t=('['+section+']') then u:=false;
                                    if (t<>('['+section+']'))and
                                       (t[1]='[') then begin
                                                         u:=true;
                                                         writeln(fo,'');
                                                       end;
                                    if u then writeln(fo,t);
                                  end;
            close(fi);
            close(fo);
            erase(fi);
          end;

Procedure DeleteIniItem(section,item:string);
          var fi,fo : text;
              t,u   : string;
          begin
            assign(fi,inifile);
            assign(fo,'~rename.tmp');
            reset(fi);
            rewrite(fo);
            while not(eof(fi)) do begin
                                    readln(fi,t);
                                    writeln(fo,t);
                                  end;
            close(fi);
            close(fo);
            erase(fi);
            assign(fi,'~rename.tmp');
            assign(fo,inifile);
            reset(fi);
            rewrite(fo);
            t:='';
            while not(eof(fi)) do begin
                                    readln(fi,u);
                                    writeln(fo,u);
                                    if u='['+section+']' then
                                       while not(eof(fi)) and
                                             not((copy(t,1,1)='[')) do
                                             begin
                                               readln(fi,t);
                                               if copy(t,1,length(item)+3)<>(item+' = ')
                                                  then writeln(fo,t);
                                             end;
                                  end;
            close(fi);
            close(fo);
            erase(fi);
          end;

Procedure AddIniItem(section,item,value:string);
          var fi,fo : text;
              t,u   : string;
          begin
            assign(fi,inifile);
            assign(fo,'~rename.tmp');
            reset(fi);
            rewrite(fo);
            while not(eof(fi)) do begin
                                    readln(fi,t);
                                    writeln(fo,t);
                                  end;
            close(fi);
            close(fo);
            erase(fi);
            assign(fi,'~rename.tmp');
            assign(fo,inifile);
            reset(fi);
            rewrite(fo);
            t:='';
            while not(eof(fi)) do begin
                                    readln(fi,u);
                                    writeln(fo,u);
                                    if u='['+section+']' then
                                       begin
                                         t:=item+' = '+value;
                                         writeln(fo,t);
                                         while not(eof(fi)) and
                                               not((copy(t,1,1)='[')) do
                                               begin
                                                 readln(fi,t);
                                                 writeln(fo,t);
                                               end;
                                       end;
                                  end;
            close(fi);
            close(fo);
            erase(fi);
          end;

Procedure AddIniSection(section:string);
          var f : text;
              t : string;
          begin
            assign(f,inifile);
            append(f);
            t:='['+section+']';
            writeln(f,t);
            writeln(f,'');
            close(f);
          end;

Function  ReadIniColor(section,item:string):longint;
          var s : string;
              i : integer;
              r : longint;
          begin
            s:=readinistring(section,item);
            ReadIniColor:=$808080;
            if inierror<>iniOK then exit;
            if length(S)<>7 then exit;
            if s[1]<>'#' then exit;
            for i:=2 to 7 do
                begin
                  if (s[i]>='0') and (s[i]<='9') then
                     begin
                       dec(s[i],ord('0'));
                       continue;
                     end;
                  if (s[i]>='A') and (s[i]<='F') then
                     begin
                       dec(s[i],ord('A'));
                       inc(s[i],10);
                       continue;
                     end;
                  exit;
                end;
            r:=0;
            for i:=2 to 7 do
                begin
                  r:=r*16;
                  r:=r or ord(s[i]);
                end;
            ReadIniColor:=r;
          end;

begin
end.