
{

  System 2001 v.6 A
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      OBJECT FUNCTIONS


  Programmed by:      Rozsnyo Daniel

  Version:            1.01.007 A
  Release date:       2001-01-24
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

Unit Objects;


{x$DEFINE debug_insert}
{x$DEFINE debug_mess}

Interface

 Uses    Types,AdvMM;

 Const   MAX_LOCALMESSSIZE = 4096;

         STD_BuffSize      = 32768;
         STD_DataBuffSize  = 32768;

 Type    TMessageSystem = object

                            ins_mess : longint;
                            ins_byte : longint;

                            constructor Init;
                            procedure   SetUser(pid:TProcessID);
                            procedure   InsertMessage( target : TProcessID;
                                                       message: Word);
                            procedure   InsertMessageParam( target : TProcessID;
                                                            message: Word;
                                                            psize  : Word;
                                                            param  : pointer);
                            function    IsMessage : boolean;
                            function    GetBufferSize : word;
                            function    UsedBuffer : word;
                            function    GetDataBufferSize : word;
                            procedure   GetMessage(p:pointer);
                            procedure   ListMessages;
                            destructor  Done;

                            private
                              Sender     : TProcessID;
                              BufferAddr : pointer;
                              DataBuffer : pointer;
                              DataBufSize: word;
                              BufferSize : word;
                              Allocated  : word;
                              Free       : word;
                              Start      : word;
                              SizeLimit  : word;
                              procedure NoMemError;
                              procedure CopyData(l:word);
                              procedure GetExtMess(p:pointer);
                              procedure PutData(a:pointer;l:word);
                              procedure GetData(a:pointer;l:word);
                          end;

         PMessageSystem = ^TMessageSystem;


         TDateTimeObj   = object
                            Year      : word;
                            Month     : word;
                            Day       : word;
                            DayOfWeek : word;
                            Hour      : word;
                            Minute    : word;
                            Second    : word;
                            Milisec   : word;
                            procedure GetFromSystem;
                            procedure SetAs(ye,mo,da,hr,mi,se,ms:word);
                          end;

         TTimeCounter   = object
                            StartTime : record
                                          h  : word;
                                          m  : word;
                                          s  : word;
                                          t  : word;
                                        end;
                            EndTime   : record
                                          h  : word;
                                          m  : word;
                                          s  : word;
                                          t  : word;
                                        end;
                            procedure Start;
                            procedure Stop;
                            function  Diff:longint;
                          end;

         PStrListItem   = ^TStrListItem;

         TStrListItem   = record
                            back      : PSTRlistItem;
                            next      : PSTRlistItem;
                            data      : string[247];
                          end;

         TStringList    = object

                            private

                            list      : PStrListItem;
                            current   : PStrListItem;
                            stdsize   : integer;

                            public

                            procedure   Clear;
                            procedure   Add(s:string);

                            procedure   Start;
                            function    Read:string;
                            procedure   Next;
                            procedure   Back;
                            function    EOF:boolean;
                            procedure   Delete;

                            procedure   Seek(n:integer);

                            procedure   SetSize(s:integer);

                            constructor init;
                            destructor  done;
                          end;

         PStringList    = ^TStringList;

         TLongList      = object

                            mBlock      : PammPart;
                            Count       : Longint;
                            LineLen     : integer;

                            constructor Init;

                            function    Alloc(linesize:integer;lines:longint):boolean;
                            procedure   DeAlloc;

                            procedure   SetLine(i:longint;s:string);
                            procedure   GetLine(i:longint;var s:string);
                            function    LoadFromFile(fn:string;var overh:longint):boolean;
                            function    SaveToFile  (fn:string):boolean;

                            destructor  Done;

                          end;

         PLongList      = ^TLongList;


Implementation

  uses convert,dos;


  procedure TdatetimeObj.GetFromSystem;
            begin
              asm
                cli
              end;
              getdate(year,month,day,dayofweek);
              gettime(hour,minute,second,milisec);
              asm
                sti
              end;
            end;

  procedure TdatetimeObj.SetAs(ye,mo,da,hr,mi,se,ms:word);
            begin
              Year      := ye;
              Month     := mo;
              Day       := da;
              Hour      := hr;
              Minute    := mi;
              Second    := se;
              Milisec   := ms;
              {
              CountDayOfWeek;
              }
            end;


  Type  TMessageSavePosition = (AfterMessage,InExtended);

         {
           AfterMessage: The data is stored immediatelly after message

           InExtended:   The data is stored in extended (XMS) memory and
                         a extended memory allocation block is stored after
                         the message (TMemoryBlock)

         }

        TExtendedMessage = record
                             Orig  : Tmessage;
                             Where : TMessageSavePosition;
                           end;

  Type  AByte  = array[0..1] of byte;

 function    TMessageSystem.IsMessage : boolean;
             begin
               IsMessage:=Allocated>0;
             end;

 function    TMessageSystem.GetBufferSize : word;
             begin
               GetBufferSize:=BufferSize;
             end;

 function    TMessageSystem.UsedBuffer : word;
             begin
               UsedBuffer:=Allocated;
             end;

 function    TMessageSystem.GetDataBufferSize : word;
             begin
               GetDataBufferSize:=DataBufSize;
             end;

 constructor TMessageSystem.Init;
             begin
               {
                 Initialize the message system
               }
               if maxavail<STD_DataBuffSize
                  then DataBufSize:=maxavail
                  else DataBufSize:=STD_DataBuffSize;
               if DataBufSize<>0 then GetMem(DataBuffer,DataBufSize);
               if maxavail<STD_BuffSize
                  then BufferSize:=maxavail
                  else BufferSize:=STD_BuffSize;
               if BufferSize<>0 then GetMem(BufferAddr,BufferSize);
               Allocated:=0;
               Free:=BufferSize;
               Sender:=0;
               SizeLimit:=MAX_LOCALMESSSIZE;
               Start:=0;
               ins_mess:=0;
               ins_byte:=0;
             end;

 procedure TMessageSystem.SetUser(pid:TProcessID);
           begin
             {
               Set the sender
             }
             Sender:=pid;
           end;

 procedure TMessageSystem.InsertMessage(target:TProcessID;
                                        message:Word);
           begin
             {
               Reinsert the message with another procedure
             }
             InsertMessageParam(target,message,0,nil);
           end;

 procedure TMessageSystem.InsertMessageParam(target:TProcessID;
                                             message,psize:Word;
                                             param:pointer);
           Var InsData : TExtendedMessage;
           begin
             inc(ins_mess);
             inc(ins_byte,psize);
             {
             if message<>0 then
             memlog('Ins msg '+integertostring(sender)+'->'+
                    integertostring(target)+':'+integertostring(message)+
                     '('+integertostring(psize)+')');

             }
             {$IFDEF debug_insert}
             {if message<>0 then}
             writeln('Ins msg ',sender,'->',target,':',message,
                     '(',psize,')  st=',start,' fr=',free,' al=',allocated);
             {$ENDIF}
             If PSize<=SizeLimit then
                begin
                  {
                    Message parameter's size is smaller than limit,
                    message is inserted to buffer
                  }
                  If Free>=(SizeOf(Tmessage)+Psize) then
                     begin
                       with InsData.Orig do
                         begin
                           From:=Sender;
                           Dest:=target;
                           Mess:=Message;
                           Size:=Psize;
                           Data:=nil;
                           {
                             however the parameter pointer is nil, the
                             data of Size size is stored after the
                             message (if size>0)
                           }
                         end;
                       InsData.Where:=AfterMessage;
                       PutData(addr(InsData),SizeOf(TExtendedMessage));
                       if Psize>0 then PutData(Param,Psize);
                     end else NoMemError;
                end else
                begin
                  {
                    Message parameter's size is larger than limit
                  }
                  { we must upload the data to XMS }

                end;
           end;

 destructor TMessageSystem.Done;
            begin
              if BufferSize>0 then freemem(BufferAddr,BufferSize);
              if DataBufSize>0 then freemem(DataBuffer,DataBufSize);
            end;

 procedure TMessageSystem.NoMemError;
           const bl = $1F20;
           var i    : integer;
               vmem : array[0..1999] of word;
               Cur  : word;
               hard_exit : procedure;
           begin
             {text mode error only}
             asm
               mov ax,300h
               mov bh,0
               int 10h
               mov cur,dx
             end;
             {store old screen and show blue screen}
             for i:=0 to 1999 do
                 begin
                   vmem[i]:=memw[$B800:i*2];
                   memw[$B800:i*2]:=bl;
                 end;
             asm
               mov ax,200h
               mov bh,0
               xor dx,dx
               int 10h
             end;
             for i:=0 to 2 do writeln;
             writeln('   SYSTEM 2001 version 6');
             writeln('   -------------------------------------------------------------------------');
             writeln;
             writeln('   There is no memory to store the message. ');
             writeln;
             writeln;
             writeln;
             writeln;
             writeln('      ENTER     = Continue');
             writeln;
             writeln('      OTHER KEY = Restart');
             asm
               MOV AH,8
               INT 21H
               XOR AH,AH
               mov i, ax
             end;
             if i<>13 then
                begin
                  @hard_exit:=ptr($FFFF,0);
                  hard_exit;
                end;
             {restore screen }
             for i:=0 to 1999 do
                 memw[$B800:i*2]:=vmem[i];
             asm
               mov ax,200h
               mov bh,0
               mov dx,cur
               int 10h
             end;
           end;

 procedure TMessageSystem.GetMessage(p:pointer);
           Var ExtMess : TExtendedMessage;
           begin
             if Allocated=0 then exit;

             GetExtMess(addr(ExtMess));

             TMessage(p^):=ExtMess.Orig;

             { handle the parameter }
             if ExtMess.Orig.Size=0 then exit;
             if ExtMess.Where = AfterMessage then
                begin
                  TMessage(p^).data:=DataBuffer;
                  CopyData(ExtMess.Orig.Size);
                  exit;
                end;
             if ExtMess.Where = InExtended then
                begin
                  { we must download the data from XMS }

                  exit;
                end;
           end;

 procedure TMessageSystem.CopyData(l:word);
           begin
             GetData(DataBuffer,l);
           end;

 procedure TMessageSystem.GetExtMess(p:pointer);
           begin
             GetData(p,sizeof(TextendedMessage));
           end;

 procedure TMessageSystem.PutData(a:pointer;l:word);
           var s,o   : word;
               s2,o2 : word;
           begin
             {
               Inserts the defined amount of data to end of buffer
             }
             if (longint(Start)+Allocated+l)>buffersize then
                for s:=0 to l-1 do
                    Abyte(BufferAddr^)
                      [(longint(s)+Start+Allocated) mod Buffersize]:=
                      Abyte(a^)[s]
                else
                begin
                  s  := seg(a^);
                  o  := ofs(a^);
                  s2 := seg(Abyte(BufferAddr^)[Start+Allocated]);
                  o2 := ofs(Abyte(BufferAddr^)[Start+Allocated]);
                  asm
                    mov cx,l
                    mov di,o2
                    mov ax,s2
                    mov es,ax
                    mov si,o
                    mov ax,s
                    push ds
                    mov ds,ax
                    cld
                    rep movsb
                    pop ds
                  end;
                end;
             Inc(Allocated,l);
             Dec(Free,l);
           end;

 procedure TMessageSystem.GetData(a:pointer;l:word);
           var s,o   : word;
               s2,o2 : word;
           begin
             {
               Returns the defined amount of data from begining of buffer
             }
             if (longint(Start)+Allocated+l)>buffersize then
                for s:=0 to l-1 do
                    Abyte(a^)[s]:=
                      Abyte(BufferAddr^)
                      [(longint(s)+Start) mod Buffersize]
                else
                begin
                  s  := seg(Abyte(BufferAddr^)[Start]);
                  o  := ofs(Abyte(BufferAddr^)[Start]);
                  s2 := seg(a^);
                  o2 := ofs(a^);
                  asm
                    mov cx,l
                    mov di,o2
                    mov ax,s2
                    mov es,ax
                    mov si,o
                    mov ax,s
                    push ds
                    mov ds,ax
                    cld
                    rep movsb
                    pop ds
                  end;
                end;
             Start:=(longint(Start)+l) mod BufferSize;
             Dec(Allocated,l);
             Inc(Free,l);
           end;

             {
             for i:=0 to l-1 do
                 Abyte(a^)[i]:=Abyte(BufferAddr^)[(i+Start) mod BufferSize];
             }

 procedure TMessageSystem.ListMessages;
           var i : longint;
               e : Textendedmessage;
               o : longint;
           begin
             writeln;
             if allocated<0 then
                begin
                  writeln('No messages.');
                  exit;
                end;
             o:=0;
             while allocated>o do
                   begin
                     for i:=0 to sizeof(e)-1 do
                         Abyte(addr(e)^)[i]:=Abyte(BufferAddr^)[(o+i+Start) mod BufferSize];
                     if e.orig.mess=0 then continue;
                     write ('Mess ',e.orig.mess:5,
                             ' from ',e.orig.from:5,
                             ' to ',e.orig.dest:5,
                             ' (',e.orig.size:5,' bytes ) ');
                     o:=o+e.orig.size+sizeof(e);
                     case e.orig.mess of
                       $0001 : writeln('KE_StartProcess');
                       $0005 : writeln('KE_StopProcess');
                       $0006 : writeln('KE_LineIn');
                       $0008 : writeln('PR_Init');
                       $000B : writeln('PR_Kill');
                       $0038 : writeln('CO_MS_ChangePos');

                       $0100 : writeln('WI_Render');
                       UP_message..$FFFF :
                               Writeln('UP_Message+',e.orig.mess-UP_message);
                       else writeln('???');
                     end;
                   end;
             {for i:=1 to 10000000 do;
             for i:=1 to 10000000 do;}
           end;

 procedure   TStringList.Clear;
             begin
               if list=nil then exit;
               Start;
               while current^.next<>nil do
                begin
                  current:=current^.next;
                  if current^.back<>nil then
                     begin
                       FreeMem(current^.back,StdSize+8);
                       current^.back:=nil;
                     end;
                end;
               FreeMem(current,StdSize+8);
               list:=nil;
               current:=nil;
             end;

 procedure   TStringList.Add(s:string);
             begin
               if (current<>nil) then
                  while current^.next<>nil do current:=current^.next;
               if list=nil then
                  begin
                    GetMem(list,StdSize+8);
                    current:=list;
                    current^.back:=nil;
                    current^.next:=nil;
                    current^.data:=copy(s,1,stdsize-1);
                  end else
                  begin
                    GetMem(current^.next,StdSize+8);
                    current^.next^.back:=current;
                    current:=current^.next;
                    current^.next:=nil;
                    current^.data:=copy(s,1,stdsize-1);
                  end;
             end;

 procedure   TStringList.Start;
             begin
               current  := list;
             end;

 function    TStringList.Read:string;
             begin
               if current=nil
                  then read:=''
                  else read:=current^.data;
             end;

 procedure   TStringList.Next;
             begin
               if current<>nil then
               current:=current^.next;
             end;

 procedure   TStringList.Delete;
             var todel : PStrListItem;
             begin
               if current<>nil then
                  begin
                    todel:=current;
                    if current^.back<>nil then
                       current^.back^.next:=current^.next;
                    if current^.next<>nil then
                       current^.next^.back:=current^.back;
                    if current=list then list:=current^.next;
                    current:=current^.next;
                    freemem(todel,StdSize+8);
                  end;
             end;

 procedure   TStringList.Back;
             begin
               if current^.back<>nil
                  then current:=current^.back;
             end;

 function    TStringList.EOF:boolean;
             begin
               EOF:=current=nil;
             end;

 procedure   TStringList.Seek(n:integer);
             var i:integer;
             begin
               if n>=0 then
                  begin
                    start;
                    if n>0 then
                    for i:=1 to n do self.Next;
                  end;
             end;

 constructor TStringList.init;
             begin
               list      := nil;
               current   := nil;
               StdSize   := 64;
             end;

 procedure   TStringList.SetSize(s:integer);
             begin
               if (s>=16) and (s<=256) then
               if (s<>stdsize) then
                  begin
                    Clear;
                    StdSize:=s;
                  end;
             end;

 destructor  TStringList.done;
             begin
               self.clear;
             end;

 constructor TLongList.Init;
             Begin
               mblock:=nil;
               count:=0;
               linelen:=0;
             end;

 function    TLongList.Alloc(linesize:integer;lines:longint):boolean;
             var memneeded : longint;
             Begin
               DeAlloc;
               count:=lines;
               memneeded:=count*linesize;
               if (memneeded mod 1024)>0 then inc(memneeded,1024);
               mblock:=xms.Alloc(memneeded div 1024);
               Alloc:=mblock<>nil;
               if mblock=nil then
                  begin
                    count:=0;
                    linelen:=0;
                  end else linelen:=linesize;
             end;

 procedure   TLongList.DeAlloc;
             Begin
               if mblock<>nil then xms.Dealloc(mblock);
             end;

 procedure   TLongList.SetLine(i:longint;s:string);
             Begin
               if mblock<>nil then
                  xms.Write(mblock,i*LineLen,ord(s[0])+1,addr(s));
             end;

 procedure   TLongList.GetLine(i:longint;var s:string);
             Begin
               if mblock<>nil then
                  xms.Read(mblock,i*LineLen,linelen,addr(s));
             end;

 function    TLongList.LoadFromFile(fn:string;var overh:longint):boolean;
             var L : string;
                 F : text;
                 c : longint;
             Begin
               LoadFromFile:=false;
               while copy(fn,1,1)=' ' do fn:=copy(fn,2,255);
               while copy(fn,ord(fn[0]),1)=' ' do dec(fn[0]);
               if fn='' then exit;
               assign(f,fn);
               {$I-}
               reset(f);
               {$I+}
               if ioresult<>0 then exit;
               c:=0;
               while not eof(f) do
                     begin
                       readln(f,l);
                       inc(c);
                     end;
               close(f);
               if c>0 then
                  begin
                    inc(c,overh);
                    overh:=c;
                    if not Alloc(256,c) then exit;
                    reset(f);
                    c:=0;
                    while not eof(f) do
                          begin
                            readln(f,l);
                            SetLine(c,l);
                            inc(c);
                          end;
                    close(f);
                  end;
               LoadFromFile:=true;
             end;

 function    TLongList.SaveToFile  (fn:string):boolean;
             Begin
             end;

 destructor  TLongList.Done;
             Begin
               DeAlloc;
             end;

 procedure   TTimeCounter.Start;
             begin
               With StartTime do Dos.GetTime(h,m,s,t);
             end;

 procedure   TTimeCounter.Stop;
             begin
               With EndTime do Dos.GetTime(h,m,s,t);
             end;

 function    TTimeCounter.Diff:longint;
             var h,m,s,t : integer;
             begin
               h:=integer(EndTime.h)-integer(StartTime.h);
               m:=integer(EndTime.m)-integer(StartTime.m);
               s:=integer(EndTime.s)-integer(StartTime.s);
               t:=integer(EndTime.t)-integer(StartTime.t);
               if h<0 then h:=h+24;
               diff:=longint(t)+
                     longint(s)*100+
                     longint(m)*100*60+
                     longint(h)*100*60*60;
             end;

Begin
End.