
 {


    ----------------------------------------------------------------------
    BLOCK RENDERING (C) 2001 by ROZSNYO DANIEL from System 7 for System 6a
    ----------------------------------------------------------------------

      System 7 is a next generation of System 2001 v.6 and will be
	       released in 2002 or 2003 :)
               (improvements: own filesystem, multiuser, remote access)

 }

 Const     MaxBRwins    = 63;

 Type      TWindowItem  = record
                            Rect   : TRect;
                            index  : integer;
                            active : boolean;
                          end;

           TWindowList  = record
                            num    : integer;
                            max    : integer;
                            data   : array[1..MaxBRwins] of TWindowItem;
                          end;

           TIntegerList = record
                            num    : integer;
                            max    : integer;
                            data   : array[1..MaxBRwins] of Integer;
                          end;


 Procedure BuildWindowList(var w:TWindowList);
           var i : integer;
           begin
             {
               make window list from kernel's data
             }
             w.num:=0;
             w.max:=MaxBRwins;
             with kerneldata do
             for i:=0 to numofprocesses-1 do
                 if (processdata[i].flags and PROC_VISUAL)>0 then
                    with PWindow(processdata[i].DS_ptr)^ do
                    begin
                      {
                        add window
                      }
                      inc(w.num);
                      w.data[w.num].rect.pos   :=position;
                      w.data[w.num].rect.size.x:=canvas.width;
                      w.data[w.num].rect.size.y:=canvas.height;
                      w.data[w.num].index      :=i;
                      w.data[w.num].active     :=true;
                      {
                        if there are too many windows -> exit
                      }
                      if w.num=w.max then exit;
                    end;
           end;

 Procedure FilterWindowList(var w:TWindowList;min,max:TPoint);
           var i : integer;
           begin
             {
                sets the ACTIVE flag in window list, if window (or its part)
                is in rendering area (min,max) the the active flag stays
                true, else it is set to false
             }
             for i:=1 to w.num do
                 with w.data[i] do
                 with rect do
                 begin

                   {
                     window is right from rendering area
                   }
                   if pos.x>max.x then
                      begin
                        active:=false;
                        continue;
                      end;

                   {
                     window is down from rendering area
                   }
                   if pos.y>max.y then
                      begin
                        active:=false;
                        continue;
                      end;

                   {
                     window is left from rendering area
                   }
                   if (pos.x+size.x-1)<min.x then
                      begin
                        active:=false;
                        continue;
                      end;

                   {
                     window is up from rendering area
                   }
                   if (pos.y+size.y-1)<min.y then
                      begin
                        active:=false;
                        continue;
                      end;

                 end;
           end;

 Procedure SimplifyWindowList(var w:TWindowList);
           var i : integer;
               n : integer;
           begin
             {
               moves active windows to the begining of window list
             }
             n:=1;

             for i:=1 to w.num do
                 begin

                   {
                     if it is active, try move it to free position
                   }
                   if w.data[i].active then
                      begin
                        if i>n then w.data[n]:=w.data[i];
                        inc(n);
                      end;

                 end;

             w.num:=n-1;

           end;

 Procedure AddToIlist(var v:TIntegerList;n:integer);
           var i : integer;
           begin
             {
               is the list full ?
             }
             if v.num=v.max then exit;
             if v.num=0 then
                begin
                  {
                    first item in list
                  }
                  v.num:=1;
                  v.data[1]:=n;
                end else
                begin
                  {
                    if exist then exit
                  }
                  for i:=1 to v.num do
                      if v.data[i]=n then exit;
                  inc(v.num);
                  v.data[v.num]:=n;
                end;
           end;

 Procedure SortIlist(var v:TIntegerList);
           var f : integer;
               s : integer;
               t : integer;
           begin
             if v.num<2 then exit;
                for f:=1 to v.num-1 do
                for s:=f+1 to v.num do
                    if v.data[f]>v.data[s] then
                       begin
                         t:=v.data[f];
                         v.data[f]:=v.data[s];
                         v.data[s]:=t;
                       end;
           end;

 Procedure MakeVDivList(var w:TWindowList;var v:TIntegerList;min,max:integer);
           var i : integer;
           begin
             v.num:=0;
             v.max:=w.max;
             {
               add the top boundary
             }
             AddToIlist(v,min);
             for i:=1 to w.num do
                 with w.data[i].rect do
                 begin
                   {
                     add begining of window
                   }
                   if pos.y>min
                      then AddToIlist(v,pos.y);
                   {
                     add start of new block after window
                   }
                   if pos.y+size.y<=max
                      then AddToIlist(v,pos.y+size.y);
                 end;
             {
               add the bottom boundary
             }
             AddToIlist(v,max+1)
           end;

 Procedure MakeHDivList(var w:TWindowList;var v:TIntegerList;min,max:integer);
           var i : integer;
           begin
             v.num:=0;
             v.max:=w.max;
             {
               add the top boundary
             }
             AddToIlist(v,min);
             for i:=1 to w.num do
                 with w.data[i].rect do
                 begin
                   {
                     add begining of window
                   }
                   if pos.x>min
                      then AddToIlist(v,pos.x);
                   {
                     add start of new block after window
                   }
                   if pos.x+size.x<=max
                      then AddToIlist(v,pos.x+size.x);
                 end;
             {
               add the bottom boundary
             }
             AddToIlist(v,max+1)
           end;

 Function  IsNotTransparent(i:integer):boolean;
           begin
             with kerneldata do
             with processdata[i] do
             with Pwindow(DS_ptr)^ do
             with canvas do
                  IsNotTransparent:=bits<=24;
           end;

 Function  Is24bitWindow(i:integer):boolean;
           begin
             with kerneldata do
             with processdata[i] do
             with Pwindow(DS_ptr)^ do
             with canvas do
                  Is24bitWindow:=bits=24;
           end;

 Procedure RenderBlock(var all:TWindowList;min,max:Tpoint);
           var w     : TWindowList;
               i     : integer;
               f     : boolean;
               p     : pointer;
               s     : word;
               r     : integer;
               o     : integer;
               a     : integer;
           begin


             {$IFDEF countpixels}

             pixelcount:=pixelcount+longint(max.x-min.x+1)*(max.y-min.y+1);

             {$ENDIF}

             {
               we are now rendering one block - there are no edges of
               window in any direction
             }
             w:=all;

             {
               filter the window list -> in list now stays only windows
               in the block
             }
             FilterWindowList(w,min,max);
             SimplifyWindowList(w);

             {
               if there is no window in list...
             }
             if w.num<1 then exit;

             {
               we must set all windows under the bottom nontransparent as
               inactive  -> these windows are not visible
             }
             f:=false;
             for i:=w.num downto 1 do
                 if f then w.data[i].active:=false
                      else if IsNotTransparent(w.data[i].index)
                           then f:=true;

             {
               remove inactive windows from list
             }
             SimplifyWindowList(w);

             {
               if there is no window in list...
             }
             if w.num<1 then exit;

             {
               if there is ONE window and it has 24 bit scheme, we may
               put it with putimage
             }

             if (w.num=1) and Is24bitWindow(w.data[1].index) then
                begin

                  {
                    draw the image to screen
                  }
                  with kerneldata.processdata[w.data[1].index] do
                  PROCESS_BLOCK
                    { x   } ( min.x,
                    { y   }   min.y,
                    { a   }   max.x-min.x+1,
                    { b   }   max.y-min.y+1,
                    { x0  }   min.x-Pwindow(DS_ptr)^.position.x,
                    { y0  }   min.y-Pwindow(DS_ptr)^.position.y,
                    { bpl }   Pwindow(DS_ptr)^.canvas.width*3,
                    { mb  }   Pwindow(DS_ptr)^.canvas.mblock,
                    { f   }   24);
                  {
                    count the rendered pixels
                  }
                  inc(guidesktop.rendered,
                      longint(max.x-min.x+1)*(max.y-min.y+1));
                end else
                begin

                  {
                    standard Alpha channel rendering procedures...
                  }
                  a:=max.x-min.x+1;
                  s:=3*a;
                  if (s mod 4)>0 then s:=((s div 4)+1)*4;
                  if maxavail<s then
                     begin
                       {
                         no memory -> exit (the image will not be rendered)
                       }
                       exit;
                     end;
                  GetMem(p,s);
                  {
                    render all rows
                  }
                  for r:=min.y to max.y do
                      begin
                        {
                          render all layers
                        }
                        for o:=1 to w.num do
                            with Pwindow(kerneldata.
                                         processdata[w.data[o].index].
                                         DS_ptr)^.canvas do
                            getline(min.x-Pwindow(kerneldata.
                                                  processdata[w.data[o].index].
                                                  DS_ptr)^.position.x,
                                    r-Pwindow(kerneldata.
                                              processdata[w.data[o].index].
                                              DS_ptr)^.position.y,
                                    a,p);
                        PROCESS_LINE
                          { x }  (min.x,
                          { y }   r,
                          { l }   a,
                          { p }   addr(p^),
                          { f }   24);
                        {
                          count the rendered pixels
                        }
                        inc(guidesktop.rendered,a);
                      end;
                  FreeMem(p,s);
                end;
           end;

 Procedure RenderStripe(var all:TWindowList;min,max:Tpoint);
           var w     : TWindowList;
               hdiv  : TIntegerList;
               bkmin : TPoint;
               bkmax : TPoint;
               i     : integer;
           begin
             {
               we must render the area from left to right and from top to
               bottom, but between top and bottom isn't any edge of window
             }

             w:=all;

             {
               filter and simpify the window list used to render the stripe
             }
             FilterWindowList(w,min,max);
             SimplifyWindowList(w);

             {
               if there is no window in window list
             }
             if w.num<1 then exit;

             {
               make HDIV operation
             }
             MakeHDivList(w,hdiv,min.x,max.x);

             {
               sort the list
             }
             SortIlist(hdiv);

             {
               and finally - render all blocks created by HDIV in stripe
             }
             for i:=1 to hdiv.num-1 do
                 begin

                   {
                     calc stripe min and max
                   }
                   bkmin.x:=hdiv.data[i+0];
                   bkmin.y:=min.y;
                   bkmax.x:=hdiv.data[i+1]-1;
                   bkmax.y:=max.y;

                   {
                     process block rendering
                   }
                   RenderBlock(w,bkmin,bkmax);
                 end;
           end;

 Procedure BlockRender(min,max,screen:TPoint);
           var all   : TWindowList;
               vdiv  : TIntegerList;
               i     : integer;
               stmin : TPoint;
               stmax : TPoint;
           begin

             {
               if area is out of screen... exit
             }
             if max.x<0 then exit;
             if max.y<0 then exit;
             if min.x>=screen.x then exit;
             if min.y>=screen.y then exit;

             {
               restrictions -> rendering area must me on the screen
             }
             if min.x<0 then min.x:=0;
             if min.y<0 then min.y:=0;
             if max.x>=screen.x then max.x:=screen.x-1;
             if max.y>=screen.y then max.y:=screen.y-1;

             {
               build list of all windows
             }
             BuildWindowList(all);

             {
               if there is no window (it is impossible to get this state)
             }
             if all.num<1 then exit;

             {
               mark windows not in (min,max) as inactive
             }
             FilterWindowList(all,min,max);

             {
               delete inactive windows from list
             }
             SimplifyWindowList(all);

             {
               if there is no window in rendering area -> exit
             }
             if all.num<1 then exit;

             {
               make VDIV operation
             }
             MakeVDIVlist(all,vdiv,min.y,max.y);

             {
               we have the VDIV list, but it is not sorted => sort it
             }
             SortIlist(vdiv);

             {
               we have now sorted the VDIV list => render stripes
             }
             for i:=1 to vdiv.num-1 do
                 begin

                   {
                     calc stripe min and max
                   }
                   stmin.x:=min.x;
                   stmin.y:=vdiv.data[i+0];
                   stmax.x:=max.x;
                   stmax.y:=vdiv.data[i+1]-1;

                   {
                     process stripe rendering
                   }
                   RenderStripe(all,stmin,stmax);
                 end;

           end;



