{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
{

  System 2001 v.6 C
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      SYSTEM KERNEL


  Programmed by:      Rozsnyo Daniel

  Version:            1.30.500 C+
  Release date:       2001-11-17
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

 {$M 65520,0,655350}

 Program   System2001;

 Uses      Dos,        { for Get and SetIntVec functions                    }
           Types,      { System 2001 v.6 basic types                        }
           SysCalls,   { System 2001 v.6 system calls and message inserting }
           Drivers,    { System 2001 v.6 basic input/output drivers         }
           Objects,    { Object functions - Message System                  }
           API,        { Advanced programming interface                     }
           ini,
           convert,
           xmscore,advmm,
           GD_VESA
           ;

 Var       oldCtrlBreak : pointer;



 {x$DEFINE test}

 procedure TEST;
           var l : TStringList;
           begin


             l.init;
             l.add('jedna');
             l.add('dva');
             l.add('tri');
             l.add('styri');
             l.add('pet');

             l.start;

             writeln;
             while not l.eof do
                   begin
                     writeln(l.read);
                     l.next;
                   end;

              l.done;


             halt(0);
           end;

 procedure CTRLBREAK; interrupt;
           begin
             {
               CTRL+BREAK pressed
             }
           end;

 procedure CtrlBreakOff;
           begin
             setintvec($23,@CtrlBreak);
           end;

 procedure CtrlBreakOn;
           begin
             setintvec($23,OldCtrlBreak);
           end;

 procedure RESETcomputer;
           var reset : procedure;
           begin
             @reset:=ptr($FFFF,$0000);
             reset;
           end;

 function  XMSautoTest:boolean;
           var mbp  : PammPart;
               orig : array[0..1023] of byte;
               buff : array[0..1023] of byte;
               i    : integer;
           begin
             {
               no mem test
             }
             if xms.maxmemory=0 then
                begin
                  write('TEST SKIPPED !  ');
                  xmsautotest:=true;
                  exit;
                end;
             {
               get memory
             }
             mbp:=xms.alloc(1);
             if mbp=nil then
                begin
                  writeln('FATAL ERROR ! ( -> advmm.xms.alloc )');
                  xmsautotest:=false;
                  exit;
                end;
             {
               fill both buffers - orig is random, buff is cleared
             }
             for i:=0 to 1023 do
                 begin
                   orig[i]:=random(256);
                   buff[i]:=0;
                 end;
             {
               upload orig to xms
             }
             xms.write(mbp,0,1024,@orig);
             {
               download to buff from xms
             }
             xms.read(mbp,0,1024,@buff);
             {
               compare both buffers
             }
             for i:=0 to 1023 do
                 if orig[i]<>buff[i] then
                    begin
                      writeln('FATAL ERROR ! ( transfer error )');
                      xmsautotest:=false;
                      exit;
                    end;
             {
               deallocate memory
             }
             if not xms.dealloc(mbp) then
                begin
                  writeln('FATAL ERROR ! ( -> advmm.xms.dealloc )');
                  xmsautotest:=false;
                  exit;
                end;
             xmsautotest:=true;
           end;

 var r:integer;s:TlongSearchRec;

     OldExitProc : pointer;

 procedure NewExitProc;
           var d1,d2,d3,d4 : string;
           begin
             ExitProc:=OldExitProc;

             if ErrorADDR<>nil then
                begin

                  d1:=integertostring(ExitCode);

                  d2:='';
                  d3:='';

                  case ExitCode of

                      1 : d3:='Invalid function number                  ';
                      2 : d3:='File not found                           ';
                      3 : d3:='Path not found                           ';
                      4 : d3:='Too many open files                      ';
                      5 : d3:='File access denied                       ';
                      6 : d3:='Invalid file handle                      ';
                     12 : d3:='Invalid file access code                 ';
                     15 : d3:='Invalid drive number                     ';
                     16 : d3:='Cannot remove current directory          ';
                     17 : d3:='Cannot rename across drives              ';
                     18 : d3:='No more files                            ';
                    100 : d3:='Disk read error                          ';
                    101 : d3:='Disk write error                         ';
                    102 : d3:='File not assigned                        ';
                    103 : d3:='File not open                            ';
                    104 : d3:='File not open for input                  ';
                    105 : d3:='File not open for output                 ';
                    106 : d3:='Invalid numeric format                   ';
                    150 : d3:='Disk is write-protected                  ';
                    151 : d3:='Bad drive request struct length          ';
                    152 : d3:='Drive not ready                          ';
                    154 : d3:='CRC error in data                        ';
                    156 : d3:='Disk seek error                          ';
                    157 : d3:='Unknown media type                       ';
                    158 : d3:='Sector Not Found                         ';
                    159 : d3:='Printer out of paper                     ';
                    160 : d3:='Device write fault                       ';
                    161 : d3:='Device read fault                        ';
                    162 : d3:='Hardware failure                         ';
                    200 : d3:='Division by zero                         ';
                    201 : d3:='Range check error                        ';
                    202 : d3:='Stack overflow error                     ';
                    203 : d3:='Heap overflow error                      ';
                    204 : d3:='Invalid pointer operation                ';
                    205 : d3:='Floating point overflow                  ';
                    206 : d3:='Floating point underflow                 ';
                    207 : d3:='Invalid floating point operation         ';
                    208 : d3:='Overlay manager not installed            ';
                    209 : d3:='Overlay file read error                  ';
                    210 : d3:='Object not initialized                   ';
                    211 : d3:='Call to abstract method                  ';
                    212 : d3:='Stream registration error                ';
                    213 : d3:='Collection index out of range            ';
                    214 : d3:='Collection overflow error                ';
                    215 : d3:='Arithmetic overflow error                ';
                    216 : d3:='General Protection fault                 ';

                  end;

                  d2:=d3;
                  d3:='';

                  d4:=PtrToString(ErrorAddr);

                  BSOD('RUNTIME ERROR '+integertostring(ExitCode),d1,d2,d3,d4);
                end;

           end;

 Begin

   {$IFDEF test}
   TEST;
   {$ENDIF}

   oldexitproc:=ExitPRoc;
   ExitProc:=addr(NewExitProc);

   getintvec($23,OldCtrlBreak);

   ctrlbreakoff;

   BuildUpdate;

     Writeln;
     Writeln('Starting SYSTEM 2001 ...');
     Writeln;
     Writeln('  (C) 1997-2001, Rozsnyo electronics and software');
     Writeln;
     Writeln('  Version string:               ',VerStr);
     Writeln;

   { Allocate XMS memory }

     Write('  XMS memory allocation         ');

     If not XMSinstalled then
        begin
          writeln('< FAILED >');
          writeln;
          writeln(' SYS ERR 00: XMS memory driver not found (Himem.sys) !');
          exit;
        end;

       xms.init;


       If xms.maxmemory=0 then
          begin
            writeln('< FAILED >');
            writeln;
            writeln(' SYS ERR 01: no XMS memory to allocate !');
            exit;
          end;


       If xms.maxmemory=0
          then writeln('< OK >   NO FREE MEMORY')
          else Writeln('< OK >   MEMORY = ',xms.maxmemory,' KB');


     Writeln('  Total free local memory       ',memavail);
     Writeln('  Largest free block of memory  ',maxavail);

     inifile:='settings\system.ini';
     {
       load the xms capability
     }
     xmscap:=readinivalue('system','xmscap');
     {
       if value was not found, use 4 byte transfer capability
     }
     if inierror<>iniOK then xmscap:=4;

     Write  ('  Memory manager test (block=',xmscap,') ');

     if XMSautotest then
        begin
          Writeln('< OK >');
        end else
        begin
          xms.done;
          Halt;
        end;

     Write('  Message system                ');

     InitMessageSystem;

       Writeln('< OK >');

       {
         mark, that we are in ON state
       }
       changeini('system','runstate','on');

       runinternal(addr(ConsoleDriver),
                   PROC_Driver or PROC_Multitask,
                   'Console driver','');

       RunShell;

       repeat

         ProcessMessage;

       until ExitFromSystem;

       writeln;
       writeln('Thanks for using this program ...');

       inifile:='settings\system.ini';
       changeini('system','runstate','off');


     KillMessageSystem;

   { Release XMS memory }

     xms.done;

     inifile:='settings\system.ini';
     if readiniboolean('system','resetonexit')
        then RESETcomputer;

 end.










