{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      SYSTEM CALL ACCESS UNIT


  Programmed by:      Rozsnyo Daniel


  Version:            1.10.029 C  from  2001-11-19
                      1.10.028 B  from  2001-11-17
                      1.00.025 A  from  2001-02-18

  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}

 Unit SysCalls;


 {x$DEFINE debug_showrun}
 {x$DEFINE debug_showkeycodes}
 {$DEFINE debug_F1_writeprocesslist}
 {x$DEFINE emergencyESC}

 Interface

   Uses      Types,      { basic types }
             Gui,        { gui, vesadriver and wins }
             Dos,
             AdvMM,
             Objects;    { message system }

   Const

             VerStr       = 'System 2001 v.6C+ version 5.17.672';

             ToKernel     : TProcessID = 0;
             FromKernel   : TProcessID = 0;
             FromUnknown  : TProcessID = $FFFF;

             MaxProcesses = 256;
             MessageSize  = 256;

             ReservedProcessID = $7000;


             MIN_MessBuffer      = 32768;
             MIN_MessDataBuffer  = 32768;


   Var
             Message      : Tmessage;      { public message }
             Process      : TProcess;      { public process }

             UpdateProcessData : Boolean;  { change process info
                                             process -> proc.table }

             ToConsole    : TProcessID;
             ToWins       : TProcessID;
             ToGraph      : TProcessID;
             ToGui        : TProcessID;

             KernelData   : record
                              ID             : string;
                              NewProcessID   : TprocessID;
                              NumOfProcesses : word;
                              ProcessData    : array[0..MaxProcesses-1] of TProcess;
                              MessageSystem  : Pmessagesystem;
                              ThereWasChange : boolean;
                              Exiting        : boolean;
                            end;

 { EXTENDED DOS FUNCTIONS }

   Function  Fileexist(fn:string):boolean;

 { KERNEL LOW-LEVEL FUNCTIONS }

   Procedure SendMessage( From,
                          Dest: TprocessID;
                          Message,
                          ParamSize:Word;
                          Param:Pointer);

   Procedure ProcessMessageNow( From,
                                Dest: TprocessID;
                                Message,
                                ParamSize:Word;
                                Param:Pointer);

   Function  GetNewProcessID:TProcessID;

   function  FlagToString(f:byte):string;

   Procedure InitMessageSystem;
   Procedure KillMessageSystem;

   Procedure ProcessMessage;
   Function  ExitFromSystem:boolean;

   procedure DING;
   procedure beep;
   Procedure ProcList;

   procedure buildupdate;

   function  AllowAccess(name,pasw:string):boolean;

   procedure ProcessMessages;


 { PUBLIC FUNCTIONS OF KERNEL }

   Procedure CloseSystem;
   Procedure HibernateSystem;
   Procedure RunInternal(a:pointer;f:byte;s,p:string);
   Procedure CloseProcess;
   Procedure Jump(m:word);
   Procedure BroadcastEvent(event:word);

 { PUBLIC FUNCTIONS OF CONSOLE DRIVER }

   Procedure GenerateKey(c:word);
   Procedure Force_MS_POS;
   procedure MouseSetGraphSensitivity;
   procedure MouseSetTextSensitivity;
   procedure MouseSetRange(rx,ry:integer);
   procedure MouseSetPosition(px,py:integer);

 { PUBLIC FUNCTIONS OF WINS SYSTEM AND GRAPHICS DRIVER }

   Procedure WinsRender(x1,y1,x2,y2:integer);
   Procedure CloseGui;

 { PROCESSES }

   Procedure SystemKernel;
   Procedure SystemShell;

 { PROGRAMS }

   Procedure RunShell;

 { OTHER MESSAGES }

   procedure SendLine   (p:TProcessID;s:string);
   procedure ExtJump    (p:TProcessID;m:word);
   procedure FromToJump (FromP,DestP:TProcessID;m:word);

 Implementation

   Uses convert,
        Ini;         { inifiles }

   Var  h,m,s,ss     : word;

        MustInsertNothing : boolean;

   Procedure OPTIMALIZE_PROC_TABLE;
             var i:integer;
             begin
               {

                  PROCESS TABLE OPTIMALIZATION
                  ============================


               }


               { AUTO CLEAN UP }


               for i:=0 to kerneldata.numofprocesses-1 do
                   if (kerneldata.processdata[i].flags and
                       PROC_DEAD)>0 then
                       SendMessage(process.id,
                                   kerneldata.processdata[i].id,
                                   PR_KILL,
                                   0,
                                   nil);


             end;

   Procedure BroadcastEvent(event:word);
             var i:integer;
             begin
               for i:=0 to kerneldata.numofprocesses-1 do
                   if (kerneldata.processdata[i].flags and
                       PROC_DEAD)=0 then
                       SendMessage(process.id,
                                   kerneldata.processdata[i].id,
                                   event,
                                   0,
                                   nil);
             end;

   procedure buildupdate;
             var oi : string;
                 n  : longint;
                 s  : longint;
                 b  : longint;
                 r  : longint;
             begin
               oi:=inifile;
               inifile:='settings\system.ini';
               b:=readinivalue('build','build');
               r:=readinivalue('build','runct');
               s:=readinivalue('build','fsize');
               n:=filelen('sys2001.exe');
               if n<>s then
                  begin
                    changeini('build','build',integertostring(b+1));
                    changeini('build','fsize',integertostring(n));
                  end;
               changeini('build','runct',integertostring(r+1));
               inifile:=oi;
             end;

   procedure DING;
             begin
               asm
                 mov ah,6
                 mov dl,7
                 int 21h
               end;
             end;

   procedure beep;
             var i,j : integer;
             begin
               asm
                 mov ah,6
                 mov dl,7
                 int 21h
               end;
               for i:=0 to 1000 do
               for j:=0 to 10000 do;
             end;

   function  AllowAccess(name,pasw:string):boolean;
             var cp : string;
             begin
               cp:='';
               cp:=readinistring('users',name);
               if name='_anonym'
                  then AllowAccess:=cp='yes'
                  else AllowAccess:=(IniError=IniOK) and (cp=pasw);
             end;

   function  FlagToString(f:byte):string;
             var r:string;
             begin
               r:='PROC';
               if (f and PROC_DRIVER      )>0 then r:=r+'.DRV';
               if (f and PROC_APPLICATION )>0 then r:=r+'.APP';
               if (f and PROC_CONSOLE     )>0 then r:=r+'.CON';
               if (f and PROC_MULTITASK   )>0 then r:=r+'.MTS';
               if (f and PROC_VISUAL      )>0 then r:=r+'.VIS';
               if (f and PROC_EXTERNAL    )>0 then r:=r+'.EXT';
               if (f and PROC_DEAD        )>0 then r:=r+'.DEAD';
               FlagToString:=r;
             end;

   procedure ProcessMessages;
             begin
               MustInsertNothing:=true;
             end;

   Procedure ProcList;
             Type VidMemType      = array[0..1999] of word;
             Var  TempVideoMemory : VidMemType;
                  TextVideoMemory : VidMemType absolute $B800:$0000;
                  cur   : word;
                  vmode : word;
                  i     : integer;
                  c     : byte;
                  mouse : TPoint;
             begin
               asm
                 mov ax,$0003
                 int $33
                 shr cx,3
                 shr dx,3
                 mov mouse.x,cx
                 mov mouse.y,dx
               end;
               asm
                 mov ax,4f03h
                 int 10h
                 mov vmode,bx
               end;
               if vmode=3 then
                  begin
                    TempVideoMemory:=TextVideoMemory;
                    asm
                      mov ax,300h
                      mov bh,0
                      int 10h
                      mov cur,dx
                      mov ax,200h
                      mov bh,0
                      mov dx,0
                      int 10h
                    end;
                  end else
                  begin
                    asm
                      mov ax,83h
                      int 10h
                    end;
                  end;
               for i:=0 to 1999 do TextVideoMemory[i]:=$0920;
               writeln;
               writeln('ID:   Process name:      Flags:                        Memory allocation:');
               with kerneldata do
                    for i:=0 to NumOfProcesses-1 do
                        begin
                          with ProcessData[i] do
                           begin
                             write(ID:5,'  ',copy(name+'                ',1,18),
                                   ' ',copy(FlagTostring(flags)+
                                   '                          ',1,30));
                             if DS_size<>0 then write('D:',DS_size,' B ');
                             if CS_size<>0 then write('C:',CS_size,' B ');
                             if (DS_size<>0) and
                                ((flags and (PROC_VISUAL or PROC_DEAD))>0) and
                                (Pwindow(DS_ptr)^.canvas.mblock<>nil)
                                then write('W: ',
                                     Pwindow(DS_ptr)^.canvas.mblock^.size+
                                     Pwindow(DS_ptr)^.objects^.size div 1024,
                                     ' KB ');
                             writeln;
                           end;
                        end;
               writeln;
               writeln('   Free conventional memory:          ',memavail,' bytes');
               writeln('   Largest free memory block:         ',maxavail,' bytes');
               writeln('   REAS memory manager: Total memory: ',xms.maxmemory,' Kbytes');
               writeln('                        Free memory:  ',xms.freemem,' Kbytes');
               if vmode<>3 then
                  begin
                    writeln;
                    writeln('   Video mode: ',guidesktop.size.x,' x ',guidesktop.size.y,' pixels, 24 bits per pixel');
                  end;
               writeln;
               writeln('   CONSOLE=',ToConsole,' GUI=',togui,' GRAPH=',tograph,' WINS=',towins);
               writeln;
               Write(' Press any key to continue ... ');
               Asm
                 @zn: mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      je   @zn
                 @rk:
                      mov  ah, 8
                      int  21h
                      mov  c,al
                      mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      jne  @rk
                      mov  al,c
                      cmp  al,0
                      jne  @k
                      mov  ah,8
                      int  21h
                 @k:
               end;
               {
               Kerneldata.MessageSystem^.ListMessages;
               Write(' Press any key to continue ... ');
               Asm
                 @zn: mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      je   @zn
                 @rk:
                      mov  ah, 8
                      int  21h
                      mov  c,al
                      mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      jne  @rk
                      mov  al,c
                      cmp  al,0
                      jne  @k
                      mov  ah,8
                      int  21h
                 @k:
               end;
               }
               if vmode=3 then
                  begin
                    TextVideoMemory:=TempVideoMemory;
                    asm
                      mov ax,200h
                      mov bh,0
                      mov dx,cur
                      int 10h
                    end;
                  end else
                  begin
                    mousesetgraphsensitivity;
                    with guidesktop.size do mousesetrange(x,y);
                    asm
                      mov ax,4f02h
                      mov bx,vmode
                      or  bx,8000h
                      int 10h
                    end;
                    {render the first two segments}
                    with guidesktop.size do WinsRender(0,0,x-1,(128*1024) div (3*x));
                  end;
               with mouse do MouseSetPosition(x,y);
             end;

   Procedure WinsRender(x1,y1,x2,y2:integer);
             var DTA: TWI_Render;
             begin
               DTA.Min.x:=x1;
               DTA.Min.y:=y1;
               DTA.Max.x:=x2;
               DTA.Max.y:=y2;
               SendMessage(process.id,ToWins,WI_Render,
                           SizeOf(DTA),addr(DTA));
             end;

   Function  Fileexist(fn:string):boolean;
             var sr : searchrec;
             begin
               findfirst(fn,$FF,sr);
               fileexist:=doserror=0;
             end;

   Procedure Jump(m:word);
             begin
               sendmessage(process.id,process.id,m,0,nil);
             end;

   Function  ExitFromSystem:boolean;
             begin
               ExitFromSystem:=KernelData.NumOfProcesses<=1;
             end;

   Function  GetNewProcessID:TprocessID;
             Function Usable : Boolean;
                      var i      : Integer;
                      begin
                        usable:=true;
                        for i:=0 to KernelData.NumOfProcesses-1 do
                            if KernelData.ProcessData[i].ID=
                               KernelData.NewProcessID then
                               begin
                                 Usable:=false;
                                 exit;
                               end;
                      end;
             begin
               inc(KernelData.NewProcessID);
               while not usable do
                     if KernelData.NewProcessID<ReservedProcessID
                        then inc(KernelData.NewProcessID)
                        else KernelData.NewProcessID:=0;
               GetNewProcessID:=KernelData.NewProcessID;
             end;

   Procedure InitMessageSystem;
             begin
               New(KernelData.MessageSystem,Init);
               with KernelData do
               if MessageSystem^.GetDataBufferSize<MIN_MessBuffer then
                  begin
                    Writeln('< FAILED >');
                    Writeln;
                    Writeln('   ERR = The data buffer is smaller than ',
                            MIN_MessBuffer,' Bytes');
                    Dispose(MessageSystem,Done);
                    xms.done;
                    halt(0);
                  end;
               with KernelData do
               if MessageSystem^.GetBufferSize<MIN_MessDataBuffer then
                  begin
                    Writeln('< FAILED >');
                    Writeln;
                    Writeln('   ERR = The message buffer is smaller than ',
                            MIN_MessDataBuffer,' Bytes');
                    Dispose(MessageSystem,Done);
                    xms.done;
                    halt(0);
                  end;
               with KernelData do
                begin
                  NewProcessID:=0;
                  ThereWasChange:=false;
                  ID:=VerStr;
                  NumOfProcesses:=1;
                  with ProcessData[0] do
                   begin
                     ID      := $0000;
                     @Handle := addr(SystemKernel);
                     CS_size := 0;
                     CS_ptr  := nil;
                     DS_size := 0;
                     DS_ptr  := nil;
                     Flags   := 0;
                     name    := 'KERNEL v.6';
                   end;
                end;
             end;

   Procedure KillMessageSystem;
             begin
               dispose(KernelData.MessageSystem,Done);
             end;

   Procedure ProcessMessageNow( From,
                                Dest: TprocessID;
                                Message,
                                ParamSize:Word;
                                Param:Pointer);
             var f : boolean;
                 i : integer;
             begin
               syscalls.message.from:=from;
               syscalls.message.dest:=dest;
               syscalls.message.mess:=message;
               syscalls.message.size:=paramsize;
               syscalls.message.data:=param;
               with kerneldata do
               begin
                 f:=false;
                 for i:=0 to NumOfProcesses-1 do
                     if ProcessData[i].ID=dest then
                        begin
                          f:=true;
                          break;
                        end;
                     if f then
                          begin
                            Process:=ProcessData[i];
                            UpdateProcessData:=false;

                            if (process.flags and proc_dead)>0 then
                               if (syscalls.message.mess<>PR_Close) and
                                  (syscalls.message.mess<>PR_Hibernate) and
                                  (syscalls.message.mess<>PR_Kill) then exit;

                            {if (process.flags and PROC_DEAD)=0 then
                               begin}
                                 Process.Handle;

                                 if UpdateProcessData then
                                    begin
                                      ProcessData[i]:=Process;
                                      ThereWasChange:=true;
                                    end;
                          end;
               end;
             end;

   Procedure ProcessMessage;
             var i : integer;
                 f : boolean;
             begin
               with kerneldata do
                begin
                  {$IFDEF debug_mess}
                  messagesystem^.listmessages;
                  {$ENDIF}

                  if (not MessageSystem^.IsMessage) or
                     mustinsertnothing then
                     begin

                       OPTIMALIZE_PROC_TABLE;

                       For i:=0 to NumOfProcesses-1 do
                           if (ProcessData[i].flags and
                               PROC_multitask)>0 then
                           if (ProcessData[i].flags and
                               PROC_DEAD)=0 then
                               SendMessage( FromKernel,
                                            ProcessData[i].ID,
                                            KE_nothing,0,nil);

                       mustinsertnothing:=false;

                     end else
                     begin
                       MessageSystem^.GetMessage(addr(SysCalls.Message));
                       f:=false;
                       for i:=NumOfProcesses-1 downto 0 do
                           if ProcessData[i].ID=Message.dest then
                              begin
                                f:=true;
                                break;
                              end;
                       if f then
                          begin
                            Process:=ProcessData[i];
                            UpdateProcessData:=false;

                            if (process.flags and proc_dead)>0 then
                               if (message.mess<>PR_Close) and
                                  (message.mess<>PR_Hibernate) and
                                  (message.mess<>PR_Kill) then exit;

                            {if (process.flags and PROC_DEAD)=0 then
                               begin}
                                 Process.Handle;
                                 if UpdateProcessData then
                                    begin
                                      ProcessData[i]:=Process;
                                      ThereWasChange:=true;
                                    end;
                            {   end else
                               begin
                                 memlog('ERROR: trying to process a message with dead process...');
                               end; }
                          end else
                          begin
                            {
                            MemLog('Error ! Process '+
                                   integertostring(message.dest)+
                                   ' not found. (mess='+
                                   integertostring(message.mess)+')');
                            }
                          end;
                     end;
                end;
             end;

   Procedure SendMessage( From,
                          Dest: TprocessID;
                          Message,
                          ParamSize:Word;
                          Param:Pointer);
             begin
               with KernelData.MessageSystem^ do
                    begin
                      SetUser(From);
                      InsertMessageParam(Dest,Message,ParamSize,Param);
                    end;
             end;

   Procedure SystemKernel;
             var LocalMess : TMessage;
                 i,j       : integer;
                 f         : boolean;
                 MR        : TCO_MS_SetRange;
                 InitProc  : PPR_Init;
             begin
               LocalMess:=Message;
               case LocalMess.Mess of

                KE_StartProcess:
                 begin
                   { insert process informations into process table and
                     initialize the process }
                   with KernelData do
                    begin
                      {set the flag}
                      ThereWasChange:=True;
                      {$IFDEF debug_showrun}
                      Writeln('Starting new process: ',
                              Tprocess(LocalMess.data^).name);
                      {$ENDIF}
                      If NumOfProcesses=MaxProcesses then exit;
                      i:=NumOfProcesses;
                      {insert to found pos}
                      ProcessData[i]:=TKE_StartProcess(LocalMess.data^).process;
                      { allocate data segment }
                      with ProcessData[i] do
                           if DS_Size>0 then
                           begin
                             {inc(DS_Size,256);}
                             GetMem(DS_ptr,DS_size);
                           end else
                           begin
                             DS_ptr:=nil;
                           end;
                      {
                      memlog('Start: '+processdata[i].name+' (ID='+
                             integertostring(processdata[i].ID)+')');
                      }
                      {increase number of processes by 1}
                      Inc(NumOfProcesses);
                      {send initialization message}
                      New(initproc);
                      InitProc^.ParentID:=LocalMess.From;
                      InitProc^.InitType:=PR_INIT_NORMAL;
                      InitProc^.Param:=TKE_StartProcess(LocalMess.data^).param;
                      SendMessage( FromKernel,
                                   processdata[i].id,
                                   PR_Init,
                                   sizeof(initproc^),initproc);
                      Dispose(initproc);
                    end;
                 end;

                KE_StopProcess:
                 begin
                   { delete process informations from process table }
                   with kerneldata do
                    begin
                      {set the flag}
                      ThereWasChange:=True;
                      {found indicator}
                      f:=false;
                      {find the process for stop}
                      for i:=0 to NumOfProcesses-1 do
                          if ProcessData[i].ID=LocalMess.From
                             then begin
                                    f:=true;
                                    break;
                                  end;
                      {if not found}
                      if not f then exit;
                      { deallocate data segment }
                      {
                      memlog('Stop: '+processdata[i].name+' (ID='+
                             integertostring(localmess.from)+')');
                      }
                      with ProcessData[i] do
                           if (DS_size>0) and (DS_ptr<>nil) then
                              FreeMem(DS_ptr,DS_size);
                      processdata[i].handle:=nil;
                      processdata[i].DS_ptr:=nil;
                      processdata[i].CS_ptr:=nil;
                      processdata[i].DS_size:=0;
                      processdata[i].CS_size:=0;
                      processdata[i].flags:=0;
                      {there are less processes - decrease number of proc by 1}
                      dec(NumOfProcesses);
                      {if it was the last item, we are complete }
                      if i=NumOfProcesses then exit;
                      {else move the processes}
                      {ProcessData[i]:= ProcessData[numofprocesses];
                      exit;
                      }
                      {
                      inc(numofprocesses);
                      proclist;
                      dec(numofprocesses);
                      }
                      for j:=i to numofprocesses-1 do
                          ProcessData[j]:= ProcessData[j+1];
                    end;
                 end;

                CO_KB_Input,      CO_MS_ChangePos,
                CO_MS_PressLeft,  CO_MS_ReleaseLeft,
                CO_MS_PressRight, CO_MS_releaseRight :
                 begin

                   {kerneldata.messagesystem^.nomemerror;}


                   { EMERGENCY EXIT }
                   {$IFDEF emergencyESC}
                   if localmess.mess=CO_KB_INPUT then
                      begin
                        if TCO_KB_INPUT(localmess.data^).code=27 then
                           CloseSystem;
                      end;
                   {$ENDIF}

                   {$IFDEF debug_showkeycodes}
                   if localmess.mess=CO_KB_INPUT then
                      begin
                        writeln(TCO_KB_INPUT(localmess.data^).code);
                      end;
                   {$ENDIF}

                   {$IFDEF debug_F1_writeprocesslist}
                   if (localmess.mess=CO_KB_INPUT) and
                      (TCO_KB_INPUT(localmess.data^).code=315) then
                      begin
                        PROCLIST;
                      end;
                   {$ENDIF}

                   { The message is console input, we must send it, where
                     is needed (process flag PROC_CONSOLE is present) }
                   For i:=0 to KernelData.NumOfProcesses-1 do
                       if (KernelData.ProcessData[i].flags and
                           PROC_console)>0
                          then SendMessage(FromKernel,
                                           KernelData.ProcessData[i].ID,
                                           LocalMess.Mess,
                                           LocalMess.Size,
                                           LocalMess.data);
                 end;

                KE_KillAll:
                 begin
                   {send the kill command to every process}
                   if TKE_KillAll(LocalMess.Data^)=KE_KILL_NORMAL then
                      begin

                        { close priority:  External
                                           Visual
                                           Application
                                           Driver }

                        For i:=0 to KernelData.NumOfProcesses-1 do
                            if (KernelData.ProcessData[i].flags and
                                PROC_external)>0
                          then SendMessage(FromKernel,
                                           KernelData.ProcessData[i].ID,
                                           PR_KILL,0,nil);
                        For i:=0 to KernelData.NumOfProcesses-1 do
                            if (KernelData.ProcessData[i].flags and
                                PROC_visual)>0
                          then SendMessage(FromKernel,
                                           KernelData.ProcessData[i].ID,
                                           PR_KILL,0,nil);
                        For i:=0 to KernelData.NumOfProcesses-1 do
                            if (KernelData.ProcessData[i].flags and
                                PROC_application)>0
                          then SendMessage(FromKernel,
                                           KernelData.ProcessData[i].ID,
                                           PR_KILL,0,nil);
                        For i:=0 to KernelData.NumOfProcesses-1 do
                            if (KernelData.ProcessData[i].flags and
                                PROC_driver)>0
                          then SendMessage(FromKernel,
                                           KernelData.ProcessData[i].ID,
                                           PR_KILL,0,nil);

                      end;
                 end;

               end;

             end;


   Var ShellData : record
                     line    : string;
                     curs    : string;
                     first   : boolean;
                     running : boolean;
                   end;


   Procedure SystemShell;
             var LocalMess : TMessage;
                 x,y       : word;
                 xo,yo     : word;
                 s         : string;
                 arun      : boolean;
             procedure NextCmd;
                       begin
                         if arun then
                            begin
                              {
                                 autorun state
                              }
                              writeln;
                              write('> ');
                            end;
                         {
                            normal function
                         }
                         SendMessage( localmess.dest,localmess.dest,
                                      UP_message,0,nil);
                       end;

             procedure Explode;
                       const ech = $0720;
                       var x : integer;
                           y : integer;
                           t : integer;
                       begin
                         exit;
                         { explode code }
                         for t:=1 to 80 do
                         for y:=0 to 24 do
                           if (y mod 2) = 0 then
                              begin
                                for x:=0 to 78 do
                                    memw[$B800:x*2+y*160]:=
                                    memw[$B800:x*2+y*160+2];
                                memw[$B800:158+y*160]:=ech;
                                {
                                for x:=0 to 10 do;
                                }
                              end else
                              begin
                                for x:=79 downto 1 do
                                    memw[$B800:x*2+y*160]:=
                                    memw[$B800:x*2+y*160-2];
                                memw[$B800:y*160]:=ech;
                                {
                                for x:=0 to 10 do;
                                }
                              end;
                       end;

             procedure LastCmd;
                       var xx : integer;
                       begin
                         for xx:=0 to 80*25-1 do
                             mem[$B800:(xx*2+1)]:=$7;
                         explode;
                         SendMessage( localmess.dest,localmess.dest,
                                      PR_KILL,0,nil);
                       end;

             procedure ProcessLine(cmd:string);
                       var h,m,s,t  : word;
                           fn,se,it,va : string;
                       begin
                         if cmd='time' then
                            begin
                              gettime(h,m,s,t);
                              Write('  Current time is ');
                              if h<10 then write('0',h,':')
                                      else write(h,':');
                              if m<10 then write('0',m,':')
                                      else write(m,':');
                              if s<10 then write('0',s,'.')
                                      else write(s,'.');
                              if t<10 then write('0',t    )
                                      else write(t    );
                              Writeln;
                              nextcmd;
                              exit;
                            end;

                         if cmd='date' then
                            begin
                              getdate(h,m,s,t);
                              Write('  Today is ',s,'.',m,'.',h);
                              Writeln;
                              nextcmd;
                              exit;
                            end;

                         if cmd='cls' then
                            begin
                              for h:=1 to 25 do writeln;
                              nextcmd;
                              exit;
                            end;

                         if (cmd='exit') or
                            (cmd='x') then
                            begin
                              closesystem;
                              lastcmd;
                              exit;
                            end;

                         if cmd='gui' then
                            begin
                              runinternal( addr(GraphicInterface),
                                           PROC_Application + PROC_Console,
                                           'GUI server','');
                              LastCmd;
                              exit;
                            end;

                         if copy(cmd,1,4)='gui ' then
                            begin
                              runinternal( addr(GraphicInterface),
                                           PROC_Application + PROC_Console,
                                           'GUI server',copy(cmd,5,255));
                              LastCmd;
                              exit;
                            end;

                         if (cmd='help') or (cmd='?') then
                            begin
                              writeln('   < cls >       clear screen');
                              writeln('   < date >      show date');
                              writeln('   < exit >      exit from system');
                              writeln('   < gui >       graphics user interface');
                              writeln('   < help >      display this help');
                              {
                              writeln('   < settings >  access settings menu');
                              }
                              writeln('   < time >      show time');
                              nextcmd;
                              exit;
                            end;

                         {
                         if cmd='settings' then
                            begin
                              writeln('   < settings(gui,resolution) >  Set the initial gui resolution');
                              writeln('   < settings(gui,device) >      Set the graphics device');
                              nextcmd;
                              exit;
                            end;
                         {

                         {
                         if cmd='settings(gui,resolution)' then
                            begin
                              writeln;
                              writeln('  What you want to set ? You may run the Gui by < gui >');
                              writeln;
                              writeln('  Force resolution detection:');
                              writeln('    < inifile(settings\system.ini,gui,resolution,undefined) >');
                              writeln;
                              writeln('  Standard resolutions');
                              writeln('    < inifile(settings\system.ini,gui,resolution,640x480) >');
                              writeln('    < inifile(settings\system.ini,gui,resolution,800x600) >');
                              writeln('    < inifile(settings\system.ini,gui,resolution,1024x768) >');
                              nextcmd;
                              exit;
                            end;
                         }

                         {
                         if cmd='settings(gui,device)' then
                            begin
                              writeln;
                              writeln('  You have these choices:');
                              writeln;
                              writeln('    < inifile(settings\system.ini,gui,driver,S3) >');
                              writeln('    < inifile(settings\system.ini,gui,driver,ATI) >');
                              nextcmd;
                              exit;
                            end;
                         }

                         if copy(cmd,1,8)='inifile(' then
                            begin
                              writeln;
                              cmd:=copy(cmd,9,255);
                              fn:=copy(cmd,1,pos(',',cmd)-1);
                              cmd:=copy(cmd,length(fn)+2,255);
                              se:=copy(cmd,1,pos(',',cmd)-1);
                              cmd:=copy(cmd,length(se)+2,255);
                              it:=copy(cmd,1,pos(',',cmd)-1);
                              cmd:=copy(cmd,length(it)+2,255);
                              va:=copy(cmd,1,pos(')',cmd)-1);
                              cmd:=copy(cmd,length(va)+1,255);
                              writeln('  Filename: ',fn);
                              writeln('  Value:    [',se,']');
                              writeln('            ',it,' = ',va);
                              if (cmd=')') and
                                 (fn<>'') and
                                 (se<>'') and
                                 (it<>'') and
                                 (va<>'') then
                                 begin
                                   cmd:=inifile;
                                   inifile:=fn;
                                   changeini(se,it,va);
                                   writeln('  Changed.');
                                 end else
                                 begin
                                   writeln('  Error.');
                                 end;
                              nextcmd;
                              exit;
                            end;

                         writeln('  unknown');
                         nextcmd;
                       end;

             procedure HighlitghtWord(x,y:integer);
                       var xx  : integer;
                           b,l : integer;
                       begin

                         mem[$B800:(x*2+160*y+1)]:=$20;

                         shelldata.curs:='';

                         if mem[$B800:(x*2+160*y)]=$20 then
                            begin
                              if (x+80*y)>0 then
                                 for xx:=0 to x+y*80-1 do
                                     mem[$B800:(xx*2+1)]:=$7;
                              if (x+80*y)<80*25-1 then
                                 for xx:=x+y*80+1 to 80*25-1 do
                                     mem[$B800:(xx*2+1)]:=$7;
                              exit;
                            end;

                         xx:=x+80*y-1;
                         while (xx>=0) and
                               (mem[$B800:(xx*2)]<>$20) do dec(xx);

                         b:=xx;

                         inc(xx);
                         l:=0;
                         while mem[$B800:xx*2]<>$20 do
                               begin
                                 with shelldata do
                                   curs:=curs+chr(mem[$B800:xx*2]);
                                   inc(xx);
                                   inc(l);
                               end;

                         if (mem[$B800:(b-1)*2]=ord('<')) and
                            (mem[$B800:(xx+1)*2]=ord('>')) then
                            begin
                              if b-1>0 then
                                 for xx:=0 to b-1 do
                                     mem[$B800:(xx*2+1)]:=$7;
                              for xx:=b-1 to b+2+l do
                                  if xx<>(x+y*80) then
                                     mem[$B800:(xx*2+1)]:=$1F;
                              if b+l+2<80*25-1 then
                                 for xx:=b+l+3 to 80*25-1 do
                                     mem[$B800:(xx*2+1)]:=$7;
                            end else
                            begin
                              if b>=0 then
                                 for xx:=0 to b do
                                     mem[$B800:(xx*2+1)]:=$7;
                              for xx:=b+1 to b+l do
                                  if xx<>(x+y*80) then
                                     mem[$B800:(xx*2+1)]:=$F;
                              if b+l<80*25-1 then
                                 for xx:=b+l+1 to 80*25-1 do
                                     mem[$B800:(xx*2+1)]:=$7;
                            end;
                       end;

             begin
               LocalMess:=Message;
               arun:=false;
               case LocalMess.Mess of

                 PR_Init:
                   begin
                     if shelldata.running then
                        begin
                          SendMessage( LocalMess.dest,
                                       ToKernel,
                                       KE_StopProcess,
                                       0,nil);
                          exit;
                        end;
                     shelldata.running:=true;
                     if shelldata.first then
                        begin
                          Writeln;
                          Writeln('System 2001 shell menu: < help > < gui > < exit >');
                        end;
                     shelldata.first:=false;
                     nextcmd;
                     if kerneldata.exiting then
                        begin
                          writeln('exit');
                          processline('exit');
                          exit;
                        end;
                     inifile:='settings\system.ini';
                     if readinistring('system','runstate')<>'on' then exit;
                     arun:=true;
                     y:=readinivalue('autorun','num');
                     if y>0 then
                        for x:=1 to y do
                            begin
                              s:=readinistring('autorun',integertostring(x));
                              writeln(s);
                              ProcessLine(s);
                            end;
                     changeini('system','runstate','shell');
                   end;

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     shelldata.running:=false;
                     SendMessage( LocalMess.dest,
                                  ToKernel,
                                  KE_StopProcess,
                                  0,nil);
                   end;

                 CO_KB_Input :
                   begin
                     if (TCO_KB_INPUT(localmess.data^).code>=$20) and
                        (TCO_KB_INPUT(localmess.data^).code<=$7f) then
                        begin
                          shelldata.line:=shelldata.line+TCO_KB_INPUT(localmess.data^).character;
                          Write(TCO_KB_INPUT(localmess.data^).character);
                          SendMessage(LocalMess.Dest,
                                      ToConsole,
                                      CO_MS_ChangePos,
                                      0,nil);
                        end;
                     if (TCO_KB_INPUT(localmess.data^).code=8) and
                        (shelldata.line<>'') then
                        begin
                          dec(shelldata.line[0]);
                          Write(#8,#32,#8);
                        end;
                     if (TCO_KB_INPUT(localmess.data^).code=13) and
                        (shelldata.line<>'') then
                        begin
                          writeln;
                          ProcessLine(Shelldata.line);
                          Shelldata.line:='';
                        end;
                     SendMessage(LocalMess.Dest,
                                 ToConsole,
                                 CO_MS_ChangePos,
                                 0,nil);
                   end;

                 CO_MS_ChangePos :
                   begin
                     x :=TCO_MS_ChangePos(localmess.data^).newposition.x;
                     y :=TCO_MS_ChangePos(localmess.data^).newposition.y;
                     xo:=TCO_MS_ChangePos(localmess.data^).oldposition.x;
                     yo:=TCO_MS_ChangePos(localmess.data^).oldposition.y;
                     HighlitghtWord(x,y);
                   end;

                 CO_MS_ReleaseRight :
                   with shelldata do
                    if curs<>'' then
                       if line='' then
                          begin
                            write(curs);
                            line:=curs;
                            Force_MS_pos;
                          end else
                          begin
                            write(' ',curs);
                            line:=line+' '+curs;
                            Force_MS_pos;
                          end else
                       if line='' then
                          begin
                            write('help');
                            line:='help';
                            Force_MS_pos;
                            GenerateKey(13);
                          end;

                 CO_MS_ReleaseLeft :
                   with shelldata do
                    if (line<>'') or (curs<>'') then
                       begin
                         if line='' then
                            begin
                              line:=curs;
                              write(curs);
                              Force_MS_pos;
                            end;
                         GenerateKey(13);
                       end;

                 UP_Message :
                   begin
                     Shelldata.line:='';
                     writeln;
                     write('> ');
                     Force_MS_pos;
                   end;

               end;

             end;






   procedure ExtJump    (p:TProcessID;m:word);
             begin
               sendmessage(process.id,p,m,0,nil);
             end;

   procedure FromToJump (FromP,DestP:TProcessID;m:word);
             begin
               sendmessage(fromp,destp,m,0,nil);
             end;

   procedure SendLine(p:TProcessID;s:string);
             var DTA : record
                         num : word;
                         str : string;
                       end;
             begin
               DTA.num:=1;
               DTA.str:=s;
               SendMessage(process.id,p,KE_LineIN,sizeof(dta),addr(dta));
             end;


   procedure MouseSetGraphSensitivity;
             var DTA:TCO_MS_SetSensitivity;
             begin
               with DTA do
                begin
                  xaxis:=2;
                  yaxis:=2;
                end;
              SendMessage(process.id,ToConsole,
                          CO_MS_SetSensitivity,
                          sizeof(DTA),addr(DTA));
             end;

   procedure MouseSetTextSensitivity;
             var DTA:TCO_MS_SetSensitivity;
             begin
               with DTA do
                begin
                  xaxis:=12;
                  yaxis:=12;
                end;
              SendMessage(process.id,ToConsole,
                          CO_MS_SetSensitivity,
                          sizeof(DTA),addr(DTA));
             end;

   procedure MouseSetRange(rx,ry:integer);
             var DTA:TCO_MS_SetRange;
             begin
               with DTA do
                begin
                  min.x:=0;
                  min.y:=0;
                  max.x:=rx-1;
                  max.y:=ry-1;
                end;
              SendMessage(process.id,ToConsole,
                          CO_MS_SetRange,
                          sizeof(DTA),addr(DTA));
             end;

   procedure MouseSetPosition(px,py:integer);
             var DTA:TCO_MS_SetPosition;
             begin
               with DTA do
                begin
                  x:=px;
                  y:=py;
                end;
              SendMessage(process.id,ToConsole,
                          CO_MS_SetPosition,
                          sizeof(DTA),addr(DTA));
             end;

   Procedure Force_MS_POS;
             begin
               SendMessage(Process.ID,ToConsole,CO_MS_ChangePos,0,nil);
             end;

   Procedure CloseProcess;
             begin
               SendMessage(Process.ID,Process.ID,PR_Kill,0,nil);
             end;

   Procedure CloseSystem;
             var DTA : TKE_KillAll;
             begin
               DTA:=KE_KILL_NORMAL;
               SendMessage(FromUnknown,ToKernel,
                           KE_KillAll,
                           sizeof(DTA),addr(DTA))
             end;

   Procedure CloseGui;
             begin
               SendMessage(process.id,ToGui,UP_Message+101,0,nil);
             end;

   Procedure HibernateSystem;
             var DTA : TKE_KillAll;
             begin
               DTA:=KE_KILL_HIBERNATE;
               SendMessage(FromUnknown,ToKernel,
                           KE_KillAll,
                           sizeof(DTA),addr(DTA))
             end;

   Procedure GenerateKey(c:word);
             var DTA : TCO_KB_GenerateKeyPress;
             begin
               DTA.code:=c;
               SendMessage(FromUnknown,ToConsole,
                           CO_KB_GenerateKeyPress,
                           sizeof(DTA),addr(DTA))
             end;

   Procedure RunInternal(a:pointer;f:byte;s,p:string);
             Var ProcessToRegister : TKE_StartProcess;
             begin
               With ProcessToRegister.Process do
                    begin
                      ID:=GetNewProcessID;
                      CS_Size:=0;
                      CS_Ptr:=nil;
                      DS_Size:=0;
                      DS_Ptr:=nil;
                      Flags:=f;
                      @Handle:=a;
                      name:=s;
                    end;
               ProcessToRegister.param:=p;
               SendMessage( Process.ID, ToKernel,
                            KE_StartProcess,
                            sizeof(ProcessToRegister),
                            addr(ProcessToRegister));
             end;

   Procedure RunShell;
             begin
               runinternal(addr(SystemShell),
                           PROC_Application + PROC_Console,
                           'System shell','');
             end;

  var  KbdIntVec : Procedure;
  Type VidMemType      = array[0..1999] of word;
  Var  TempVideoMemory : VidMemType;
       TextVideoMemory : VidMemType absolute $B800:$0000;
       cur   : word;
       vmode : word;
       i     : integer;
       c     : byte;

   Procedure ProcList1;
             begin
               asm
                 mov ax,4f03h
                 int 10h
                 mov vmode,bx
               end;
               if vmode=3 then
                  begin
                    TempVideoMemory:=TextVideoMemory;
                    asm
                      mov ax,300h
                      mov bh,0
                      int 10h
                      mov cur,dx
                      mov ax,200h
                      mov bh,0
                      mov dx,0
                      int 10h
                    end;
                  end else
                  begin
                    asm
                      mov ax,83h
                      int 10h
                    end;
                  end;
               for i:=0 to 1999 do TextVideoMemory[i]:=$0920;
               writeln;
               writeln('ID:   Process name:    Flags:');
               with kerneldata do
                    for i:=0 to NumOfProcesses-1 do
                        begin
                          with ProcessData[i] do
                           begin
                             write(ID:5,'  ',copy(name+'                ',1,16),
                                   ' ',copy(FlagTostring(flags)+
                                   '                          ',1,30));
                             if DS_size<>0 then write('DS:',DS_size:5,' B  ') else write('            ');
                             if CS_size<>0 then write('CS:',CS_size:5,' B  ') else write('            ');
                             writeln;
                           end;
                        end;
               writeln;
               writeln('   Free conventional memory:          ',memavail,' bytes');
               writeln('   Largest free memory block:         ',maxavail,' bytes');
               writeln('   REAS memory manager: Total memory: ',longint(xms.maxmemory)*1024,' bytes');
               writeln('                        Free memory:  ',xms.freemem,' bytes');
               if vmode<>3 then
                  begin
                    writeln;
                    writeln('   Video mode: ',guidesktop.size.x,' x ',guidesktop.size.y,' pixels, 24 bits per pixel');
                  end;
               writeln;
               writeln('   CONSOLE=',ToConsole,' GRAPH=',tograph,' WINS=',towins);
               {Kerneldata.MessageSystem^.ListMessages;}
             end;

   Procedure ProcList2;
             begin
               if vmode=3 then
                  begin
                    TextVideoMemory:=TempVideoMemory;
                    asm
                      mov ax,200h
                      mov bh,0
                      mov dx,cur
                      int 10h
                    end;
                  end else
                  begin
                    mousesetgraphsensitivity;
                    with guidesktop.size do mousesetrange(x,y);
                    asm
                      mov ax,4f02h
                      mov bx,vmode
                      or  bx,8000h
                      int 10h
                    end;
                    {render the first two segments}
                    with guidesktop.size do WinsRender(0,0,x-1,(128*1024) div (3*x));
                  end;
             end;







{$F+}
procedure Keyclick; interrupt;
begin
  if Port[$60] = $36 then proclist1;
  if Port[$60] = $B6 then proclist2;
  inline ($9C);
  KbdIntVec;
end;
{$F-}
 Begin
   shelldata.first:=true;
   shelldata.running:=false;
   mustinsertnothing:=false;
   kerneldata.exiting:=false;

{   GetIntVec($9,@KbdIntVec);
   SetIntVec($9,Addr(Keyclick));
}
 End.











