{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      SYSTEM TYPES UNIT


  Programmed by:      Rozsnyo Daniel

  Version:            1.00.030
  Release date:       2001-02-22
  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}
{

  This file contains the definition of used types and constans

      MessageSystem
      |
      +- Kernel
      |
      +- Graphics Driver
      |  |
      |  +- Basic Function
      |  |
      |  +- Direct Output Functions
      |  |
      |  +- Accelerated Functions
      |
      +- Console
      |  |
      |  +- Keyboard Input
      |  |
      |  +- Mouse Input
      |
      +- WINS IV
      |
      |

}

Unit Types;

Interface

 Uses  AdvMM;

 Type  TProcessID    = Word;                      { Identifies the process  }

       TMessage      = record
                         From    : TProcessID;    { Sender process          }
                         Dest    : TProcessID;    { Destination process     }
                         Mess    : Word;          { Message                 }
                         Size    : Word;          { Additional data size    }
                         Data    : Pointer;       { Additional data pointer }
                       end;

       PMessage      = ^TMessage;

       TMessageArray = array[0..255] of TMessage; { Message queue           }
       PMessageArray = ^TmessageArray;


       TPoint        = record                     { Point on 2D screen      }
                         X       : integer;
                         Y       : integer;
                       end;

       TRect         = record                     { Rectangle on 2D screen  }
                         Pos     : Tpoint;
                         Size    : Tpoint;
                       end;

       TColor        = Longint;                   { Color code as $AARRGGBB }

       TColorArr     = array [0..256] of TColor;

       PColorArr     = ^TColorArr;

       TRGBColor     = record                     { Color in R,G,B system   }
                         B       : byte;
                         G       : byte;
                         R       : byte;
                       end;

       TRGBAColor    = record                     { Color with alpha chanel }
                         B       : byte;
                         G       : byte;
                         R       : byte;
                         A       : byte;
                       end;

       TRGBColorArr  = array[0..256] of TRGBcolor;   { RGB color line   }

       PRGBColorArr  = ^TRGBcolorArr;

       TRGBAColorArr = array[0..256] of TRGBAcolor;  { RGBA color line  }

       PRGBAColorArr = ^TRGBAcolorArr;

       TBuff         = array[0..65520] of byte;      { buffer           }

       PBuff         = ^TBuff;

       TDateTime     = record
                         Year      : Word;  { 2001           }
                         Month     : Byte;  { 1..12          }
                         Day       : Byte;  { 1..28|29|30|31 }
                         DayOfWeek : Byte;  { 0(SU).. 6(SA)  }
                         Hrs       : Byte;  { 0..23          }
                         Min       : Byte;  { 0..59          }
                         Sec       : Byte;  { 0..59          }
                         HoS       : Byte;  { 0..99          }
                       end;

       TProcessName  = string[20];

       TProcess      = record
                         ID      : TProcessID;
                         Handle  : procedure;
                         CS_Size : Word;
                         CS_PTR  : Pointer;
                         DS_Size : Word;
                         DS_PTR  : Pointer;
                         Flags   : Byte;
                         Name    : TProcessName;
                       end;

         Const PROC_DRIVER      = $01;  { the process is driver             }
               PROC_APPLICATION = $02;  { the process is application        }
               PROC_CONSOLE     = $04;  { allow console input               }
               PROC_MULTITASK   = $08;  { need KE_Nothing message           }
               PROC_VISUAL      = $10;  { this is an WINS IV application    }
               PROC_DEAD        = $20;  { this process is dead              }
               PROC_EXTERNAL    = $80;  { memory was allocated by kernel    }

 Type  PProcess      = ^TProcess;

       TProcessTable = array[0..1023] of PProcess;

 Const

   { OK - this event works                                                 }
   { UC - under construction                                               }

   {KERNEL}
       KE_Nothing               = $0000;      { event for process   } { OK }
       KE_StartProcess          = $0001;      { command to kernel   } { OK }
       KE_RunFile               = $0002;      { command to kernel   }
       KE_KillProcess           = $0003;      { command to kernel   } { OK }
       KE_KillAll               = $0004;      { command to kernel   } { OK }
       KE_StopProcess           = $0005;      { command to kernel   } { OK }
       KE_LineIn                = $0006;      { event for process   }
       KE_BinaryIn              = $0007;      { event for process   }
       PR_Init                  = $0008;      { event for process   } { OK }
       PR_Close                 = $0009;      { event for process   } { OK }
       PR_Hibernate             = $000A;      { event for process   } { OK }
       PR_Kill                  = $000B;      { event for process   } { OK }
       KE_GetVersionInfo        = $000C;      { event for process   }
       KE_VersionInfo           = $000D;      { event for process   }

   {GRAPHICS DRIVER}
       GP_DRIVERSCOUNT          = $0010;      {   -> w              }
       GP_DRIVERSNAME           = $0011;      { w -> string         }
       GP_USEDRIVER             = $0012;      { w ->                }
       GP_MODECOUNT             = $0013;      {   -> w              }
       GP_MODEINFO              = $0014;      { w -> x,y,bpp [w,w,b]}
       GP_SETMODE               = $0015;      { w ->                }

       GD_GetAdapterInfo        = $0010;      { event for GrDriver  } { OK }
       GD_GetNumberOfModes      = $0011;      { event for GrDriver  } { OK }
       GD_GetModeInfo           = $0012;      { event for GrDriver  } { OK }
       GD_SetMode               = $0013;      { event for GrDriver  } { OK }
       GD_GetMode               = $0014;      { event for GrDriver  }

       GD_GetStandByStatus      = $0015;      { event for GrDriver  }
       GD_SetStandByMode        = $0016;      { event for GrDriver  }
       GD_Paint_24              = $0017;      { event for GrDriver  } { OK }
       GD_Paint_16              = $0018;      { event for GrDriver  }
       GD_Paint_15              = $0019;      { event for GrDriver  }
       GD_Paint_08              = $001A;      { event for GrDriver  }
       GD_Paint_04              = $001B;      { event for GrDriver  }
       GD_Paint_01              = $001C;      { event for GrDriver  }
       GD_SetPalette            = $001D;      { event for GrDriver  }
       GD_GetPalette            = $001E;      { event for GrDriver  }
       GD_GetLine_24            = $001F;      { event for GrDriver  }

   {GRAPHICS DRIVER - Direct Out }
       GD_DO_SetPosition        = $0020;      { event for GrDriver  }
       GD_DO_SetSize            = $0021;      { event for GrDriver  }
       GD_DO_SetWindow          = $0022;      { event for GrDriver  }
       GD_DO_Write              = $0023;      { event for GrDriver  }
       GD_DO_Read               = $0024;      { event for GrDriver  }
       GD_DO_Peek               = $0025;      { event for GrDriver  }

   {GRAPHICS DRIVER - Accelerated functions }
       GD_AF_FillScreen         = $0026;      { event for GrDriver  }
       GD_AF_Bar                = $0027;      { event for GrDriver  }
       GD_AF_PutImage           = $0028;      { event for GrDriver  } { OK }
       GD_AF_GetImage           = $0029;      { event for GrDriver  } { ?? }
       GD_AF_CopyImage          = $002A;      { event for GrDriver  } { ?? }

   {CONSOLE}
       CO_CheckState            = KE_Nothing; { event for Console   } { OK }

   {CONSOLE - Keyboard driver    }
       CO_KB_GenerateKeyPress   = $0030;      { command to Console  } { OK }
       CO_KB_Input              = $0031;      { event for process   } { OK }

   {CONSOLE - Mouse driver }
       CO_MS_ChangePos          = $0038;      { event for process   } { OK }
       CO_MS_PressLeft          = $0039;      { event for process   } { OK }
       CO_MS_ReleaseLeft        = $003A;      { event for process   } { OK }
       CO_MS_PressRight         = $003B;      { event for process   } { OK }
       CO_MS_ReleaseRight       = $003C;      { event for process   } { OK }
       CO_MS_SetSensitivity     = $003D;      { command to Console  } { OK }
       CO_MS_SetPosition        = $003E;      { command to Console  } { OK }
       CO_MS_SetRange           = $003F;      { command to Console  } { OK }

   {WINS IV MESSAGES }
       WI_Render                = $0100;      { command for wins    } { OK }
       WI_NewWindow             = $0101;      { command for wins    } { OK }

       WI_MakeActive            = $0102;      { command for wins    } { OK }
       WI_MakeInActive          = $0103;      { command for wins    } { OK }

       WI_ActivateMe            = $0104;      { command for wins    } { OK }



       WI_ChangeResolution      = $0110;      { event for process   } { OK }
       WI_PrepareToChangeRes    = $0111;      { event for process   } { OK }



       WI_Activate              = $0180;      { event for vis. proc } { OK }
       WI_DeActivate            = $0181;      { event for vis. proc } { OK }
       WI_StartDrag             = $0182;      { event for vis. proc } { OK }
       WI_EndDrag               = $0183;      { event for vis. proc } { OK }
       WI_Move                  = $0184;      { event for vis. proc } { OK }
       WI_TitleClick            = $0185;      { event for vis. proc } { OK }




       WI_OnWindow              = $0190;      { event for vis. proc } { OK }
       WI_OverWindow            = $0191;      { event for vis. proc } { OK }
       WI_OffWindow             = $0192;      { event for vis. proc } { OK }
       WI_OnPress               = $0193;      { event for vis. proc } { OK }
       WI_OnRelease             = $0194;      { event for vis. proc } { OK }
       WI_Char                  = $0195;      { event for vis. proc } { OK }



       WI_Ok                    = $01A0;      { qestion result      } { OK }
       WI_Cancel                = $01A1;      { qestion result      } { OK }
       WI_Yes                   = $01A2;      { qestion result      } { OK }
       WI_No                    = $01A3;      { qestion result      } { OK }




       WI_TB_Close              = $01B0;      { titlebutton command } { OK }
       WI_TB_Title              = $01B1;      { titlebutton command } { OK }

       WI_CLOSEAPP              = $01B8;      { close the window    } { OK }

       WI_SubID                 = $01BC;      { subprocess ID       } { OK }
       WI_SubClose              = $01BD;      { submenu closed      } { OK }
       WI_SubCloseOK            = $01BE;      { submenu closed comm } { OK }
       WI_SubLocked             = $01BF;      { submenu closed lock } { OK }


       WI_Button                = $01D0;      { button              } { OK }
       WI_FlatButton            = $01D1;      { button - old style  } { OK }
       WI_MenuButton            = $01D2;      { button for menu     } { OK }
       WI_LineIn                = $01D3;      { line input box      } { OK }
       WI_LogicalButton         = $01D4;      { logical button      } { OK }
       WI_CheckBox              = $01D5;      { checkbox [ ] [X]    } { OK }

       WI_ListBox               = $01E0;      { listbox BASE        } { OK }

          { reserved from 0x01E1 to 0x01EF }

       LB_Draw                  = $01F0;      { initial draw        } { OK }
       LB_Pressed               = $01F1;      { draw as pressed     } { OK }
       LB_OnMouse               = $01F2;      { draw as mouse-over  } { OK }
       LB_OffMouse              = $01F3;      { draw as mouse off   } { OK }


       WI_Keycode               = $0200;      { event for vis. proc } { OK }

          { reserved from 0x0200 to 0x03FF }

          WI_KB_BS              = $0208;
          WI_KB_Tab             = $0209;
          WI_KB_Enter           = $020D;
          WI_KB_Esc             = $021B;

          WI_KB_STab            = $030F;
          WI_KB_Space           = $0220;
          WI_KB_Del             = $0353;
          WI_KB_Home            = $0347;
          WI_KB_End             = $034f;
          WI_KB_Insert          = $0352;
          WI_KB_PgUp            = $0349;
          WI_KB_PgDown          = $0351;

          WI_KB_Left            = $034b;
          WI_KB_Right           = $034d;
          WI_KB_Up              = $0348;
          WI_KB_Down            = $0350;

          WI_KB_F1              = $033B;
          WI_KB_F2              = $033C;
          WI_KB_F3              = $033D;
          WI_KB_F4              = $033E;
          WI_KB_F5              = $033F;
          WI_KB_F6              = $0340;
          WI_KB_F7              = $0341;
          WI_KB_F8              = $0342;
          WI_KB_F9              = $0343;
          WI_KB_F10             = $0344;

          WI_KB_Shift_F1        = $033B+25;
          WI_KB_Shift_F2        = $033C+25;
          WI_KB_Shift_F3        = $033D+25;
          WI_KB_Shift_F4        = $033E+25;
          WI_KB_Shift_F5        = $033F+25;
          WI_KB_Shift_F6        = $0340+25;
          WI_KB_Shift_F7        = $0341+25;
          WI_KB_Shift_F8        = $0342+25;
          WI_KB_Shift_F9        = $0343+25;
          WI_KB_Shift_F10       = $0344+25;

          WI_KB_Ctrl_F1         = $033B+35;
          WI_KB_Ctrl_F2         = $033C+35;
          WI_KB_Ctrl_F3         = $033D+35;
          WI_KB_Ctrl_F4         = $033E+35;
          WI_KB_Ctrl_F5         = $033F+35;
          WI_KB_Ctrl_F6         = $0340+35;
          WI_KB_Ctrl_F7         = $0341+35;
          WI_KB_Ctrl_F8         = $0342+35;
          WI_KB_Ctrl_F9         = $0343+35;
          WI_KB_Ctrl_F10        = $0344+35;

          WI_KB_Alt_F1          = $033B+45;
          WI_KB_Alt_F2          = $033C+45;
          WI_KB_Alt_F3          = $033D+45;
          WI_KB_Alt_F4          = $033E+45;
          WI_KB_Alt_F5          = $033F+45;
          WI_KB_Alt_F6          = $0340+45;
          WI_KB_Alt_F7          = $0341+45;
          WI_KB_Alt_F8          = $0342+45;
          WI_KB_Alt_F9          = $0343+45;
          WI_KB_Alt_F10         = $0344+45;


       WI_Object                = $3000;      { event from an object} { OK }
       MN_Action                = $3800;      { event from menu     } { OK }

   {USER PROGRAMS}

       UP_Message               = $4000;      { command for process } { OK }



{

       DEFINITION OF MESSAGE ADDITIONAL DATA
       -------------------------------------

}

 Type  TKE_StartProcess         = record
                                    Process     : TProcess;
                                    Param       : string;
                                  end;

       TKE_RunFile              = record
                                    Directory   : String;
                                    FileName    : String;
                                    Param       : string;
                                  end;

       TKE_KillProcess          = record
                                    Process     : TProcessID;
                                    KillType    : Byte;
                                  end;

 Type  TKE_KillAll              = Byte;

         Const KE_KILL_NORMAL     = $00;  { close application   - CLOSE }
               KE_KILL_HARD       = $01;  { immediatelly close  - KILL  }
               KE_KILL_HIBERNATE  = $02;  { save and immediately close  }

 Type  TKE_VersionInfo          = record
                                    Major       : Byte;
                                    Minor       : Byte;
                                    Build       : Word;
                                    Company     : String[200];
                                    Name        : String[200];
                                    Language    : String[64];
                                    Date        : TDateTime;
                                  end;

       TKE_LineIn               = record
                                    NumLines    : Word;
                                    Lines       : array[0..9] of string[255];
                                  end;

       TKE_BinaryIn             = record
                                    Length      : Word;
                                    Data        : array[0..256] of Byte;
                                  end;

       TPR_Init                 = record
                                    ParentID    : TProcessID;
                                    InitType    : Byte;
                                    Param       : string;
                                  end;

         Const PR_INIT_NORMAL     = $00;  { new process     }
               PR_INIT_HIBERNATE  = $01;  { load saved data }

 Type
       TGP_ModeInfo             = record
                                    size        : TPoint;
                                    bitcount    : byte;
                                  end;

       TGD_GetAdapterInfo       = record
                                    InfoVersion : Byte;
                                    MemorySize  : Word;
                                    AdapterName : String[64];
                                  end;

       TGD_GetNumberOfModes     = Word;

       TGD_GetModeInfo          = record
                                    InfoVersion : Byte;
                                    Size        : Tpoint;
                                    NumPixels   : Longint;
                                    NumBytes    : Longint;
                                    BytePerLine : Word;
                                    BitsPerPixel: Byte;
                                    ModeNumber  : Word;
                                    Graphical   : Boolean;
                                    Supported   : Boolean;
                                  end;

       TGD_SetMode              = record
                                    ModeNumber  : Word;
                                    ClearMem    : Boolean;
                                    Color       : TColor;
                                  end;

       TGD_GetMode              = record
                                    Graphics    : Boolean;
                                    Size        : TPoint;
                                    Number      : Word;
                                  end;

       TGD_GetStandByStatus     = Byte;

         Const GD_STBY_NORMAL     = $00;
               GD_STBY_SLEEP      = $01;

 Type  TGD_SetStandByMode       = Byte;

         Const GD_STBY_GOSLEEP    = $00;
               GD_STBY_WAKEUP     = $01;

 Type  TGD_Paint_24             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_Paint_16             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of Word;
                                  end;

       TGD_Paint_15             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of Word;
                                  end;

       TGD_Paint_08             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of Byte;
                                  end;

       TGD_Paint_04             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of Byte;
                                  end;

       TGD_Paint_01             = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of Byte;
                                  end;

       TGD_SetPalette           = record
                                    FirstItem   : Byte;
                                    LastItem    : Byte;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_GetPalette           = record
                                    Bits        : Byte;
                                    Data        : array[0..255] of TRGBColor;
                                  end;

       TGD_GetLine_24           = record
                                    Position    : TPoint;
                                    Length      : Word;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_DO_SetPosition       = TPoint;

       TGD_DO_SetSize           = TPoint;

       TGD_DO_SetWindow         = record
                                    Position    : TPoint;
                                    Size        : TPoint;
                                  end;

       TGD_DO_Write             = record
                                    Length      : Word;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_DO_Read              = record
                                    Length      : Word;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_DO_Peek              = record
                                    Length      : Word;
                                    Data        : array[0..256] of TRGBColor;
                                  end;

       TGD_AF_FillScreen        = TRGBColor;

       TGD_AF_Bar               = record
                                    Position    : TPoint;
                                    Size        : TPoint;
                                    Color       : TRGBColor;
                                  end;

       TGD_AF_PutImage          = record
                                    Position    : Tpoint;
                                    Size        : Tpoint;
                                    BytePerLine : Word;
                                    SourcePos   : Tpoint;
                                    Image       : PammPart;
                                  end;

       TGD_AF_GetImage          = record
                                    Position    : Tpoint;
                                    Size        : Tpoint;
                                    BytePerLine : Word;
                                    SourcePos   : Tpoint;
                                    Image       : PammPart;
                                  end;

       TGD_AF_CopyImage         = record
                                    Position    : Tpoint;
                                    Size        : Tpoint;
                                    NewPosition : Tpoint;
                                  end;

       TCO_KB_Input             = record
                                    Character   : Char;
                                    Code        : Word;
                                    Flags       : Byte;
                                  end;

       TCO_KB_GenerateKeyPress  = TCO_KB_Input;

       TCO_MS_ChangePos         = record
                                    NewPosition : TPoint;
                                    OldPosition : TPoint;
                                  end;

       TCO_MS_PressLeft         = TPoint;

       TCO_MS_ReleaseLeft       = TPoint;

       TCO_MS_PressRight        = TPoint;

       TCO_MS_ReleaseRight      = TPoint;

       TCO_MS_SetSensitivity    = record
                                    Xaxis       : Byte;
                                    Yaxis       : Byte;
                                  end;

       TCO_MS_SetPosition       = Tpoint;

       TCO_MS_SetRange          = record
                                    Min         : Tpoint;
                                    Max         : Tpoint;
                                  end;

       TWI_Render               = record
                                    Min         : Tpoint;
                                    Max         : Tpoint;
                                  end;

       TWI_Char                 = TCO_KB_Input;


       TLB_Draw                 = word;
       TLB_OnMouse              = word;
       TLB_OffMouse             = word;
       TLB_Pressed              = word;






 Type  PKE_StartProcess         = ^TKE_StartProcess;
       PKE_RunFile              = ^TKE_RunFile;
       PKE_KillProcess          = ^TKE_KillProcess;
       PKE_KillAll              = ^TKE_KillAll;
       PKE_VersionInfo          = ^TKE_VersionInfo;
       PKE_LineIn               = ^TKE_LineIn;
       PKE_BinaryIn             = ^TKE_BinaryIn;
       PPR_Init                 = ^TPR_Init;

       PGD_GetAdapterInfo       = ^TGD_GetAdapterInfo;
       PGD_GetNumberOfModes     = ^TGD_GetNumberOfModes;
       PGD_GetModeInfo          = ^TGD_GetModeInfo;
       PGD_SetMode              = ^TGD_SetMode;
       PGD_GetMode              = ^TGD_GetMode;
       PGD_GetStandByStatus     = ^TGD_GetStandByStatus;
       PGD_SetStandByMode       = ^TGD_SetStandByMode;
       PGD_Paint_24             = ^TGD_Paint_24;
       PGD_Paint_16             = ^TGD_Paint_16;
       PGD_Paint_15             = ^TGD_Paint_15;
       PGD_Paint_08             = ^TGD_Paint_08;
       PGD_Paint_04             = ^TGD_Paint_04;
       PGD_Paint_01             = ^TGD_Paint_01;
       PGD_SetPalette           = ^TGD_SetPalette;
       PGD_GetPalette           = ^TGD_GetPalette ;
       PGD_GetLine_24           = ^TGD_GetLine_24;

       PGD_DO_SetPosition       = ^TGD_DO_SetPosition;
       PGD_DO_SetSize           = ^TGD_DO_SetSize;
       PGD_DO_SetWindow         = ^TGD_DO_SetWindow;
       PGD_DO_Write             = ^TGD_DO_Write;
       PGD_DO_Read              = ^TGD_DO_Read;
       PGD_DO_Peek              = ^TGD_DO_Peek;

       PGD_AF_FillScreen        = ^TGD_AF_FillScreen;
       PGD_AF_Bar               = ^TGD_AF_Bar;
       PGD_AF_PutImage          = ^TGD_AF_PutImage;
       PGD_AF_GetImage          = ^TGD_AF_GetImage;
       PGD_AF_CopyImage         = ^TGD_AF_CopyImage;

       PCO_KB_GenerateKeyPress  = ^TCO_KB_GenerateKeyPress;
       PCO_KB_Input             = ^TCO_KB_Input;

       PCO_MS_ChangePos         = ^TCO_MS_ChangePos;
       PCO_MS_PressLeft         = ^TCO_MS_PressLeft;
       PCO_MS_ReleaseLeft       = ^TCO_MS_ReleaseLeft;
       PCO_MS_PressRight        = ^TCO_MS_PressRight;
       PCO_MS_ReleaseRight      = ^TCO_MS_ReleaseRight;
       PCO_MS_SetSensitivity    = ^TCO_MS_SetSensitivity;
       PCO_MS_SetPosition       = ^TCO_MS_SetPosition;
       PCO_MS_SetRange          = ^TCO_MS_SetRange;

       PWI_Render               = ^TWI_Render;
       PWI_Char                 = ^TWI_Char;

       PLB_Draw                 = ^TLB_Draw;
       PLB_OnMouse              = ^TLB_OnMouse;
       PLB_OffMouse             = ^TLB_OffMouse;
       PLB_Pressed              = ^TLB_Pressed;

       TProcessorData           = record
                                    EAX    : longint;
                                    EBX    : longint;
                                    ECX    : longint;
                                    EDX    : longint;
                                    Pages  : longint;
                                    Brand  : byte;
                                    ID     : byte;
                                    Model  : byte;
                                    Family : byte;
                                    Class  : ( prcls_Oem,
                                               prcls_OverDrive,
                                               prcls_Dual,
                                               prcls_Reserved );
                                    FPU    : boolean;
                                    VME    : boolean;
                                    DE     : boolean;
                                    PSE    : boolean;
                                    TSC    : boolean;
                                    MSR    : boolean;
                                    PAE    : boolean;
                                    MCE    : boolean;
                                    CX8    : boolean;
                                    APIC   : boolean;
                                    {RES   : boolean;}
                                    SEP    : boolean;
                                    MTRR   : boolean;
                                    PGE    : boolean;
                                    MCA    : boolean;
                                    CMOV   : boolean;
                                    FGPAT  : boolean;
                                    PSE36  : boolean;
                                    PSN    : boolean;
                                    CLFSH  : boolean;
                                    {RES   : boolean;}
                                    DS     : boolean;
                                    ACPI   : boolean;
                                    MMX    : boolean;
                                    FXSR   : boolean;
                                    SSE    : boolean;
                                    SSE2   : boolean;
                                    SS     : boolean;
                                    {RES   : boolean;}
                                    TM     : boolean;
                                    Cache  : array[0..15] of byte;
                                    Serial : string[16];
                                  end;

       TBiosDiskData            = record
                                    C      : word;
                                    H      : word;
                                    S      : word;
                                  end;

       TIDEDiskData             = record
                                    Model  : string[40];
                                    SN     : string[20];
                                    Rev    : string[8];
                                  end;


   Type
           TTitleButton = record
                            onmouse : boolean;
                            pressed : boolean;
                            icon    : char;
                            command : word;
                          end;

   Const
           TB_CloseIcon = #192;
           TB_MaximIcon = #193;
           TB_RestoIcon = #194;
           TB_TitleIcon = #195;
           TB_DeTitIcon = #196;

           TBUTT_Close  : TTitleButton = (onmouse:false;
                                          pressed:false;
                                          icon:TB_CloseIcon;
                                          command:WI_TB_Close);
           TBUTT_Title  : TTitleButton = (onmouse:false;
                                          pressed:false;
                                          icon:TB_TitleIcon;
                                          command:WI_TB_Title);

   procedure BSOD(error,d1,d2,d3,d4:string);

Implementation

   procedure BSOD(error,d1,d2,d3,d4:string);
             Type VidMemType      = array[0..1999] of word;
             Var  TempVideoMemory : VidMemType;
                  TextVideoMemory : VidMemType absolute $B800:$0000;
                  cur   : word;
                  vmode : word;
                  i     : integer;
                  c     : byte;
             begin
               asm
                 mov ax,4f03h
                 int 10h
                 mov vmode,bx
               end;
               if vmode=3 then
                  begin
                    TempVideoMemory:=TextVideoMemory;
                    asm
                      mov ax,300h
                      mov bh,0
                      int 10h
                      mov cur,dx
                      mov ax,200h
                      mov bh,0
                      mov dx,0
                      int 10h
                    end;
                  end else
                  begin
                    asm
                      mov ax,83h
                      int 10h
                    end;
                  end;
               for i:=0 to 239 do TextVideoMemory[i]:=$0920;
               for i:=240 to 1759 do TextVideoMemory[i]:=$1F20;
               for i:=1760 to 1919 do TextVideoMemory[i]:=$0920;
               for i:=1920 to 1999 do TextVideoMemory[i]:=$0020;
               writeln;
               writeln('  SYSTEM 2001 version 6');
               writeln;
               writeln;
               writeln;
               writeln('  FATAL ERROR !');
               writeln;
               writeln('    ',copy(error,1,65));
               writeln;
               writeln(' ------------------------------------------------------------------------------');
               writeln;
               writeln('  DETAILS');
               writeln;
               writeln('    ',copy(d1,1,70));
               writeln('    ',copy(d2,1,70));
               writeln('    ',copy(d3,1,70));
               writeln('    ',copy(d4,1,70));
               writeln;
               writeln;
               writeln(' ------------------------------------------------------------------------------');
               writeln('    Press any key to exit ...');
               writeln;
               writeln;
               writeln('  (C) 1998-2001, Rozsnyo electronics and software');
               Asm
                 @zn: mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      je   @zn
                 @rk:
                      mov  ah, 8
                      int  21h
                      mov  c,al
                      mov  ax, 40h
                      mov  es, ax
                      mov  dx, es:[1ah]
                      mov  bx, es:[1ch]
                      xor  ax, ax
                      cmp  dx, bx
                      jne  @rk
                      mov  al,c
                      cmp  al,0
                      jne  @k
                      mov  ah,8
                      int  21h
                 @k:
               end;
               halt;
             end;

Begin
  asm
    mov ax,3h
    int 10h
  end;
end.
