{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      WINS APPLICATIONS


  Programmed by:      Rozsnyo Daniel

  Version:            1.10.028 B  from  2001-11-17
                      1.00.021 A  from  2001-02-18

  Language:           EN
  Copyright:          (C) 2001, Rozsnyo electronics and software

}
{$F+}

Unit WinsApp;

 Interface

   Uses    Types,      { System 2001 v.6 basic types                        }
           SysCalls,   { System 2001 v.6 system calls and message inserting }

           API,

           Ini,convert,bmp,memimage,gui,objects;

   Type

           TQuestionApp =  record
                             STD       : STDwindow;
                             parent    : word;
                           end;

           TErrorApp =     record
                             STD       : STDwindow;
                             parent    : word;
                           end;

           TMouseApp =     record
                             STD       : STDwindow;
                             oldpnum   : integer;
                           end;

           TGuiShellApp =  record
                             STD       : STDwindow;
                             timeshow  : TDateTime;
                             timearea  : TRect;
                             timecolor : TColor;
                             oldcolor  : TColor;
                             cpick     : boolean;
                           end;

           TTestApp =      record
                             STD       : STDwindow;
                             pt        : string;
                             af        : integer;
                             st        : byte;
                           end;

   Procedure RunWinsApp(appname,param:string);

   function  UserPath:string;
   procedure DrawIcon(x,y:integer;s:string);
   function  MTextShortcut(s:string):char;
   procedure DrawMtextCenter(x,y:integer;s:string;e:boolean);
   procedure DrawMtextLeft(x,y:integer;s:string;e:boolean);
   procedure DrawMString(x,y:integer;s:string);
   function  GetMtextLength(s:string;f1,f2:byte):integer;
   function  MakePasswordString(s:string;en:boolean):string;
   function  AmILocked:boolean;
   procedure DrawObjectInitial;
   procedure LoadObject(i:integer);
   procedure SaveObject(i:integer);
   procedure UpdateObject;
   Function  InBox(x,y,a,b:integer):boolean;
   procedure ObjectOnMouse;
   procedure ObjectPressed;
   procedure ObjectOffMouse;
   function  LineInKeypress(code:word):boolean;
   function  ObjectKeyPress(c:word):boolean;
   procedure CheckObjects(m:word);
   procedure WinsMainMenu(s:string);
   function  WinsObject(objcode:word;x,y,a,b:integer;s:string):word;
   procedure WinsDisable;
   procedure WinsEnable;
   procedure WinsChecked;
   procedure WinsNotChecked;
   procedure WinsNoEditable;
   procedure DrawAllObjectsInitial;
   procedure ReShowWindow;
   procedure MoveToFront;
   procedure MoveToTop;
   procedure Create(x,y,b:integer;o:word);
   procedure CenterWindow;
   procedure RandomWindow;
   procedure CloseWindow;
   procedure PlaceBmp(fn:string);
   procedure PlaceAlp(fn:string);
   procedure MoveWindowTo(nx,ny:integer);
   procedure LoadPos;
   procedure SavePos;
   procedure PrepareCanvas;
   procedure ActualizeCanvas;
   procedure WINS_Menu(x,y:integer;s:string);
   procedure WinsLineInPassword;
   function  LineInGetText(i:integer):string;
   procedure LineInSetText(i:integer;s:string);
   function  IsChecked(i:integer):boolean;
   procedure ChangeWindowTitle(s:string);
   procedure ButtonSetEnable(i:integer;en:boolean);

   procedure PlaceSign(fn:string;x,y:integer;c:char);

   procedure DrawMtextUsr(x,y:integer;s:string;e:boolean;
                          underline  : boolean;
                          normalfont : byte;
                          normalcolor: TColor;
                          shortfont  : byte;
                          shortcolor : TColor);
   procedure CloseSubWindow;


 Implementation
   uses font16,dos,advMM;

   Const DockUp       = 1;
         DockDown     = 2;
         DockLeft     = 3;
         DockRight    = 4;
         DockDisabled = 0;

         PS_Stop      = 0;
         PS_Play      = 1;
         PS_PlayBack  = 2;
         PS_Rewind    = 3;
         PS_Forward   = 4;

   var
        i      : integer;
        j      : integer;
        n      : byte;
        b      : boolean;

        {
          WINS components
        }
        CurrentObjectIndex : Integer;
        LockedObjectIndex  : integer;

   function  UserPath:string;
             begin
               userpath:='users\'+loggedperson.loginpath;
             end;

   procedure DrawIcon(x,y:integer;s:string);
             begin
               w^.canvas.placebmp(x,y,GuiDesktop.ThemeDir+'icons\'+s+'.bmp');
             end;

   function  MTextShortcut(s:string):char;
             var c:char;
                 i:integer;
             begin
               MtextShortcut:=#255;
               if length(s)<1 then exit;
               c:=#255;
               for i:=1 to length(s) do
                   if s[i]='&' then
                      begin
                        inc(i);
                        if i<=length(s) then
                           if s[i]<>'&' then
                              begin
                                c:=s[i];
                                break;
                              end;
                      end;
               MtextShortcut:=c;
             end;

   procedure DrawMtextCenter(x,y:integer;s:string;e:boolean);
             var t1,t2,t3 : string;
                 i        : integer;
                 f        : boolean;
                 l1,l2,l3 : integer;
                 l        : integer;
             begin
               if s='' then exit;
               f:=false;
               t1:='';
               t2:='';
               t3:='';
               for i:=1 to length(s) do
                   if s[i]<>'&'
                      then if f then t3:=t3+s[i]
                                else t1:=t1+s[i]
                      else begin
                             inc(i);
                             if length(s)<i then break;
                             if s[i]='&'
                                then t1:=t1+s[i]
                                else begin
                                       t2:=t2+s[i];
                                       f:=true;
                                     end;
                           end;
               setfont(norm,0);
               l1:=lenstring(t1);
               l3:=lenstring(t3);
               setfont(bold,0);
               l2:=lenstring(t2);
               l:=l1;
               if l2<>0 then l:=l+2+l2;
               if l3<>0 then l:=l+2+l3;
               if e then
                  begin
                    setfont(norm,mix($000000,WinsBackColor,$D0));
                    w^.canvas.drawstring(x-l div 2+1,y-6+1,t1);
                    setfont(norm,$000000);
                    w^.canvas.drawstring(x-l div 2,y-6,t1);
                    setfont(bold,mix($000080,WinsBackColor,$C0));
                    w^.canvas.drawstring(x-l div 2+l1+2+1,y-6+1,t2);
                    setfont(bold,$000080);
                    w^.canvas.drawstring(x-l div 2+l1+2,y-6,t2);
                    setfont(norm,mix($000000,WinsBackColor,$D0));
                    w^.canvas.drawstring(x-l div 2+l1+2+l2+2+1,y-6+1,t3);
                    setfont(norm,$000000);
                    w^.canvas.drawstring(x-l div 2+l1+2+l2+2,y-6,t3);
                  end else
                  begin
                    setfont(norm,mix($000000,WinsBackColor,$A0));
                    w^.canvas.drawstring(x-l div 2,y-6,t1);
                    setfont(bold,mix($000000,WinsBackColor,$A0));
                    w^.canvas.drawstring(x-l div 2+l1+2,y-6,t2);
                    setfont(norm,mix($000000,WinsBackColor,$A0));
                    w^.canvas.drawstring(x-l div 2+l1+2+l2+2,y-6,t3);
                  end;
             end;

   procedure DrawMtextUsr(x,y:integer;s:string;e:boolean;
                          underline  : boolean;
                          normalfont : byte;
                          normalcolor: TColor;
                          shortfont  : byte;
                          shortcolor : TColor);
             var t1,t2,t3 : string;
                 i        : integer;
                 f        : boolean;
                 l1,l2,l3 : integer;
                 l        : integer;
             begin
               if s='' then exit;
               f:=false;
               t1:='';
               t2:='';
               t3:='';
               for i:=1 to length(s) do
                   if s[i]<>'&'
                      then if f then t3:=t3+s[i]
                                else t1:=t1+s[i]
                      else begin
                             inc(i);
                             if length(s)<i then break;
                             if s[i]='&'
                                then t1:=t1+s[i]
                                else begin
                                       t2:=t2+s[i];
                                       f:=true;
                                     end;
                           end;
               setfont(norm,0);
               l1:=lenstring(t1);
               l3:=lenstring(t3);
               setfont(bold,0);
               l2:=lenstring(t2);
               l:=l1;
               if l2<>0 then l:=l+2+l2;
               if l3<>0 then l:=l+2+l3;
               if l1=0 then l1:=-2;
               l2:=l2+1;
               if e then
                  begin
                    setfont(normalfont,normalcolor);
                    w^.canvas.drawstring(x,y-6,t1);
                    setfont(shortfont,shortcolor);
                    w^.canvas.drawstring(x+l1+2,y-6,t2);
                    setfont(normalfont,normalcolor);
                    w^.canvas.drawstring(x+l1+2+l2,y-6,t3);
                    if underline then
                    if t2<>'' then
                       begin
                         w^.canvas.setcolor(shortcolor);
                         w^.canvas.line(x+l1+1,y+6,x+l1+l2,y+6);
                       end;
                  end else
                  begin
                    setfont(normalfont,mix(normalcolor,WinsBackColor,$A0));
                    w^.canvas.drawstring(x,y-6,t1);
                    setfont(shortfont,mix(shortcolor,WinsBackColor,$A0));
                    w^.canvas.drawstring(x+l1+2,y-6,t2);
                    setfont(normalfont,mix(normalcolor,WinsBackColor,$A0));
                    w^.canvas.drawstring(x+l1+2+l2,y-6,t3);
                    if underline then
                    if t2<>'' then
                       begin
                         w^.canvas.setcolor(mix(shortcolor,WinsBackColor,$A0));
                         w^.canvas.line(x+l1+1,y+6,x+l1+l2,y+6);
                       end;
                  end;
             end;

   procedure DrawMtextLeft(x,y:integer;s:string;e:boolean);
             begin
               DrawMtextUsr(x,y,s,e,true,norm,$000000,norm,$000000);
             end;

   procedure DrawMString(x,y:integer;s:string);
             var t1,t2,t3 : string;
                 i        : integer;
                 f        : boolean;
                 l1,l2,l3 : integer;
                 l        : integer;
             begin
               if s='' then exit;
               f:=false;
               t1:='';
               t2:='';
               t3:='';
               for i:=1 to length(s) do
                   if s[i]<>'&'
                      then if f then t3:=t3+s[i]
                                else t1:=t1+s[i]
                      else begin
                             inc(i);
                             if length(s)<i then break;
                             if s[i]='&'
                                then t1:=t1+s[i]
                                else begin
                                       t2:=t2+s[i];
                                       f:=true;
                                     end;
                           end;
               l1:=lenstring(t1);
               l2:=lenstring(t2);
               l3:=lenstring(t3);
               l:=l1;
               if l2<>0 then l:=l+2+l2;
               if l3<>0 then l:=l+2+l3;
               if l1=0 then l1:=-2;
               w^.canvas.drawstring(x,y-6,t1);
               w^.canvas.drawstring(x+l1+2,y-6,t2);
               w^.canvas.drawstring(x+l1+2+l2+2,y-6,t3);
               w^.canvas.setcolor(fonts.color);
               if l2>0 then
               w^.canvas.line(x+l1+2,y+6,x+l1+2+l2-1,y+6);
             end;

   function  GetMtextLength(s:string;f1,f2:byte):integer;
             var t1,t2,t3 : string;
                 i        : integer;
                 f        : boolean;
                 l1,l2,l3 : integer;
                 l        : integer;
             begin
               getmtextlength:=0;
               if s='' then exit;
               f:=false;
               t1:='';
               t2:='';
               t3:='';
               for i:=1 to length(s) do
                   if s[i]<>'&'
                      then if f then t3:=t3+s[i]
                                else t1:=t1+s[i]
                      else begin
                             inc(i);
                             if length(s)<i then break;
                             if s[i]='&'
                                then t1:=t1+s[i]
                                else begin
                                       t2:=t2+s[i];
                                       f:=true;
                                     end;
                           end;
               setfont(f1,0);
               l1:=lenstring(t1);
               l3:=lenstring(t3);
               setfont(f2,0);
               l2:=lenstring(t2);
               l:=l1;
               if l2<>0 then
                  if l1=0 then l:=l2
                          else l:=l+2+l2;
               if l3<>0 then l:=l+2+l3;
               getmtextlength:=l;
             end;

   function  MakePasswordString(s:string;en:boolean):string;
             var t:string;
                 i:integer;
             begin
               makepasswordstring:=s;
               if not en then exit;
               if s='' then exit;
               t:='';
               for i:=1 to length(s) do
                   t:=t+'*';
               makepasswordstring:=t;
             end;

   function  AmILocked:boolean;
             begin
               Amilocked:=w^.ObjectLock=CurrentObjectIndex;
             end;

   procedure DrawObjectInitial;
             var l  : integer;
                 s  : byte;
                 c  : TColor;
             begin
               with TStdObj(objptr^) do
               case ID of

                 WI_Button : begin
                               {if onmouse and enabled then ColorShift;}
                               if onmouse and not enabled then
                                  begin
                                    onmouse:=false;
                                    updateobject;
                                  end;
                               if w^.status.active and
                                  inbox(position.x,position.y,
                                        size.x,size.y) and
                                  not onmouse and enabled then
                                  begin
                                    onmouse:=true;
                                    updateobject;
                                    {ColorShift;}
                                  end;
                               c:=WinsDarkColor;
                               s:=2*ord(pressed)+ord(onmouse);
                               with w^.canvas do
                               case s of
                                 0 : begin
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$F0));
                                       frame(position.x,
                                             position.y,
                                             size.x,
                                             size.y);
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$80));
                                       frame(position.x+1,
                                             position.y+1,
                                             size.x-2,
                                             size.y-2);
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$F0));
                                       box  (position.x+2,
                                             position.y+2,
                                             size.x-4,
                                             size.y-4);
                                     end;
                                 1 : begin
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$40));
                                       frame(position.x+1,
                                             position.y+1,
                                             size.x-2,
                                             size.y-2);
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$D0));
                                       box  (position.x+2,
                                             position.y+2,
                                             size.x-4,
                                             size.y-4);
                                     end;
                                 2 : begin
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$80));
                                       frame(position.x+1,
                                             position.y+1,
                                             size.x-2,
                                             size.y-2);
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$E0));
                                       box  (position.x+2,
                                             position.y+2,
                                             size.x-4,
                                             size.y-4);
                                     end;
                                 3 : begin
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$00));
                                       frame(position.x+1,
                                             position.y+1,
                                             size.x-2,
                                             size.y-2);
                                       setcolor(mix(WinsDarkColor,
                                                    WinsBackColor,$C0));
                                       box  (position.x+2,
                                             position.y+2,
                                             size.x-4,
                                             size.y-4);
                                     end;
                               end;
                               with w^.canvas do
                               DrawMtextUsr( position.x+size.x div 2-
                                             GetMtextLength(text,norm,bold) div 2,
                                             position.y+size.y div 2,
                                             text,
                                             enabled,
                                             false,
                                             norm,
                                             c,
                                             bold,
                                             c);                               ColorNormal;
                             end;

                 WI_FlatButton :
                             begin
                               if onmouse and not enabled then
                                  begin
                                    onmouse:=false;
                                    updateobject;
                                  end;
                               if w^.status.active and
                                  inbox(position.x,position.y,
                                        size.x,size.y) and
                                  not onmouse and enabled then
                                  begin
                                    onmouse:=true;
                                    updateobject;
                                  end;
                               w^.canvas.setcolor(WinsBackColor);
                               if onmouse then
                                  if pressed
                                     then w^.canvas.dipt(position.x,position.y,size.x,size.y,$80)
                                     else w^.canvas.undipt(position.x,position.y,size.x,size.y,$F0)
                                  else
                                  if pressed
                                     then w^.canvas.undipt(position.x,position.y,size.x,size.y,$70)
                                     else w^.canvas.frame(position.x,position.y,size.x,size.y);
                               DrawMtextLeft( position.x+5,
                                              position.y+size.y div 2,
                                              text,enabled);
                             end;

                 WI_MenuButton :
                             begin
                               if onmouse and not enabled then
                                  begin
                                    onmouse:=false;
                                    updateobject;
                                  end;
                               if w^.status.active and
                                  inbox(position.x,position.y,
                                        size.x,size.y) and
                                  not onmouse and enabled then
                                  begin
                                    onmouse:=true;
                                    updateobject;
                                  end;
                               c:=WinsDarkColor;
                               with w^.canvas do
                               if onmouse then
                                  if pressed
                                     then
                                      begin
                                        {
                                          pressed
                                        }
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$C0));
                                        frame(position.x,position.y,
                                              size.x,size.y);
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$30));
                                        box(position.x+1,position.y+1,
                                            size.x-2,size.y-2);
                                        c:=$000000;
                                      end
                                     else
                                      begin
                                        {
                                          on mouse
                                        }
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$40));
                                        frame(position.x,position.y,
                                              size.x,size.y);
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$10));
                                        box(position.x+1,position.y+1,
                                            size.x-2,size.y-2);
                                      end
                                  else
                                  if pressed
                                     then
                                      begin
                                        {
                                          pressed, but not on mouse
                                        }
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$80));
                                        frame(position.x,position.y,
                                              size.x,size.y);
                                        setcolor(mix(winsbackcolor,
                                                     winsdarkcolor,$20));
                                        box(position.x+1,position.y+1,
                                            size.x-2,size.y-2);
                                      end
                                     else
                                      begin
                                        {
                                          normal state
                                        }
                                        if ID=WI_Button then
                                           begin
                                             undip(position.x,position.y,
                                                   size.x,size.y,$40);
                                           end else
                                           begin
                                             setcolor(mix(winsbackcolor,
                                                          winsdarkcolor,$0));
                                             box(position.x,position.y,
                                                 size.x,size.y);
                                           end;
                                      end;
                               with w^.canvas do
                                begin
                                  SetColor(winsbackcolor);
                                  PutPixel(position.x,position.y);
                                  PutPixel(position.x+size.x-1,position.y);
                                  PutPixel(position.x,position.y+size.y-1);
                                  PutPixel(position.x+size.x-1,position.y+size.y-1);
                                end;
                               if ID=WI_Button
                                  then DrawMTextCenter( position.x+
                                                        size.x div 2,
                                                        position.y+
                                                        size.y div 2,
                                                        text,
                                                        enabled)
                                  else DrawMtextUsr( position.x+5,
                                                     position.y+size.y div 2,
                                                     text,
                                                     enabled,
                                                     true,
                                                     norm,
                                                     c,
                                                     norm,
                                                     c);
                             end;

                 WI_LogicalButton : begin
                                      SendMessage(process.id,
                                                  process.id,
                                                  LB_Draw,
                                                  sizeof(CurrentObjectIndex),
                                                  addr(CurrentObjectIndex));
                                    end;

                 WI_CheckBox : with w^.canvas do
                             begin

                               dipt(position.x+0,position.y+0,
                                    size.x    -0,size.y    -0, $40);
                               dipt(position.x+1,position.y+1,
                                    size.x    -2,size.y    -2, $80);

                               if enabled
                                  then setcolor($FFFFFF)
                                  else setcolor(WinsBackColor);

                               box (position.x+3,position.y+3,
                                    size.x    -6,size.y    -6);

                               if checked then
                                  begin
                                    if enabled
                                       then c:=$000000
                                       else c:=WinsDarkColor;
                                    PlaceStamp(position.x+(size.x-7) div 2,
                                               position.y+(size.y-7) div 2,
                                               c,API_GetAppDir('WinsAPP')+'check.bmp');
                                  end;

                               setfont(norm,$000000);
                               DrawMtextCenter(position.x+size.x+4+
                                               GetMtextLength(text,norm,bold) div 2,
                                               position.y+(size.y div 2)-1,
                                               text,enabled);


                             end;

                 WI_LineIn : with TLineInObj(objptr^) do
                             begin
                               w^.canvas.dipt(position.x,
                                              position.y,
                                              size.x,
                                              size.y,
                                              $FF);
                               w^.canvas.dipt(position.x+1,
                                              position.y+1,
                                              size.x-2,
                                              size.y-2,
                                              $80);
                               with w^.canvas do
                               if enabled
                                  then if onmouse
                                       then setcolor(mix($FFFFFF,
                                                         WinsColorShift,
                                                         WinsColorShiftRatio))
                                       else setcolor($FFFFFF)
                                  else setcolor(mix($FFFFFF,
                                                    winsbackcolor,
                                                    $C0));

                               w^.canvas.box(position.x+2,
                                             position.y+2,
                                             size.x-4,
                                             size.y-4);
                               if enabled
                                  then setfont(norm,$000000)
                                  else setfont(norm,mix($000000,WinsBackColor,$C0));
                               if not enabled and noEdit then setfont(norm,$000000);
                               oldtext:=makepasswordstring
                                        (copy(newtext,startpos,255),ispasw);
                               w^.canvas.drawstringlen(position.x+4,
                                                       position.y+size.y div 2-7,
                                                       size.x-8,
                                                       oldtext);
                               if AmIlocked then
                                  begin
                                    w^.canvas.setcolor(WinsColorShift);
                                    l:=lenstring(copy(oldtext,1,curpos));
                                    if curpos=0 then l:=-1;
                                    l:=minim(l,size.x-4);
                                    w^.canvas.line(position.x+4+l,
                                                   position.y+3,
                                                   position.x+4+l,
                                                   position.y+size.y-5);
                                  end;
                             end;
               end;
             end;

   procedure LoadObject(i:integer);
             begin
               xms.Read(w^.objects,ObjSizeMax*i,ObjSizeMax,objptr);
               CurrentObjectIndex:=i;
             end;

   procedure SaveObject(i:integer);
             begin
               xms.Write(w^.objects,ObjSizeMax*i,ObjSizeMax,objptr);
               CurrentObjectIndex:=i;
             end;

   procedure UpdateObject;
             begin
               SaveObject(CurrentObjectIndex);
             end;

   Function  InBox(x,y,a,b:integer):boolean;
             begin
               with w^ do
                inbox:=(x<=VMouse.Pos.x) and
                       (VMouse.Pos.x<(x+a)) and
                       (y<=VMouse.Pos.y) and
                       (VMouse.Pos.y<(y+b));
             end;

   procedure ObjectOnMouse;
             begin
               with TStdObj(objptr^) do
               case ID of
                 WI_MenuButton,
                 WI_FlatButton,
                 WI_Button : begin
                               DrawObjectInitial;
                             end;
                 WI_LineIn : begin
                               DrawObjectInitial;
                             end;
                 WI_LogicalButton : begin
                                      SendMessage(process.id,
                                                  process.id,
                                                  LB_OnMouse,
                                                  sizeof(CurrentObjectIndex),
                                                  addr(CurrentObjectIndex));
                                    end;
               end;
             end;

   procedure ObjectEvent;
             begin
               SendMessage(process.id,process.id,
                           WI_Object+CurrentObjectIndex,0,nil);
             end;

   procedure LineInSetCursor(xin,sx:integer;s:string;var p:byte);
             var c : integer;
                 d : array[0..255] of byte;
                 m : byte;
             begin
               dec(xin,4); { now xin point to text }
               fonts.used:=norm;
               if lenstring(s)<xin then
                  begin
                    p:=length(s);
                    exit;
                  end;
               p:=0;
               for c:=0 to length(s) do
                   d[c]:=minim(abs(lenstring(copy(s,1,c))-xin),255);
               m:=255;
               for c:=0 to length(s) do
                   if d[c]<m then
                   begin
                     m:=d[c];
                     p:=c;
                   end;
             end;

   procedure ObjectPressed;
             begin
               with TStdObj(objptr^) do
               case ID of
                 WI_FlatButton,
                 WI_MenuButton,
                 WI_Button : begin
                               DrawObjectInitial;
                             end;
                 WI_CheckBox: begin
                                pressed:=false;
                                checked:=not checked;
                                DrawObjectInitial;
                                ObjectEvent;
                              end;
                 WI_LineIn : begin
                               { LOCK IT or TRANSFER LOCK }
                               w^.objectlock:=CurrentObjectIndex;
                               { Try Find Cursor... }
                               LineInSetCursor(w^.vmouse.pos.x-position.x,
                                               size.x,
                                               TLineInObj(objptr^).oldtext,
                                               TLineInObj(objptr^).curpos);
                               UpdateObject;
                             end;
                 WI_LogicalButton : begin
                                      SendMessage(process.id,
                                                  process.id,
                                                  LB_Pressed,
                                                  sizeof(CurrentObjectIndex),
                                                  addr(CurrentObjectIndex));
                                    end;
               end;
             end;

   procedure ObjectOffMouse;
             begin
               with TStdObj(objptr^) do
               case ID of
                 WI_FlatButton,
                 WI_MenuButton,
                 WI_Button : begin
                               DrawObjectInitial;
                             end;
                 WI_LineIn : begin
                               DrawObjectInitial;
                             end;
                 WI_LogicalButton : begin
                                      SendMessage(process.id,
                                                  process.id,
                                                  LB_OffMouse,
                                                  sizeof(CurrentObjectIndex),
                                                  addr(CurrentObjectIndex));
                                    end;
               end;
             end;

   function  LineInKeypress(code:word):boolean;
             var oldcur : byte;
             procedure refresh;
                       var s:string;
                           l:integer;
                       begin
                         with TStdObj(objptr^) do
                         with TLineInObj(objptr^) do
                          begin
                            lineinkeypress:=true;
                            s:=makepasswordstring(copy(newtext,startpos,255),ispasw);
                            if s=oldtext then exit;
                            with w^.canvas do
                                 if onmouse
                                    then setcolor(mix($FFFFFF,
                                                      WinsColorShift,
                                                      WinsColorShiftRatio))
                                    else setcolor($FFFFFF);
                            w^.canvas.box(position.x+2,
                                          position.y+2,
                                          size.x-4,
                                          size.y-4);
                            setfont(norm,$000000);
                            w^.canvas.drawstringlen(position.x+4,
                                                    position.y+size.y div 2-7,
                                                    size.x-8,
                                                    s);
                            l:=lenstring(copy(s,1,curpos));
                            if curpos=0 then l:=-1;
                            l:=minim(l,size.x-8);
                            w^.canvas.setcolor(WinsColorShift);
                            w^.canvas.line(position.x+4+l,position.y+3,
                                           position.x+4+l,position.y+size.y-5);
                            oldtext:=s;
                            updateobject;
                          end;
                       end;

             procedure refreshCursor;
                       var s:string;
                           l:integer;
                       begin
                         with TStdObj(objptr^) do
                         with TLineInObj(objptr^) do
                          begin
                            lineinkeypress:=true;
                            s:=makepasswordstring(copy(newtext,startpos,255),ispasw);
                            fonts.used:=norm;
                            with w^.canvas do
                                 if onmouse
                                    then setcolor(mix($FFFFFF,
                                                      WinsColorShift,
                                                      WinsColorShiftRatio))
                                    else setcolor($FFFFFF);
                            l:=lenstring(copy(s,1,oldcur));
                            if oldcur=0 then l:=-1;
                            l:=minim(l,size.x-8);
                            w^.canvas.line(position.x+4+l,position.y+3,
                                           position.x+4+l,position.y+size.y-5);
                            if not amilocked then exit;
                            setfont(norm,$000000);
                            w^.canvas.setcolor(WinsColorShift);
                            l:=lenstring(copy(s,1,curpos));
                            if curpos=0 then l:=-1;
                            l:=minim(l,size.x-8);
                            w^.canvas.line(position.x+4+l,position.y+3,
                                           position.x+4+l,position.y+size.y-5);
                            oldcur:=curpos;
                            updateobject;
                          end;
                       end;

             var p : pointer;
                 c : char;
                 k : word;
                 tabok : boolean;
             begin
               c:=chr(code and $FF);
               k:=WI_KeyCode+code;
               lineinkeypress:=false;
               with TLineInObj(objptr^) do
                begin

                  OldCur:=Curpos;

                  { string = len ch1 ch2 ch3 ch4 ch5  }
                  { curpos =    0   1   2   3   4     }

                  if w^.objectlock>=0 then         { if something is locked }
                     if not (AmILocked) then exit; { and it is not me = end }

                  if w^.objectlock<0 then          { if is nothing locked   }
                     if std.onmouse then           { and mouse is here then }
                        w^.objectlock:=CurrentObjectIndex; { lock this obj  }

                  if not AmIlocked then exit;      { if still not locked .. }

                  if (k=WI_KB_End) { End } then
                     begin
                       curpos:=length(newtext);
                       RefreshCursor;
                     end;

                  if (k=WI_KB_Home) { Home } then
                     begin
                       curpos:=0;
                       RefreshCursor;
                     end;

                  if (k=WI_KB_Left) { Left } then
                     if curpos>0 then
                     begin
                       dec(curpos);
                       RefreshCursor;
                     end;

                  if (k=WI_KB_Right) { Right } then
                     if curpos<length(newtext) then
                     begin
                       inc(curpos);
                       RefreshCursor;
                     end;

                  if (k=WI_KB_Del) { Del } then
                     begin
                       if curpos=length(newtext) then exit;
                       newtext:=copy(newtext,1,curpos)+copy(newtext,curpos+2,255);
                       refresh;
                     end;

                  if (k=WI_KB_BS) {backspace} then
                     begin
                       if length(newtext)<1 then exit;
                          { nothing to delete }
                       if curpos=0 then exit;
                          { we are on start of text }
                       dec(curpos);
                       newtext:=copy(newtext,1,curpos)+copy(newtext,curpos+2,255);
                       refresh;
                     end;

                  if (k=WI_KB_Enter) {enter} or
                     (k=WI_KB_ESC)   { esc } then { unlock objects }
                     begin
                       w^.objectlock:=-1;
                       DrawObjectInitial;
                       exit;
                     end;

                  if (k=WI_KB_Tab) {tab} then
                     begin
                       tabok:=false;
                       inc(w^.objectlock);
                       if w^.objectscount>w^.objectlock then
                          {exist the next object}
                          begin
                            p:=objptr;
                            objptr:=nil;
                            getmem(objptr,objsizemax);
                            loadobject(w^.objectlock);
                            if (TstdObj(objptr^).id<>WI_LineIn) or
                               (TstdObj(objptr^).enabled<>true)
                               {if it is not linein or it is not enabled }
                               then dec(w^.objectlock) else
                               begin
                                 {
                                 dec(w^.objectlock);
                                 dec(currentobjectindex);
                                 }
                                 tabok:=true;
                                 refreshcursor;
                                 {
                                 inc(currentobjectindex);
                                 inc(w^.objectlock);
                                 }
                               end;
                            freemem(objptr,objsizemax);
                            objptr:=p;
                            dec(currentobjectindex);
                          end;
                       if tabok then
                          begin
                            loadobject(w^.objectlock-1);
                            drawobjectinitial;
                            loadobject(w^.objectlock);
                          end;
                     end;

                  if (code>=20) and
                     (code<=255) {space and upper character } then
                     begin
                       if curpos=0
                          then newtext:=c+newtext
                          else insert(c,newtext,curpos+1);
                       inc(curpos);
                       refresh;
                     end;
                end;
             end;

   function  ObjectKeyPress(c:word):boolean;
             var r:boolean;
             begin
               ObjectKeyPress:=false;
               with TStdObj(objptr^) do
               case ID of

                 WI_CheckBox,
                 WI_LogicalButton,
                 WI_FlatButton,
                 WI_Button : if c<$100 then
                             begin
                               r:= (w^.objectlock<0) and
                                   (Upcase(MtextShortcut(text))=
                                    Upcase(chr(c and $FF)));
                               if (ID=WI_CheckBox) and r then
                                  begin
                                    checked:=not checked;
                                    UpdateObject;
                                    DrawObjectInitial;
                                  end;
                               ObjectKeyPress:=r;
                             end;
                 WI_LineIn : objectKeyPress:=LineInKeypress(c);
               end;
             end;

   procedure CheckObjects(m:word);
             var i:integer;
             procedure event;
                       begin
                         SendMessage(process.id,process.id,
                                     WI_Object+i,0,nil);
                       end;
             begin
               if (m=WI_OverWindow) and
                  (not w^.status.active) then exit;
               if w^.objectscount<1 then exit;
               if m=WI_OnPress then
                  begin
                    { if there was a click to window,
                      unlock all object ...}
                    if w^.objectlock>=0 then
                       begin
                         LoadObject(w^.objectlock);
                         w^.objectlock:=-1;
                         DrawObjectInitial;
                         ActualizeCanvas;
                         PrepareCanvas;
                       end;
                    w^.objectlock:=-1;
                  end;
               for i:=0 to w^.objectscount-1 do
                   begin
                     loadobject(i);
                     if not TStdObj(objptr^).enabled then continue;
                     w^.canvas.prepare;

                     with TStdObj(objptr^) do
                      if m=WI_Char then
                         if ObjectKeyPress(
                            TWI_Char(message.data^).code) then Event;

                     with TStdObj(objptr^) do
                      if (m=WI_OverWindow) or (m=WI_OffWindow) then
                      if inbox(position.x,position.y,size.x,size.y) and
                         (m=WI_OverWindow) then
                         begin
                           if not onmouse then
                              begin
                                onmouse:=true;
                                if pressed
                                   then ObjectPressed
                                   else ObjectOnMouse;
                                SaveObject(i);
                              end;
                         end else
                         begin
                           if onmouse then
                              begin
                                onmouse:=false;
                                ObjectOffMouse;
                                SaveObject(i);
                              end;
                         end;

                     with TStdObj(objptr^) do
                      if onmouse and
                         (m=WI_OffWindow)
                         then
                          begin
                            onmouse:=false;
                            ObjectOffMouse;
                            SaveObject(i);
                          end;

                     with TStdObj(objptr^) do
                      if onmouse and
                         (m=WI_OnPress)
                         then
                          begin
                            Pressed:=true;
                            ObjectPressed;
                            SaveObject(i);
                          end;

                     with TStdObj(objptr^) do
                      if (m=WI_OnRelease)
                         then
                          begin
                            if pressed then
                               begin
                                 Pressed:=false;
                                 if onmouse then Event;
                                 SaveObject(i);
                                 if onmouse
                                    then ObjectOnMouse
                                    else ObjectOffMouse;
                               end;
                          end;

                     with w^ do
                     with canvas do
                     if needredraw then
                        WinsRender(position.x+umin.x,
                                   position.y+umin.y,
                                   position.x+umax.x,
                                   position.y+umax.y);
                   end;
               with w^.vmouse do
                begin
                  orb:=rb;
                  olb:=lb;
                end;
             end;

   function  WinsObject(objcode:word;x,y,a,b:integer;s:string):word;
             begin
               winsobject:=w^.objectscount;
               if  w^.objectscount=
                  ((w^.objects^.size*1024) div ObjSizeMax) then exit;
               with TStdObj(objptr^) do
                begin
                  id:=objcode;
                  position.x:=x;
                  position.y:=y;
                  size.x:=a;
                  size.y:=b;
                  text:=s;
                  onmouse:=false;
                  pressed:=false;
                  checked:=false;
                  active:=w^.objectscount=0;
                  enabled:=true;
                end;
               if objcode=WI_LineIn then
                  with TLineInObj(objptr^) do
                       begin
                         startpos:= 0;
                         curpos  := 0;
                         oldtext := '';
                         newtext := s;
                         ispasw  := false;
                         noEdit  := false;
                       end;
               SaveObject(w^.objectscount);
               inc(w^.objectscount);
             end;

   procedure WinsDisable;
             begin
               TStdObj(objptr^).enabled:=false;
               UpdateObject;
             end;

   procedure WinsEnable;
             begin
               TStdObj(objptr^).enabled:=true;
               UpdateObject;
             end;

   procedure WinsChecked;
             begin
               TStdObj(objptr^).checked:=true;
               UpdateObject;
             end;

   procedure WinsNotChecked;
             begin
               TStdObj(objptr^).checked:=false;
               UpdateObject;
             end;

   procedure WinsNoEditable;
             begin
               TLineInObj(objptr^).noEdit:=true;
               UpdateObject;
             end;

   procedure DrawAllObjectsInitial;
             var i:integer;
             begin
               if w^.objectscount<1 then exit;
               for i:=1 to w^.objectscount do
                   begin
                     LoadObject(i-1);
                     DrawObjectInitial;
                   end;
             end;

   procedure CloseSubWindow;
             begin
               sendmessage(process.id,w^.parent,WI_SubClose,0,nil);
             end;

   procedure ReShowWindow;
             var DTA : TWI_Render;
                 i   : integer;
             begin
               DTA.Min  :=w^.Position;
               DTA.Max.x:=w^.Position.x+w^.Canvas.Width-1;
               DTA.Max.y:=w^.Position.y+w^.Canvas.Height-1;

               SendMessage(process.id,ToWins,WI_NewWindow,0,nil);

               SendMessage(process.id,ToWins,WI_Render,
                           SizeOf(TWI_Render),addr(DTA));

             end;

   procedure MoveToFront;
             var cwi : word;
                 ctw : word;
                 i   : integer;
             begin
               {
                 process.id  - current window
                 cwi         - index of current window
                 ctw         - current top window
               }
               cwi:=$FFFF;
               ctw:=0;
               with kerneldata do
                    for i:=0 to numofprocesses-1 do
                        begin
                          if processdata[i].id=process.id then cwi:=i;
                          if ((processdata[i].flags and PROC_VISUAL)>0) and
                             (not Pwindow(processdata[i].DS_ptr)^.status.ontop)
                             then ctw:=i;
                        end;
               {
                 current   cwi
                 top       ctw
               }
               if cwi=$FFFF then exit;
               if ctw=0 then exit;
               if cwi>=ctw then exit;

               {
                 move the current to top and move other by 1 to back
               }

               with kerneldata do
                begin
                  for i:=cwi to ctw-1 do processdata[i]:=processdata[i+1];
                  processdata[ctw]:=Process;
                  therewaschange:=true;
                end;

               reshowwindow;
             end;

   procedure MoveToTop;
             var cwi : word;
                 ctw : word;
                 i   : integer;
             begin
               {
                 process.id  - current window (process)
                 cwi         - current window index
                 ctw         - current toppest window
               }
               cwi:=$FFFF;
               ctw:=0;
               with kerneldata do
                    for i:=0 to numofprocesses-1 do
                        begin
                          if processdata[i].id=process.id then cwi:=i;
                          if ((processdata[i].flags and PROC_VISUAL)>0)
                             then ctw:=i;
                        end;
               {
                 current   cwi
                 top       ctw
               }
               if cwi=$FFFF then exit;
               if ctw=0 then exit;
               if cwi>=ctw then exit;

               with kerneldata do
                begin
                  for i:=cwi to ctw-1 do processdata[i]:=processdata[i+1];
                  processdata[ctw]:=Process;
                  therewaschange:=true;
                end;

               reshowwindow;
             end;

   procedure Create(x,y,b:integer;o:word);
             var memneeded : longint;
             begin
               with Pwindow(process.ds_ptr)^ do
                begin
                  parent:=TPR_init(message.data^).parentID;
                  position.x:=10;
                  position.y:=10;
                  canvas.init;
                  canvas.alloc(x,y,b);
                  titlearea.override:=false;
                  titlearea.pos.x:=0;
                  titlearea.pos.y:=0;
                  titlearea.size.x:=x;
                  titlearea.size.y:=y;
                  titleoffsetL:=0;
                  titleoffsetR:=0;
                  titlebuttcount:=2;
                  titlebutt[0]:=TBUTT_Close;
                  titlebutt[1]:=TBUTT_Title;
                  hastitle:=true;
                  with status do
                   begin
                     intitle:=false;
                     indrag:=false;
                     active:=false;
                     hidden:=false;
                     ontop:=false;
                     locked:=false;
                   end;
                  vmouse.lb:=false;
                  vmouse.rb:=false;
                  objectscount:=0;
                  memneeded:=longint(o)*ObjSizeMax;
                  if (memneeded mod 1024)>0 then inc(memneeded,1024);
                  if o<>0 then objects:=xms.Alloc(memneeded div 1024);
                  titlemode.apply:=false;
                  ismouse:=false;
                  objectlock:=-1;
                end;

               {force mouse change}
               sendmessage(toWins,toConsole,CO_MS_ChangePos,0,nil);

               {
                 SET the VISUAL FLAG
               }
               process.flags:=process.flags or PROC_VISUAL;
               updateprocessdata:=true;

             end;

   procedure CenterWindow;
             begin
               with Pwindow(process.ds_ptr)^ do
                begin
                  position.x:=(guidesktop.size.x-canvas.width) div 2;
                  position.y:=(guidesktop.size.y-canvas.height) div 2;
                end;
             end;

   procedure RandomWindow;
             begin
               with Pwindow(process.ds_ptr)^ do
                begin
                  position.x:=random(guidesktop.size.x-canvas.width);
                  position.y:=random(guidesktop.size.y-canvas.height);
                end;
             end;

   procedure CloseWindow;
             begin
               process.flags:=(process.flags and (not (PROC_VISUAL or
                                                       { or delattrib }
                                                       PROC_CONSOLE)))
                              or { or setattrib }
                                 PROC_DEAD;
               updateprocessdata:=true;
               ReShowWindow;

               Pwindow(process.ds_ptr)^.canvas.done;

               {force mouse change}
               sendmessage(toWins,toConsole,CO_MS_ChangePos,0,nil);

               {jump(PR_Kill);}
             end;

   procedure PlaceBmp(fn:string);
             begin
               Pwindow(process.ds_ptr)^.canvas.placeBmp(0,0,fn);
             end;

   procedure PlaceAlp(fn:string);
             begin
               Pwindow(process.ds_ptr)^.canvas.placeAlpha(fn);
             end;

   procedure MoveWindowTo(nx,ny:integer);
             begin
               ReShowWindow;
               with Pwindow(process.ds_ptr)^ do
                begin
                  Position.x:=nx;
                  Position.y:=ny;
                end;
               ReShowWindow;
             end;

   procedure LoadPos;
             var posstr : string;
                 oldini : string;
                 b      : boolean;
             begin
               oldini:=inifile;
               inifile:=userpath+'window.ini';
               posstr:=readinistring(process.name,'position');
               if inierror=iniok then
                  begin
                    w^.position.x:=stringtointeger(copy(posstr,1,pos(',',posstr)-1));
                    w^.position.y:=stringtointeger(copy(posstr,pos(',',posstr)+1,255));

                    if (w^.position.x+w^.canvas.width) >= guidesktop.size.x
                       then w^.position.x:=guidesktop.size.x-w^.canvas.width;

                    if (w^.position.y+w^.canvas.height) >= guidesktop.size.y
                       then w^.position.y:=guidesktop.size.y-w^.canvas.height;

                    if w^.position.x<0 then w^.position.x:=0;
                    if w^.position.y<0 then w^.position.y:=0;

                    b:=readiniboolean(process.name,'locked');
                    if inierror=iniok then w^.status.locked:=b;
                  end;
               inifile:=oldini;
             end;

   procedure SavePos;
             var posstr : string;
                 oldpos : string;
                 oldini : string;
             begin
               oldini:=inifile;
               inifile:=userpath+'window.ini';
               oldpos:=readinistring(process.name,'position');
               with w^.position do
                    posstr:=integertostring(x)+','+integertostring(y);
               if inierror=iniok then
                  begin
                    if oldpos<>posstr then
                       changeini(process.name,'position',posstr);
                    if w^.status.locked
                       then posstr:='yes'
                       else posstr:='no';
                            changeini(process.name,'locked',posstr);
                  end else
                  begin
                    addinisection(process.name);
                    with w^.position do
                         posstr:=integertostring(x)+','+integertostring(y);
                    addiniitem(process.name,'position',posstr);
                    if w^.status.locked
                       then posstr:='yes'
                       else posstr:='no';
                    addiniitem(process.name,'locked',posstr);
                  end;
               inifile:=oldini;
             end;

   procedure PrepareCanvas;
             begin
               w^.canvas.prepare;
             end;

   procedure ActualizeCanvas;
             begin
               with w^ do
                with canvas do
                     if needredraw then
                        WinsRender(position.x+umin.x,
                                   position.y+umin.y,
                                   position.x+umax.x,
                                   position.y+umax.y);
             end;

   procedure PlaceSign(fn:string;x,y:integer;c:char);
             var pos  : TPoint;
                 size : TPoint;
                 Abmp : BmpFile;
                 Ibmp : BmpFile;
                 Abuf : PBuff;
                 Ibuf : PRGBColorArr;
                 Qbuf : PRGBColorArr;
                 i    : TPoint;
             begin
               {
                 calc size ( last two characters
                             in filename xxx16,
                             yy24, zzzz32, ...    )
               }
               size.x:=StringToInteger(copy(fn,length(fn)-1,2));
               if size.x<1 then exit;
               size.y:=size.x;
               {
                 calc position ( we know, that the images
                                 are stored in BMP file in
                                 matrix of 16x16 - index is
                                 0..255 )
               }
               pos.x:=(ord(c) mod 16)*size.x;
               pos.y:=(ord(c) div 16)*size.y;
               {
                 add path as 'appdata\winsapp\'+fn+'i.bmp' and +'a.bmp'
               }
               fn:=API_GetAppDir('WinsAPP')+fn;
               {
                 initialize the bmp component
               }
               Abmp.init;
               Ibmp.init;
               {
                 open the Bmp files
               }
               with Abmp do
                begin
                  openfile(fn+'a.bmp');
                  if not opened then
                     begin
                       Abmp.done;
                       Ibmp.done;
                       exit;
                     end;
                end;
               with Ibmp do
                begin
                  openfile(fn+'i.bmp');
                  if not opened then
                     begin
                       Abmp.done;
                       Ibmp.done;
                       exit;
                     end;
                end;
               {
                 check the memory and allocate it
               }
               if MaxAvail > (size.x*sizeof(Qbuf^[0])) then
               begin
                 GetMem(Qbuf,size.x*sizeof(Qbuf^[0]));
                 if MaxAvail > (size.x*sizeof(Ibuf^[0])) then
                 begin
                   GetMem(Ibuf,size.x*sizeof(Ibuf^[0]));
                   if MaxAvail > (size.x*sizeof(Abuf^[0])) then
                   begin
                     GetMem(Abuf,size.x*sizeof(Abuf^[0]));
                     {
                       read lines 1 to height of image
                     }
                     for i.y:=0 to size.y-1 do
                         begin
                           Abmp.ReadLineXL  (pos.x,pos.y+i.y,size.x,
                                             pointer(Abuf));
                           Ibmp.ReadLine24xl(pos.x,pos.y+i.y,size.x,
                                             pointer(Ibuf));
                           w^.Canvas.GetLine(x,y+i.y,size.x,Qbuf);
                           {
                             apply the alpha channel
                           }
                           for i.x:=0 to size.x-1 do
                               begin
                                 Qbuf^[i.x].r:=Qbuf^[i.x].r+
                                               (longint(Ibuf^[i.x].r)-
                                                Qbuf^[i.x].r)*Abuf^[i.x]
                                                 div 255;
                                 Qbuf^[i.x].g:=Qbuf^[i.x].g+
                                               (longint(Ibuf^[i.x].g)-
                                                Qbuf^[i.x].g)*Abuf^[i.x]
                                                 div 255;
                                 Qbuf^[i.x].b:=Qbuf^[i.x].b+
                                               (longint(Ibuf^[i.x].b)-
                                                Qbuf^[i.x].b)*Abuf^[i.x]
                                                 div 255;
                               end;
                           w^.Canvas.PutLine(x,y+i.y,size.x,Qbuf);
                         end;
                     FreeMem(Abuf,size.x*sizeof(Abuf^[0]));
                   end;
                   FreeMem(Ibuf,size.x*sizeof(Ibuf^[0]));
                 end;
                 FreeMem(Qbuf,size.x*sizeof(Qbuf^[0]));
               end;
               {
                 the end... close the bmp files
               }
               Abmp.done;
               Ibmp.done;
             end;

   procedure TTestAppHandle;
             var m : TMessage;
                 d : ^TTestApp;
                 b,c      : byte;
                 hr,sr,lr : real;
                 s : string;
             begin
               m:=message;
               d:=process.DS_ptr;
               w:=process.DS_ptr;
               case m.mess of
                 PR_Init:
                   begin
                     With d^ do
                      begin
                        Create(640+13,304+70,24,8);
                        std.Title:='Multimedia control';
                        PaintWindow;
                        CenterWindow;

                        with std.canvas do
                         begin
                           setcolor($808080);
                           frame(5,25,width-9,height-66);
                           setcolor(0);
                           frame(4,24,width-9,height-66);
                           setcolor($FFFFFF);
                           frame(5,25,width-11,height-68);

                           placebmp(6,26,'testing\kim.bmp');

                           for i:=1 to 7 do
                           dipt(2,std.canvas.height-31+i*2,std.canvas.width-4,2,$40);
                         end;

                        af:=0;
                        st:=PS_Stop;

                        WinsObject(WI_Button, 10,w^.canvas.height-35,34,25,#22);
                        WinsObject(WI_Button, 50,w^.canvas.height-35,54,25,#16);
                        WinsObject(WI_Button,105,w^.canvas.height-35,34,25,#23);
                        WinsObject(WI_Button,140,w^.canvas.height-35,34,25,#21);
                        WinsObject(WI_Button,180,w^.canvas.height-35,34,25,#31);
                        WinsObject(WI_Button,215,w^.canvas.height-35,34,25,#29);
                        WinsObject(WI_Button,250,w^.canvas.height-35,34,25,#28);
                        WinsObject(WI_Button,285,w^.canvas.height-35,34,25,#30);

                        DrawAllObjectsInitial;
                      end;
                      ReShowWindow;
                      jump(up_Message);
                   end;

                 WI_Char,
                 WI_OnPress,
                 WI_OnRelease,
                 WI_OverWindow,
                 WI_OffWindow:
                   begin
                     CheckObjects(m.mess);
                     if not d^.std.status.indrag then
                     begin
                     preparecanvas;
                     d^.std.canvas.placebmp(65,55,API_GetAppDir('test')+
                         '6555f'+integertostring(ord(inbox(10,166,80,70)))+'.bmp');
                     actualizecanvas;
                     preparecanvas;
                     d^.std.canvas.placebmp(95,55,API_GetAppDir('test')+
                         '9555f'+integertostring(ord(inbox(70,174,70,60)))+'.bmp');
                     actualizecanvas;
                     if m.mess=WI_onPress then
                        begin
                          preparecanvas;
                          d^.std.canvas.placebmp(70,80,API_GetAppDir('test')+'7080f1.bmp');
                          actualizecanvas;
                        end;
                     if m.mess=WI_onRelease then
                        begin
                          preparecanvas;
                          d^.std.canvas.placebmp(70,80,API_GetAppDir('test')+'7080f0.bmp');
                          actualizecanvas;
                        end;
                     end;
                   end;

                 WI_KB_Esc,     { on ESC pressed        }
                 WI_Object,     { on ,,close'' button   }
                 WI_TB_Close,   { on title button close }
                 WI_CloseApp:
                   begin
                     CloseWindow;
                     {
                     SendMessage(process.id,ToGui,UP_Message+101,0,nil);
                     }
                   end;
                 {
                 WI_Object+1:
                   begin
                     if d^.st=PS_Stop then
                        begin
                          d^.af:=-1;
                          d^.st:=PS_Play;
                          jump(WI_Object+6);
                        end;
                   end;

                 WI_Object+5:
                   begin
                     if d^.af>0 then
                        begin
                          dec(d^.af);
                          jump(UP_Message);
                        end;
                   end;

                 WI_Object+6:
                   begin
                     if d^.af<9 then
                        begin
                          inc(d^.af);
                          jump(UP_Message);
                        end else
                        begin
                          if d^.st=PS_Play then d^.st:=PS_Stop;
                        end;
                   end;

                 UP_Message:
                   begin
                     preparecanvas;
                     with d^ do
                      begin
                        s:=integertostring(af);
                        while length(s)<4 do s:='0'+s;
                        s:=pt+s+'.bmp';
                        d^.std.canvas.placebmp(6,26,s);
                      end;
                     actualizecanvas;
                     if d^.st=PS_Play then
                        begin
                          jump(WI_Object+6);
                          ProcessMessages;
                        end;
                   end;
                 }
                 WI_Activate:
                   begin
                     MoveToFront;
                   end;

                 WI_TB_Title:
                   if w^.titlemode.apply then
                      begin
                        w^.canvas.height:=w^.titlemode.oldsize;
                        w^.titlebutt[1].icon:=TB_TitleIcon;
                        ReShowWindow;
                        w^.titlemode.apply:=false;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end else
                      begin
                        w^.titlemode.oldsize:=w^.canvas.height;
                        ReShowWindow;
                        w^.canvas.height:=22;
                        w^.titlebutt[1].icon:=TB_DeTitIcon;
                        w^.titlemode.apply:=true;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end;

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     d^.std.canvas.done;
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;
               end;
             end;

   procedure WINS_Menu(x,y:integer;s:string);
             begin
               {
                 format:    134,200:mainmenu\programs
               }
               RunWinsApp('submenu',Integertostring(x)+','+
                                    Integertostring(y)+':'+s);
             end;

   procedure TGuiShellAppHandle;
             var m : TMessage;
                 d : ^TGuiShellApp;
                 b : integer;

                 procedure checkother(a:word);
                           begin
                             with d^ do
                             with timearea do
                                  if (a=WI_OnPress) and
                                     inbox(pos.x,pos.y,
                                           size.x,size.y) and
                                     (not cpick) then
                                     begin
                                       cpick:=true;
                                       RunWinsApp('commdlg:colorpick',
                                                  colortostr(timecolor));
                                     end;
                           end;

                 procedure RefreshClock;
                           var n : TDateTime;
                           Function FormTime(t:TDateTime):string;
                                    begin
                                      FormTime:=chr(t.hrs div 10)+
                                                chr(t.hrs mod 10)+':'+
                                                chr(t.min div 10)+
                                                chr(t.min mod 10)+':'+
                                                chr(t.sec div 10)+
                                                chr(t.sec mod 10);
                                    end;
                           begin
                             API_GetSystemTime(n);
                             if n.sec<>d^.timeshow.sec then
                                begin
                                  preparecanvas;
                                  if d^.timeshow.sec=60 then
                                     begin
                                       with d^.timearea do
                                            d^.std.canvas.dipt(
                                                pos.x,pos.y,
                                                size.x,size.y,$80);
                                       d^.std.canvas.setcolor(mix(
                                            WinsBackColor,d^.TimeColor,$20));
                                       with d^.timearea do
                                            d^.std.canvas.box(
                                                pos.x+1,pos.y+1,
                                                size.x-2,size.y-2);
                                     end;
                                  {clear}
                                  setfont(norm,mix(WinsBackColor,
                                                   d^.TimeColor,$40));
                                  d^.std.canvas.drawstringcenter(
                                      d^.timearea.pos.x+d^.timearea.size.x div 2-1,
                                      d^.timearea.pos.y+d^.timearea.size.y div 2-7,
                                      #8+#8+':'+#8+#8+':'+#8+#8);
                                  d^.timeshow:=n;
                                  {show}
                                  setfont(norm,mix(0,d^.TimeColor,$40));
                                  d^.std.canvas.drawstringcenter(
                                      d^.timearea.pos.x+d^.timearea.size.x div 2-1,
                                      d^.timearea.pos.y+d^.timearea.size.y div 2-7,
                                      FormTime(d^.timeshow));
                                  actualizecanvas;
                                end;
                           end;

             Function  GetIniColor(s:string):TColor;
                       var oldini:string;
                       begin
                         oldini:=inifile;
                         inifile:=API_GetFile('applsets');
                         GetIniColor:=ReadIniColor('guishell\clock',
                                                   'color');
                         inifile:=oldini;
                       end;

             Procedure SaveConfig;
                       var oldini:string;
                       begin
                         oldini:=inifile;
                         inifile:=API_GetFile('applsets');
                         changeini('guishell\clock',
                                   'color',
                                   ColorToStr(d^.timecolor));
                         inifile:=oldini;
                       end;

             procedure AcceptLineIn(s:string);
                       begin
                         if s='commdlg.colorpick.ready' then
                            with d^ do
                            begin
                              oldcolor:=timecolor;
                            end;

                         if copy(s,1,26)=
                            'commdlg.colorpick.color = ' then
                            with d^ do
                            begin
                              timeshow.sec:=60;
                              timecolor:=StrToColor(copy(s,27,7));
                            end;

                         if s='commdlg.colorpick.cancel' then
                            with d^ do
                            if timecolor<>oldcolor then
                            begin
                              timecolor:=oldcolor;
                              timeshow.sec:=60;
                            end;

                         if s='commdlg.colorpick.close' then
                            with d^ do
                            begin
                              cpick:=false;
                            end;

                       end;

             begin
               m:=message;
               d:=process.DS_ptr;
               w:=process.DS_ptr;
               case m.mess of
                 PR_Init:
                   begin
                     { wins after mainpanel start }
                     {

                     RunWinsApp('commdlg:colorpick','');

                     }
                     With d^ do
                      begin
                        Create(guidesktop.size.x,21,24,4);

                        std.Title:='GuiShell';
                        std.hastitle:=false;

                        {std.titlearea.override:=true;}
                        std.titlearea.size.x:=8;
                        std.titlebuttcount:=0;

                        timearea.pos.x:=guidesktop.size.x-72;
                        timearea.pos.y:=1;
                        timearea.size.x:=50;
                        timearea.size.y:=18;

                        cpick:=false;
                        TimeColor:=GetIniColor('timecolor');

                        API_GetSystemTime(timeshow);
                        timeshow.sec:=60;

                        {PaintWindow;}
                        {CenterWindow;}
                        {LoadPos;}

                        {if (std.position.y<0) then
                           begin
                             std.canvas.done;
                             std.canvas.alloc(guidesktop.size.x+2,22,24);}
                             std.position.x:=0;
                             std.position.y:=0;
                         {  end;}

                        with std.canvas do
                         begin
                           {
                           undip(0,0,width,height,255);
                           undipt(3,2,3,height-5,$80);
                           }
                           fill(winsbackcolor);
                           undipt(2,1,3,height-4,$80);
                           setcolor(winsdarkcolor);
                           line(0,height-1,width-1,height-1);
                           WinsObject(WI_FlatButton,width-21,1,19,18,'');
                           setfont(norm,0);
                           drawstring(width-16,6,TB_CloseIcon);
                           b:=7;
                           WinsObject(WI_FlatButton, b,1,
                                      5,18,Tr('&File'));
                           inc(TSTDobj(objptr^).size.x,lenstring(TSTDobj(objptr^).text));
                           UpdateObject;
                           inc(b,TSTDobj(objptr^).size.x);
                           WinsObject(WI_FlatButton, b,1,
                                      5,18,Tr('&Programs'));
                           inc(TSTDobj(objptr^).size.x,lenstring(TSTDobj(objptr^).text));
                           UpdateObject;
                           inc(b,TSTDobj(objptr^).size.x);
                           WinsObject(WI_FlatButton, b,1,
                                      5,18,Tr('&Settings'));
                           inc(TSTDobj(objptr^).size.x,lenstring(TSTDobj(objptr^).text));
                           UpdateObject;
                         end;

                        DrawAllObjectsInitial;
                      end;
                      ReShowWindow;

                      Process.Flags:=Process.Flags or PROC_Multitask;
                      UpdateProcessData:=true;
                   end;

                 KE_Nothing:
                   with d^ do
                   begin
                     RefreshClock;
                   end;

                 KE_LineIn:
                   with d^ do
                   if TKE_LineIn(m.data^).numlines=1 then
                   begin
                     AcceptLineIn(TKE_LineIn(m.data^).lines[0]);
                   end;

                 WI_PrepareToChangeRes:
                   begin
                     Jump(PR_Kill);
                     RunWinsApp(Process.Name,'');
                   end;

                 WI_Char,
                 WI_OnPress,
                 WI_OnRelease,
                 WI_OverWindow,
                 WI_OffWindow:
                   begin
                     CheckObjects(m.mess);
                     CheckOther(m.mess);
                   end;

                 WI_KB_Esc,     { on ESC pressed        }
                 WI_Object,     { on ,,close'' button   }
                 WI_TB_Close,   { on title button close }
                 WI_CloseApp:
                   begin
                     SavePos;
                     SaveConfig;
                     CloseWindow;
                     CloseGui;
                   end;

                 WI_Object+1:   { file }
                   begin
                     loadobject(1);
                     WINS_Menu(w^.position.x+TSTDobj(objptr^).position.x+4,
                               w^.position.y+18,'mainmenu\file');
                   end;

                 WI_Object+2:   { programs }
                   begin
                     loadobject(2);
                     WINS_Menu(w^.position.x+TSTDobj(objptr^).position.x+4,
                               w^.position.y+18,'mainmenu\programs');
                   end;

                 WI_Object+3:   { settings }
                   begin
                     loadobject(3);
                     WINS_Menu(w^.position.x+TSTDobj(objptr^).position.x+4,
                               w^.position.y+18,'mainmenu\settings');
                   end;

                 WI_Activate:
                   begin
                     MoveToFront;
                   end;

                 {WI_TitleClick:
                   if w^.titlemode.apply then
                      begin
                        w^.canvas.width:=w^.titlemode.oldsize;
                        with w^.canvas do
                             begin
                               undipt(0,0,width,height,255);
                               setcolor(winsbackcolor);
                               line(9,1,9,height-2);
                             end;
                        ReShowWindow;
                        w^.titlemode.apply:=false;
                      end;

                 WI_KB_TAB:
                   if not w^.titlemode.apply then
                      begin
                        w^.titlemode.oldsize:=w^.canvas.width;
                        with w^.canvas do undipt(0,0,10,height,255);
                        ReShowWindow;
                        w^.canvas.width:=10;
                        w^.titlemode.apply:=true;
                      end;
                 }

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     d^.std.canvas.done;
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;
               end;
             end;

   procedure WinsLineInPassword;
             begin
               TLineInObj(objptr^).ispasw:=true;
             end;

   function  IsChecked(i:integer):boolean;
             begin
               LoadObject(i);
               IsChecked:=TStdObj(objptr^).checked;
             end;

   function  LineInGetText(i:integer):string;
             begin
               LoadObject(i);
               LineinGetText:=TLineInObj(objptr^).newtext;
             end;

   procedure LineInSetText(i:integer;s:string);
             begin
               LoadObject(i);
               if TLineInObj(objptr^).newtext=s then exit;
               TLineInObj(objptr^).newtext:=s;
               UpdateObject;
               DrawObjectInitial;
             end;

   procedure ButtonSetEnable(i:integer;en:boolean);
             begin
               LoadObject(i);
               if TStdObj(objptr^).enabled=en then exit;
               Tstdobj(objptr^).enabled:=en;
               UpdateObject;
               DrawObjectInitial;
             end;

   procedure ChangeWindowTitle(s:string);
             begin
               w^.title:=s;
               preparecanvas;
               drawwindowtitle;
               actualizecanvas;
             end;

   procedure WinsMainMenu(s:string);
             var items : array[0..31] of ^String;
                 ct    : integer;
                 i     : integer;
                 x     : integer;
             begin
               ct:=0;
               {
                 add items - separated with | character
               }
               while pos('|',s)>0 do
                     begin
                       new(items[ct]);
                       items[ct]^:=copy(s,1,pos('|',s)-1);
                       s:=copy(s,pos('|',s)+1,255);
                       inc(ct);
                     end;
               {
                 add single or last menu item
               }
               if s<>'' then
                  begin
                    new(items[ct]);
                    items[ct]^:=s;
                    inc(ct);
                  end;
               {
                 insert menu
               }
               if ct>0 then
                  begin
                    x:=5;
                    for i:=0 to ct-1 do
                        begin
                          setfont(norm,0);
                          WinsObject(WI_MenuButton,x,25,8,18,items[i]^);
                          inc(TSTDobj(objptr^).size.x,
                              GetMTextLength(TSTDobj(objptr^).text,norm,norm));
                          UpdateObject;
                          inc(x,TSTDobj(objptr^).size.x+1);
                        end;
                    {
                      draw outline
                    }
                    with w^.canvas do
                      begin
                        dipt(2,46,w^.canvas.width-4,2,$40);
                      end;
                  end;
               {
                 release memory
               }
               if ct>0 then
                  for i:=0 to ct-1 do
                      dispose(items[i]);
             end;

   procedure TQuestionAppHandle;
             var m : TMessage;
                 d : ^TQuestionApp;
                 s : word;
                 t : string;
             begin
               m:=message;
               d:=process.DS_ptr;
               w:=process.DS_ptr;
               case m.mess of
                 PR_Init:
                   begin
                     With d^ do
                      begin
                        Parent:=TPR_Init(m.data^).parentID;
                        t     :=TPR_Init(m.data^).Param;
                        setfont(norm,0);
                        s:=80+lenstring(t)+15;
                        if s<355 then s:=355;
                        Create(s,130,24,3);
                        std.Title:=Tr('Are you sure ?');
                        PaintWindow;
                        CenterWindow;
                        {insert controls}
                        with d^.std.canvas do
                         begin
                           setfont(norm,mix(0,WinsBackColor,$D0));
                           drawstring(80,46,t);
                           drawstring(81,46,t);
                           drawstring(81,45,t);
                           setfont(norm,0);
                           drawstring(80,45,t);
                           for i:=1 to 7 do
                           dipt(2,std.canvas.height-31+i*2,std.canvas.width-4,2,$40);
                         end;
                        DrawIcon(20,35,'Warning');
                        s:=(std.canvas.width-3*85-2*5-70) div 2;
                        s:=s+70;
                        WinsObject(WI_Button,s,std.canvas.height-35,85,24,Tr('&Yes'));
                        WinsObject(WI_Button,s+90,std.canvas.height-35,85,24,Tr('&No'));
                        WinsObject(WI_Button,s+180,std.canvas.height-35,85,24,Tr('&Cancel'));
                        with d^.std.canvas do
                         colorize(10,22,70,height-5,$FFFF00,$40);
                        DrawAllObjectsInitial;
                      end;
                      ReShowWindow;
                      SwitchActive;
                   end;

                 WI_Char,
                 WI_OnPress,
                 WI_OnRelease,
                 WI_OverWindow,
                 WI_OffWindow:
                   begin
                     CheckObjects(m.mess);
                   end;

                 WI_KB_Enter,
                 WI_Object+0:
                   begin
                     Jump(WI_CloseApp);
                     SendMessage(process.id,d^.parent,WI_Yes,0,nil);
                   end;

                 WI_Object+1:
                   begin
                     Jump(WI_CloseApp);
                     SendMessage(process.id,d^.parent,WI_No,0,nil);
                   end;

                 WI_KB_Esc,
                 WI_Object+2,
                 WI_TB_Close:
                   begin
                     Jump(WI_CloseApp);
                     SendMessage(process.id,d^.parent,WI_Cancel,0,nil);
                   end;

                 WI_CloseAPP:
                   begin
                     CloseWindow;
                   end;

                 WI_Activate:
                   begin
                     MoveToFront;
                   end;

                 WI_TB_Title:
                   if w^.titlemode.apply then
                      begin
                        w^.canvas.height:=w^.titlemode.oldsize;
                        w^.titlebutt[1].icon:=TB_TitleIcon;
                        ReShowWindow;
                        w^.titlemode.apply:=false;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end else
                      begin
                        w^.titlemode.oldsize:=w^.canvas.height;
                        ReShowWindow;
                        w^.canvas.height:=22;
                        w^.titlebutt[1].icon:=TB_DeTitIcon;
                        w^.titlemode.apply:=true;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end;

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     d^.std.canvas.done;
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;
               end;
             end;

   procedure TErrorAppHandle;
             var m : TMessage;
                 d : ^TErrorApp;
                 s : integer;
                 t : string;
                 u : string;
             begin
               m:=message;
               d:=process.DS_ptr;
               w:=process.DS_ptr;
               case m.mess of
                 PR_Init:
                   begin
                     With d^ do
                      begin
                        Parent:=TPR_Init(m.data^).parentID;
                        t     :=TPR_Init(m.data^).Param;
                        if pos('|',t)=0
                           then u:=''
                           else begin
                                  u:=copy(t,pos('|',t)+1,255);
                                  t:=copy(t,1,pos('|',t)-1);
                                end;
                        s:=95;
                        setfont(norm,0);
                        if lenstring(t)>(10+lenstring(u))
                           then s:=s+lenstring(t)
                           else s:=s+10+lenstring(u);
                        if s<250 then s:=250;
                        Create(s,130,24,3);
                        std.Title:=Tr('Error');
                        PaintWindow;
                        CenterWindow;
                        {insert controls}
                        with d^.std.canvas do
                         begin
                           setfont(norm,mix(0,WinsBackColor,$D0));
                           drawstring(80,46,t);
                           drawstring(81,46,t);
                           drawstring(81,45,t);
                           drawstring(90,66,u);
                           drawstring(91,66,u);
                           drawstring(91,65,u);
                           setfont(norm,0);
                           drawstring(80,45,t);
                           drawstring(90,65,u);
                           for i:=1 to 7 do
                           dipt(2,std.canvas.height-31+i*2,std.canvas.width-4,2,$40);
                         end;
                        DrawIcon(20,35,'xSign');
                        s:=60+(std.canvas.width-85-60) div 2;
                        WinsObject(WI_Button,s,std.canvas.height-35,85,24,Tr('&Ok'));
                        with d^.std.canvas do
                         colorize(10,22,70,height-5,$FF0000,$20);
                        DrawAllObjectsInitial;
                      end;
                      ReShowWindow;
                      SwitchActive;
                   end;

                 WI_Char,
                 WI_OnPress,
                 WI_OnRelease,
                 WI_OverWindow,
                 WI_OffWindow:
                   begin
                     CheckObjects(m.mess);
                   end;

                 WI_KB_Enter,
                 WI_Object+0:
                   begin
                     Jump(WI_CloseApp);
                     SendMessage(process.id,d^.parent,WI_OK,0,nil);
                   end;

                 WI_KB_Esc,
                 WI_TB_Close:
                   begin
                     Jump(WI_CloseApp);
                     SendMessage(process.id,d^.parent,WI_Cancel,0,nil);
                   end;

                 WI_CloseAPP:
                   begin
                     CloseWindow;
                   end;

                 WI_Activate:
                   begin
                     MoveToFront;
                   end;

                 WI_TB_Title:
                   if w^.titlemode.apply then
                      begin
                        w^.canvas.height:=w^.titlemode.oldsize;
                        w^.titlebutt[1].icon:=TB_TitleIcon;
                        ReShowWindow;
                        w^.titlemode.apply:=false;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end else
                      begin
                        w^.titlemode.oldsize:=w^.canvas.height;
                        ReShowWindow;
                        w^.canvas.height:=22;
                        w^.titlebutt[1].icon:=TB_DeTitIcon;
                        w^.titlemode.apply:=true;
                        drawwindowtitle;
                        PaintWindowOutline;
                      end;

                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     d^.std.canvas.done;
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;
               end;
             end;


   procedure TMouseAppHandle;
             var m : TMessage;
                 d : ^TMouseApp;

             procedure SetSensitivity;
                       var x,y : integer;
                       begin
                         {
                           set mouse sensitivity
                         }
                         inifile:='settings\system.ini';
                         x:=readinivalue('mouse','sense.x');
                         y:=readinivalue('mouse','sense.y');
                         asm
                           mov ax,$001A
          	           mov bx,x
          	           mov cx,y
                           mov dx,64
                           int $33
                         end
                       end;

             begin
               m:=message;
               d:=process.DS_ptr;
               w:=process.DS_ptr;
               case m.mess of
                 PR_Init:
                   begin
                     With d^ do
                      begin
                        Create(32,32,32,0);
                        PlaceBmp(GuiDesktop.ThemeDir+'mouse_i.bmp');
                        PlaceAlp(GuiDesktop.ThemeDir+'mouse_a.bmp');
                        std.Title:='Mouse cursor (alpha chanell)';
                        std.position:=GuiDesktop.mousepos;
                        std.titlebuttcount:=0;
                        std.hastitle:=false;
                        std.status.hidden:=true;
                        std.status.ontop:=true;
                        SetSensitivity;
                      end;
                     Process.Flags:=Process.Flags or PROC_Multitask;
                     UpdateProcessData:=true;
                   end;

                 KE_Nothing:
                   begin
                     if (d^.std.position.x<>GuiDesktop.MousePos.x) or
                        (d^.std.position.y<>GuiDesktop.MousePos.y) then
                        With GuiDesktop.MousePos do MoveWindowTo(x,y);
                     if kerneldata.numofprocesses<>d^.oldpnum then
                        begin
                          MoveToTop;
                          d^.oldpnum:=kerneldata.numofprocesses
                        end;
                   end;

                 WI_newwindow:
                   begin
                     MoveToTop;
                     d^.oldpnum:=kerneldata.numofprocesses
                   end;

                 {CO_MS_ChangePos:
                   begin
                     with TCO_MS_ChangePos(m.data^).NewPosition do
                          MoveWindowTo(x,y);
                   end;
                 }
                 PR_Close,
                 PR_Hibernate,
                 PR_Kill:
                   begin
                     d^.std.canvas.done;
                     SendMessage( process.id,ToKernel,KE_StopProcess,0,nil);
                   end;
               end;
             end;

   procedure processscript(s:string);
             procedure RESETcomputer;
                       var reset:procedure;
                       begin
                         @reset:=ptr($FFFF,$0000);
                         reset;
                       end;
             procedure ATXOFF; {board: Intel Advanced/ML}
                       var i:byte;
                       begin
                         port[$0C]:=$2E;
                         port[$75]:=$2F;
                         port[$11]:=$2E;
                         port[$00]:=$2F;
                         port[$0D]:=$2E;
                         port[$A0]:=$2F;
                         i:=port[$75];
                       end;
             var i  : integer;
                 ct : integer;
                 oi : string;
                 st : string;
             begin
               if s=':exit:logout' then
                  begin
                    sendmessage(FromUnknown,ToGui,UP_Message+102,0,nil);
                    exit;
                  end;
               if s=':exit:closegui' then
                  begin
                    sendmessage(FromUnknown,ToGui,UP_Message+101,0,nil);
                    exit;
                  end;
               if s=':exit:reset' then
                  begin
                    RESETcomputer;
                    exit;
                  end;
               if s=':exit:shutdown' then
                  begin
                    {ATXoff;}
                    RunWinsApp('error',
                               Tr('Operation failed !')+'|'+
                                  'ATX shutdown');
                    exit;
                  end;
               if s=':exit:quit' then
                  begin
                    kerneldata.exiting:=true;
                    closegui;
                    exit;
                  end;
               if s='.afterlogin' then
                  begin
                    {
                      PUSH IniFile
                    }
                    oi:=inifile;
                    {
                      IniFile:=userpath\gui.ini
                    }
                    inifile:=API_GetDir('user')+'\gui.ini';
                    ct:=readinivalue('afterlogin','count');
                    if (ct>0) and
                       (inierror=iniOK) then
                       {
                         value readed, no error
                       }
                       for i:=1 to ct do
                           begin
                             st:=readinistring('afterlogin',
                                               integertostring(i));
                             if (st<>'') and
                                (inierror=iniOK) then
                                {
                                  value successfully readed
                                }
                                if pos(' ',st)=0 then
                                   runwinsapp(st,'') else
                                   runwinsapp(copy(st,1,pos(' ',st)-1),
                                              copy(st,pos(' ',st)+1,255));
                           end;
                    {
                      POP IniFile
                    }
                    inifile:=oi;
                    exit;
                  end;
             end;

   {$I src\color.pas}          {
                                 RGBtoCOLOR
                                 HSLtoCOLOR
                                 HSLtoRGB
                               }

   {$I src\app\submenu.pas}    { app:\\submenu           }

   {$I src\app\desktop.pas}    { app:\\desktop           }

   {$I src\app\login.pas}      { app:\\login             }

   {$I src\app\setres.pas}     { app:\\set:resolution    }


   Procedure RunWinsApp(appname,param:string);
             Var ProcessToRegister : TKE_StartProcess;
                 DataSize          : word;
                 Found             : boolean;
                 HandlePtr         : pointer;
             begin
               Found:=true;

               if appname='submenu' then
                  begin
                    DataSize:=sizeof(TSubMenuApp);
                    HandlePtr:=addr(TSubMenuAppHandle);
                  end else
               if appname='question' then
                  begin
                    DataSize:=sizeof(TQuestionApp);
                    HandlePtr:=addr(TQuestionAppHandle);
                  end else
               if appname='error' then
                  begin
                    DataSize:=sizeof(TErrorApp);
                    HandlePtr:=addr(TErrorAppHandle);
                  end else
               if appname='set:resolution' then
                  begin
                    DataSize:=sizeof(TSetResApp);
                    HandlePtr:=addr(TSetResAppHandle);
                  end else
               if appname='login' then
                  begin
                    DataSize:=sizeof(TLoginApp);
                    HandlePtr:=addr(TLoginAppHandle);
                  end else
               if appname='mouse' then
                  begin
                    DataSize:=sizeof(TMouseApp);
                    HandlePtr:=addr(TMouseAppHandle);
                  end else
               if appname='guishell' then
                  begin
                    DataSize:=sizeof(TGuiShellApp);
                    HandlePtr:=addr(TGuiShellAppHandle);
                  end else
               if appname='desktop' then
                  begin
                    DataSize:=sizeof(TDesktopApp);
                    HandlePtr:=addr(TDesktopAppHandle);
                  end else
               if appname='test' then
                  begin
                    DataSize:=sizeof(TTestApp);
                    HandlePtr:=addr(TTestAppHandle);
                  end else
                  found:=false;

               if found then
                  begin
                    ProcessToRegister.Param:=param;
                    With ProcessToRegister.Process do
                     begin
                       ID:=GetNewProcessID;
                       CS_Size:=0;
                       CS_Ptr:=nil;
                       DS_Size:=DataSize;
                       DS_Ptr:=nil;
                       Flags:=PROC_APPLICATION;
                       @Handle:=HandlePtr;
                       name:=appname;
                     end;
                    SendMessage( process.id, ToKernel,
                                 KE_StartProcess,
                                 sizeof(ProcessToRegister),
                                 addr(ProcessToRegister));
                  end else
                  begin
                    if copy(appname,1,1)='.' then processscript(appname);
                    if copy(appname,1,1)=':' then processscript(appname);
                  end;
             end;

 begin
   ColorNormal;
   loggedperson.loginpath:='_def\';
 end.


