{

  System 2001 v.6
  --------------------------------------------------------------------------
  (C) 1997-2001, Rozsnyo electronics and software


      WINS OBJECTS


  Programmed by:      Rozsnyo Daniel
  Copyright:          (C) 2001, Rozsnyo electronics and software

}
{$F+}

Unit WinsObj;

 Interface

   Uses    Types,Objects;


   Type    TListBoxDisplayProc = procedure( pos,
                                            size : Tpoint;
                                            s    : string;
                                            sel  : boolean );

           TSortFunction = function(s1,s2:string):boolean;

           TInputFilter  = procedure(var s:string);

           TCodePage     = array[#0..#255] of char;
           PCodePage     = ^TCodePage;

   Type    TListBox      = object
                             private

                              List        : TStringList;

                              Pos         : TPoint;
                              Size        : TPoint;
                              SeekPos     : TPoint;
                              SeekSize    : Tpoint;

                              SeekStart   : integer;
                              SeekLength  : integer;
                              inSeek      : boolean;
                              SeekSnap    : integer;

                              Message     : Word;

                              Offset      : Integer; { first disp item   }
                              Display     : Integer; { num of rows       }
                              DispSel     : Integer; { selected item pos }

                              Selection   : Integer; { selected item     }

                              P_Display   : TListBoxDisplayProc;
                              F_Sort      : TSortFunction;

                              InpFilter   : TInputFilter;

                              RowHeight   : integer;

                              Icon        : string;

                              CPtable     : PCodePage;

                              function    OnItem(id:integer):boolean;
                              procedure   ReshowLine(id:integer);

                              Procedure   ChangeSeek(start,len:integer);
                              procedure   ActualizeSeek;

                              Procedure   KeyUp;
                              Procedure   KeyDown;
                              Procedure   KeyHome;
                              Procedure   KeyEnd;

                             public

                              Count       : Integer; { munber of items   }

                              constructor Init;
                              destructor  Done;
                              Procedure   Handle(mess:word;md:pointer);

                              Procedure   SetPosition(x,y:integer);
                              Procedure   SetSize    (x,y:integer);

                              Procedure   Clear;
                              Procedure   Add(s:string);
                              Procedure   Insert(i:integer;s:string);
                              Function    Delete(i:integer):String;
                              Function    RemoveLast:string;

                              Procedure   Sort;

                              Procedure   SetDisplayProc(p:TListBoxDisplayProc);
                              Procedure   SetSortFunction(f:TSortFunction);
                              Procedure   SetMessage(m:Word);

                              Procedure   SetTreeDisplay(icofile:string);
                              Procedure   SetIconDisplay(icofile:string);

                              Procedure   Reselect(i:integer);
                              function    ItemIndex:integer;

                              Procedure   DrawAll;
                              Procedure   Event;

                              Procedure   InputFilter(p:TInputFilter);
                              Procedure   AddFromFile(fn:string);

                              Procedure   CodePage(cp:string);
                              Procedure   CPfilter(var s:string);

                              Function    GetLine(i:integer):string;

                           end;

 Implementation

   Uses SysCalls,API,Ini,convert,bmp,memimage,gui,WinsAPP,font16;


   Var  IconFile : string;


   procedure   IFnone(var s:string);
               begin
               end;


   Function    NormalSort(s1,s2:string):boolean;
               begin
                 NormalSort:=s1<s2;
               end;

   Procedure   TListBoxStandardDisplayProcedure( pos,
                                                 size : Tpoint;
                                                 s    : string;
                                                 sel  : boolean );
               begin
                 with w^.canvas do
                      begin
                        {
                          draw background bar
                        }
                        if sel then
                           begin
                             SetColor($000080);
                             Box(pos.x,pos.y+2,size.x,size.y-4);
                             SetColor(mix($000080,$FFFFFF,$B0));
                             Line(pos.x,         pos.y,
                                  pos.x+size.x-1,pos.y);
                             Line(pos.x,         pos.y+size.y-1,
                                  pos.x+size.x-1,pos.y+size.y-1);
                             SetColor(mix($000080,$FFFFFF,$60));
                             Line(pos.x,         pos.y+1,
                                  pos.x+size.x-1,pos.y+1);
                             Line(pos.x,         pos.y+size.y-2,
                                  pos.x+size.x-1,pos.y+size.y-2);
                           end else
                           begin
                             SetColor($FFFFFF);
                             Box(pos.x,pos.y,size.x,size.y);
                           end;

                        {
                          draw foreground text
                        }
                        if sel then SetFont(norm,$FFFFFF)
                               else SetFont(norm,$000000);
                        if s<>'' then
                        if system.pos(#255,s)= 0 then
                           DrawStringLen(pos.x+2,
                                         pos.y+size.y div 2-6,
                                         size.x-4,
                                         s) else
                           begin
                             DrawStringRight(pos.x+size.x-4,
                                             pos.y+size.y div 2-6,
                                             copy(s,
                                                  system.pos(#255,s)+1,
                                                  255));
                             s:=copy(s,1,system.pos(#255,s)-1);
                             DrawStringLen(pos.x+2,
                                             pos.y+size.y div 2-6,
                                             size.x-4,
                                             s);
                           end;
                      end;
               end;

   Procedure   TListBoxTreeDisplayProcedure( pos,
                                             size : Tpoint;
                                             s    : string;
                                             sel  : boolean );
               var xo : integer;
                   ic : integer;
                   i  : integer;
               begin
                 with w^.canvas do
                      begin

                        {
                          ic = icon count 0,1,2 ... n
                          xo = x offset
                        }
                        if s='' then ic:=0
                                else ic:=maxim(0,system.pos(#255,s)-1);
                        if ic=0 then xo:=0
                                else xo:=ic*size.y+3;

                        if ic>0 then
                           for i:=0 to ic-1 do
                               begin
                                 setcolor($FFFFFF);
                                 box(pos.x+i*size.y,
                                     pos.y,
                                     size.y,
                                     size.y);
                                 PlaceSign(iconfile,
                                           pos.x+i*size.y,
                                           pos.y,
                                           s[i+1]);
                               end;

                        if xo>0 then
                           begin
                             setcolor($FFFFFF);
                             box(pos.x+xo-3,
                                 pos.y,
                                 3,
                                 size.y);
                           end;
                        {
                          draw background bar
                        }
                        inc(pos.x,xo);
                        dec(size.x,xo);
                        if size.x<1 then exit;
                        if sel then
                           begin
                             SetColor($000080);
                             Box(pos.x,pos.y+2,size.x,size.y-4);
                             SetColor(mix($000080,$FFFFFF,$B0));
                             Line(pos.x,         pos.y,
                                  pos.x+size.x-1,pos.y);
                             Line(pos.x,         pos.y+size.y-1,
                                  pos.x+size.x-1,pos.y+size.y-1);
                             SetColor(mix($000080,$FFFFFF,$60));
                             Line(pos.x,         pos.y+1,
                                  pos.x+size.x-1,pos.y+1);
                             Line(pos.x,         pos.y+size.y-2,
                                  pos.x+size.x-1,pos.y+size.y-2);
                           end else
                           begin
                             SetColor($FFFFFF);
                             Box(pos.x,pos.y,size.x,size.y);
                           end;
                        dec(pos.x,xo);
                        inc(size.x,xo);

                        {
                          draw foreground text
                        }
                        if sel then SetFont(norm,$FFFFFF)
                               else SetFont(norm,$000000);
                        if ic>0 then s:=copy(s,ic+2,255);
                        if s<>'' then
                           begin
                             i:=system.pos(#255,s);
                             if i=0 then
                                DrawStringLen(pos.x+2+xo,
                                              pos.y+size.y div 2-6,
                                              size.x-4-xo,
                                              s) else
                                begin
                                  DrawString(pos.x+2+xo,
                                             pos.y+size.y div 2-6,
                                             copy(s,1,i-1));
                                  DrawStringRight(pos.x+size.x-2,
                                                  pos.y+size.y div 2-6,
                                                  copy(s,i+1,255));
                                end;
                           end;
                      end;
               end;

   Procedure   TListBoxIconDisplayProcedure( pos,
                                             size : Tpoint;
                                             s    : string;
                                             sel  : boolean );
               begin
                 with w^.canvas do
                      begin
                        {
                          draw background bar
                        }
                        if sel then
                           begin
                             SetColor($000080);
                             Box(pos.x,pos.y+2,size.x,size.y-4);
                             SetColor(mix($000080,$FFFFFF,$B0));
                             Line(pos.x,         pos.y,
                                  pos.x+size.x-1,pos.y);
                             Line(pos.x,         pos.y+size.y-1,
                                  pos.x+size.x-1,pos.y+size.y-1);
                             SetColor(mix($000080,$FFFFFF,$60));
                             Line(pos.x,         pos.y+1,
                                  pos.x+size.x-1,pos.y+1);
                             Line(pos.x,         pos.y+size.y-2,
                                  pos.x+size.x-1,pos.y+size.y-2);
                           end else
                           begin
                             SetColor($FFFFFF);
                             Box(pos.x,pos.y,size.x,size.y);
                           end;

                        {
                          draw foreground text
                        }
                        if sel then SetFont(norm,$FFFFFF)
                               else SetFont(norm,$000000);
                        if s<>'' then
                        DrawStringLen(pos.x+2+size.y,
                                      pos.y+size.y div 2-6,
                                      size.x-4-size.y,
                                      s);
                        if s<>'' then
                        PlaceStamp   (pos.x,
                                      pos.y,
                                      fonts.color,
                                      iconfile);
                      end;
               end;



   Constructor TListBox.Init;
               begin
                 SetDisplayProc(TListBoxStandardDisplayProcedure);
                 SetSortFunction(NormalSort);
                 InputFilter(IFnone);
                 List.Init;

                 message:=WI_ListBox;
                 CPtable:=nil;

                 Offset:=0;
                 Display:=1;
                 DispSel:=0;
                 Count:=0;
                 selection:=-1;

                 rowheight:=18;
                 SeekSize.x:=10;

                 seekstart:=0;
                 seeklength:=0;

                 inSeek:=false;

               end;

   Destructor  TListBox.Done;
               begin
                 list.done;
               end;

   Procedure   TListBox.Event;
               begin
                 Jump(message);
               end;

   Procedure   TListBox.ChangeSeek(start,len:integer);
               begin
                 {
                   clear old
                 }
                 preparecanvas;
                 with w^.canvas do
                 if seeklength > 0 then
                    begin
                      setcolor(winsbackcolor);
                      box(seekpos.x,seekpos.y+seekstart,seeksize.x,seeklength);
                    end;
                 {
                   actualize
                 }
                 seekstart:=start;
                 seeklength:=len;
                 {
                   draw new
                 }
                 with w^.canvas do
                 if len>0 then
                    begin
                      undipt(seekpos.x+0,seekpos.y+seekstart+0,
                             seeksize.x-0,seeklength-0,$C0);
                      undipt(seekpos.x+1,seekpos.y+seekstart+1,
                             seeksize.x-2,seeklength-2,$60);
                      undipt(seekpos.x+2,seekpos.y+seekstart+2,
                             seeksize.x-4,seeklength-4,$30);
                    end;
                 actualizecanvas;
               end;

   Procedure   TListBox.ActualizeSeek;
               var s : integer;
                   l : integer;
               begin
                 if count=0 then
                    begin
                      l:=seeksize.y;
                      s:=0;
                    end else
                    begin
                      l:=round(seeksize.y/count*display);
                      l:=minim(l,seeksize.y);
                      l:=maxim(l,seeksize.x div 4);
                      s:=round(seeksize.y/count*offset);
                      s:=minim(s,seeksize.y-l);
                    end;
                 if (l<>seeklength) or
                    (s<>seekstart) then ChangeSeek(s,l);
               end;

   Procedure   TListBox.ReshowLine(id:integer);
               var p,s : TPoint;
                   i   : integer;
               begin
                 if not (selection<count)
                    then begin
                           {
                             unselect
                           }
                           selection:=-1;
                           dispsel  := 0;
                         end;
                 {
                   is in displayable area ?
                 }
                 if (id<1) or
                    (id>display) then exit;
                 i:=offset+id-1;
                 iconfile:=icon;
                 if i<count then
                    begin
                      {
                        is item
                      }
                      List.seek(i);
                      p.x:=pos.x+3;
                      p.y:=pos.y+3+(id-1)*rowheight;
                      s.x:=size.x-10-SeekSize.x;
                      s.y:=rowheight;
                      P_Display(p,s,list.read,i=selection);
                      if i=selection then DispSel:=id;
                    end else
                    begin
                      {
                        is free space
                      }
                      p.x:=pos.x+3;
                      p.y:=pos.y+3+(id-1)*rowheight;
                      s.x:=size.x-10-SeekSize.x;
                      s.y:=rowheight;
                      P_Display(p,s,'',i=selection);
                      if i=selection then DispSel:=id;
                    end;
               end;

   Function    TListBox.OnItem(id:integer):boolean;
               begin
                 OnItem:=(id>=1) and
                         (id<=display) and
                         InBox( pos.x+3,
                                pos.y+3+(id-1)*rowheight,
                                size.x-10-SeekSize.x,
                                rowheight );
               end;

   Procedure   TListBox.Handle(mess:word;md:pointer);
               var i:integer;
               begin
                 {
                   items check
                 }
                 if not inSeek then
                 if (mess=WI_OverWindow) or
                    (mess=WI_OnPress) then
                    if w^.vmouse.lb then
                       for i:=1 to display do
                           if  i<>dispsel then
                           if OnItem(i) then
                              begin
                                selection:=offset+i-1;
                                if dispsel>0 then
                                   begin
                                     preparecanvas;
                                     ReshowLine(DispSel);
                                     actualizecanvas;
                                   end;
                                preparecanvas;
                                ReshowLine(i);
                                actualizecanvas;
                                event;
                                exit;
                              end;
                 {
                   scroll bar check
                 }
                 if (mess=WI_OnPress) then
                    if inbox(seekpos.x,seekpos.y,
                             seeksize.x,seeksize.y) then
                       begin
                         inSeek:=count>display;
                         seekSnap:=w^.vmouse.pos.y;
                       end;

                 if (mess=WI_OnRelease) then
                    if inSeek then
                    begin
                      inSeek:=false;
                      {
                        calculate new offset
                      }
                      i:=(longint(count)-display)*seekstart div (seeksize.y-seeklength);
                      if i<>offset then
                         begin
                           {
                             need change the offset
                           }
                           offset:=i;
                           preparecanvas;
                           for i:=1 to display do
                               reshowline(i);
                           actualizecanvas;
                           ActualizeSeek;
                         end;
                    end;

                 if ((mess=WI_OnPress) or
                     (mess=WI_OverWindow)) and
                    inSeek then
                    begin
                      i:=(w^.vmouse.pos.y-seekSnap)+seekstart;
                      seekSnap:=w^.vmouse.pos.y;
                      if i<0
                         then i:=0;
                      if i>(seeksize.y-seeklength)
                         then i:=seeksize.y-seeklength;
                      if i<>seekstart then
                         begin
                           {
                             changed
                           }
                           ChangeSeek(i,seeklength);
                         end;
                    end;
                 {
                   keypress....
                 }
                 if mess=WI_Char then
                    case (TWI_Char(md^).code+WI_Keycode) of
                      WI_KB_Down : KeyDown;
                      WI_KB_Up   : KeyUp;
                      WI_KB_Home : KeyHome;
                      WI_KB_End  : KeyEnd;
                    end;
               end;

   Procedure   TListBox.KeyUp;
               var i:integer;
               begin
                 if count<1 then exit;
                 if selection=-1 then
                    begin
                      selection:=count-1;
                      if offset<>(maxim(count-display,0)) then
                         begin
                           offset:=maxim(count-display,0);
                           preparecanvas;
                           for i:=1 to display do
                               reshowline(i);
                           actualizecanvas;
                           actualizeseek;
                         end else
                         begin
                           preparecanvas;
                           reshowline(selection-offset+1);
                           actualizecanvas;
                         end;
                    end else
                    if selection>0 then
                    begin
                      dec(selection);
                      if (selection-offset)<0 then
                         begin
                           dec(offset);
                           preparecanvas;
                           for i:=1 to display do
                               reshowline(i);
                           actualizecanvas;
                           actualizeseek;
                         end else
                         begin
                           preparecanvas;
                           reshowline(selection-offset+1);
                           reshowline(selection-offset+2);
                           actualizecanvas;
                         end;
                    end;
               end;

   Procedure   TListBox.KeyHome;
               var i:integer;
               begin
                 if count<1 then exit;
                 if (offset=0) and (selection=0) then exit;
                 offset:=0;
                 selection:=0;
                 ActualizeSeek;
                 preparecanvas;
                 for i:=1 to display do ReshowLine(i);
                 actualizecanvas;
               end;

   Procedure   TListBox.KeyEnd;
               var i:integer;
               begin
                 if count<1 then exit;
                 if selection=(count-1) then exit;
                 offset:=maxim(count-display,0);
                 selection:=count-1;
                 ActualizeSeek;
                 preparecanvas;
                 for i:=1 to display do ReshowLine(i);
                 actualizecanvas;
               end;

   Procedure   TListBox.KeyDown;
               var i:integer;
               begin
                 if count<1 then exit;
                 if selection=-1 then
                    begin
                      selection:=0;
                      if offset<>0 then
                         begin
                           offset:=0;
                           preparecanvas;
                           for i:=1 to display do
                               reshowline(i);
                           actualizecanvas;
                           actualizeseek;
                         end else
                         begin
                           preparecanvas;
                           reshowline(1);
                           actualizecanvas;
                         end;
                    end else
                    if (selection+1)<count then
                    begin
                      inc(selection);
                      if (selection-offset+1)>Display then
                         begin
                           inc(offset);
                           preparecanvas;
                           for i:=1 to display do
                               reshowline(i);
                           actualizecanvas;
                           actualizeseek;
                         end else
                         begin
                           preparecanvas;
                           reshowline(selection-offset);
                           reshowline(selection-offset+1);
                           actualizecanvas;
                         end;
                    end;
               end;

   Procedure   TListBox.SetPosition(x,y:integer);
               begin
                 pos.x:=x;
                 pos.y:=y;
               end;

   Procedure   TListBox.SetSize    (x,y:integer);
               begin
                 size.x:=x;
                 size.y:=y;
                 display:=(y-6) div RowHeight;
               end;

   Procedure   TListBox.Clear;
               var i: integer;
               begin
                 list.clear;
                 count:=0;
                 offset:=0;
                 ActualizeSeek;
                 preparecanvas;
                 for i:=1 to display do ReshowLine(i);
                 actualizecanvas;
               end;

   Function    TListBox.RemoveLast:string;
               begin
                 removeLast:=delete(count-1);
               end;

   Procedure   TListBox.Add(s:string);
               begin
                 list.add(s);
                 inc(count);
                 preparecanvas;
                 reshowline(count-offset);
                 actualizecanvas;
                 actualizeseek;
               end;

   Function    TListBox.Delete(i:integer):string;
               begin
                 delete:='';
                 if (i<0) or
                    (i>=count)
                    then exit;
                 if i>offset
                    then if offset>0 then dec(offset);
                 list.seek(i);
                 Delete:=list.read;
                 list.delete;
                 dec(count);
                 ActualizeSeek;
                 preparecanvas;
                 for i:=1 to display do ReshowLine(i);
                 actualizecanvas;
               end;

   Procedure   TListBox.Insert(i:integer;s:string);
               begin
               end;

   Procedure   TListBox.Sort;
               begin
               end;

   Procedure   TListBox.SetDisplayProc(p:TListBoxDisplayProc);
               begin
                 p_display:=p;
               end;

   Procedure   TListBox.SetSortFunction(f:TSortFunction);
               begin
                 f_sort:=f;
               end;

   Procedure   TListBox.SetMessage(m:Word);
               begin
                 message:=m;
               end;

   Procedure   TListBox.SetTreeDisplay(icofile:string);
               begin;
                 if icofile=''
                    then SetDisplayProc(TListBoxStandardDisplayProcedure)
                    else SetDisplayProc(TListBoxTreeDisplayProcedure);
                 rowheight:=maxim(12,
                                  stringtointeger(copy(icofile,
                                                       length(icofile)-1,
                                                       2)));
                 with size do setsize(x,y);
                 icon:=icofile;
               end;

   Procedure   TListBox.SetIconDisplay(icofile:string);
               begin
                 rowheight:=18;
                 with size do setsize(x,y);
                 if icofile=''
                    then SetDisplayProc(TListBoxStandardDisplayProcedure)
                    else SetDisplayProc(TListBoxIconDisplayProcedure);
                 icon:=icofile;
               end;

   Procedure   TListBox.Reselect(i:integer);
               begin
                 Selection:=i;
               end;

   Function    TListBox.ItemIndex:integer;
               begin
                 ItemIndex:=Selection;
               end;

   Procedure   TListBox.DrawAll;
               var i:integer;
               begin
                 with w^.canvas do
                  begin

                    {preparecanvas;}
                    DipT(pos.x,pos.y,size.x,size.y,$80);
                    SetColor($FFFFFF);
                    Box(pos.x+2,pos.y+2,size.x-7-SeekSize.x,size.y-4);

                    seekpos.x:=pos.x+size.x-SeekSize.x-3;
                    seekpos.y:=pos.y+3;
                    seeksize.y:=size.y-6;

                    seeklength:=0;
                    seekstart:=0;

                    DipT(seekpos.x-1,seekpos.y-1,
                         seeksize.x+2,seeksize.y+2,$40);

                    {actualizecanvas;}

                    ActualizeSeek;

                    for i:=1 to display do ReshowLine(i);

                  end;
               end;

   Procedure   TListBox.AddFromFile(fn:string);
               var f : text;
                   l : string;
               begin
                 CutSpaces(fn);
                 if fn='' then exit;
                 assign(f,fn);
                 {$I-}
                 reset(f);
                 {$I+}
                 if ioresult<>0 then exit;
                 while not eof(f) do
                       begin
                         readln(f,l);
                         self.CPfilter(l);
                         self.InpFilter(l);
                         if l<>'' then self.add(l);
                       end;
                 close(f);
               end;

   Procedure   TListBox.InputFilter(p:TInputFilter);
               begin
                 InpFilter:=p;
               end;

   Procedure   TListBox.CPfilter(var s:string);
               var i:byte;
               begin
                 if (CPtable<>nil) and
                    (s[0]<>#0)     then
                    begin
                      i:=ord(s[0]);
                      repeat
                        s[i]:=CPtable^[s[i]];
                        dec(i);
                      until i=0;
                    end;
               end;

   Procedure   TListBox.CodePage(cp:string);
               procedure makeCP;
                         var c:char;
                         begin
                           if CPtable=nil then new(CPtable);
                           for c:=#0 to #255 do CPtable^[c]:=c;
                         end;
               begin
                 if CPtable<>nil then dispose(CPtable);
                 CPtable:=nil;
                 if cp='CP852' then
                    begin
                      makeCP;
                      {

                         Translation table from MSDOS encoding to
                         internal codepage.

                               CP852  internal
                               V      V
                      }
                      cptable^[#$85]:=#$96; { uO }
                      cptable^[#$E6]:=#$9B; { S< }
                      cptable^[#$E7]:=#$A8; { s< }
                      cptable^[#$AC]:=#$80; { C< }
                      cptable^[#$9F]:=#$87; { c< }
                      cptable^[#$FC]:=#$9E; { R< }
                      cptable^[#$FD]:=#$A9; { r< }
                      cptable^[#$D5]:=#$A5; { N< }
                      cptable^[#$E5]:=#$A4; { n< }
                      cptable^[#$ED]:=#$9D; { Y' }
                      cptable^[#$EC]:=#$98; { y' }
                    end;
               end;

   Function    TListBox.GetLine(i:integer):string;
               begin
                 if i>=count then
                    begin
                      getline:='';
                    end else
                    begin
                      list.seek(i);
                      getline:=list.read;
                    end;
               end;

 Begin
 end.
